/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.48.0-dev-20240314(69991d66135e4a1fc1cf0b1ac4ad25d429866a0d)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var J=["require","exports","vs/editor/common/core/range","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/base/common/arrays","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/nls","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/base/common/cache","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/map","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Z=function(B){for(var n=[],r=0,x=B.length;r<x;r++)n[r]=J[B[r]];return n};const Re=this,Ae=typeof global=="object"?global:{};var ue;(function(B){B.global=Re;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof B.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}B.Environment=n})(ue||(ue={}));var ue;(function(B){class n{constructor(c,m,v){this.type=c,this.detail=m,this.timestamp=v}}B.LoaderEvent=n;class r{constructor(c){this._events=[new n(1,"",c)]}record(c,m){this._events.push(new n(c,m,B.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}B.LoaderEventRecorder=r;class x{record(c,m){}getEvents(){return[]}}x.INSTANCE=new x,B.NullLoaderEventRecorder=x})(ue||(ue={}));var ue;(function(B){class n{static fileUriToFilePath(x,A){if(A=decodeURI(A).replace(/%23/g,"#"),x){if(/^file:\/\/\//.test(A))return A.substr(8);if(/^file:\/\//.test(A))return A.substr(5)}else if(/^file:\/\//.test(A))return A.substr(7);return A}static startsWith(x,A){return x.length>=A.length&&x.substr(0,A.length)===A}static endsWith(x,A){return x.length>=A.length&&x.substr(x.length-A.length)===A}static containsQueryString(x){return/^[^\#]*\?/gi.test(x)}static isAbsolutePath(x){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(x)}static forEachProperty(x,A){if(x){let c;for(c in x)x.hasOwnProperty(c)&&A(c,x[c])}}static isEmpty(x){let A=!0;return n.forEachProperty(x,()=>{A=!1}),A}static recursiveClone(x){if(!x||typeof x!="object"||x instanceof RegExp||!Array.isArray(x)&&Object.getPrototypeOf(x)!==Object.prototype)return x;let A=Array.isArray(x)?[]:{};return n.forEachProperty(x,(c,m)=>{m&&typeof m=="object"?A[c]=n.recursiveClone(m):A[c]=m}),A}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(x){return n.startsWith(x,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=B.global.performance&&typeof B.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?B.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,B.Utilities=n})(ue||(ue={}));var ue;(function(B){function n(A){if(A instanceof Error)return A;const c=new Error(A.message||String(A)||"Unknown Error");return A.stack&&(c.stack=A.stack),c}B.ensureError=n;class r{static validateConfigurationOptions(c){function m(v){if(v.phase==="loading"){console.error('Loading "'+v.moduleId+'" failed'),console.error(v),console.error("Here are the modules that depend on it:"),console.error(v.neededBy);return}if(v.phase==="factory"){console.error('The factory function of "'+v.moduleId+'" has thrown an exception'),console.error(v),console.error("Here are the modules that depend on it:"),console.error(v.neededBy);return}}if(c=c||{},typeof c.baseUrl!="string"&&(c.baseUrl=""),typeof c.isBuild!="boolean"&&(c.isBuild=!1),typeof c.paths!="object"&&(c.paths={}),typeof c.config!="object"&&(c.config={}),typeof c.catchError>"u"&&(c.catchError=!1),typeof c.recordStats>"u"&&(c.recordStats=!1),typeof c.urlArgs!="string"&&(c.urlArgs=""),typeof c.onError!="function"&&(c.onError=m),Array.isArray(c.ignoreDuplicateModules)||(c.ignoreDuplicateModules=[]),c.baseUrl.length>0&&(B.Utilities.endsWith(c.baseUrl,"/")||(c.baseUrl+="/")),typeof c.cspNonce!="string"&&(c.cspNonce=""),typeof c.preferScriptTags>"u"&&(c.preferScriptTags=!1),c.nodeCachedData&&typeof c.nodeCachedData=="object"&&(typeof c.nodeCachedData.seed!="string"&&(c.nodeCachedData.seed="seed"),(typeof c.nodeCachedData.writeDelay!="number"||c.nodeCachedData.writeDelay<0)&&(c.nodeCachedData.writeDelay=1e3*7),!c.nodeCachedData.path||typeof c.nodeCachedData.path!="string")){const v=n(new Error("INVALID cached data configuration, 'path' MUST be set"));v.phase="configuration",c.onError(v),c.nodeCachedData=void 0}return c}static mergeConfigurationOptions(c=null,m=null){let v=B.Utilities.recursiveClone(m||{});return B.Utilities.forEachProperty(c,(h,l)=>{h==="ignoreDuplicateModules"&&typeof v.ignoreDuplicateModules<"u"?v.ignoreDuplicateModules=v.ignoreDuplicateModules.concat(l):h==="paths"&&typeof v.paths<"u"?B.Utilities.forEachProperty(l,(L,e)=>v.paths[L]=e):h==="config"&&typeof v.config<"u"?B.Utilities.forEachProperty(l,(L,e)=>v.config[L]=e):v[h]=B.Utilities.recursiveClone(l)}),r.validateConfigurationOptions(v)}}B.ConfigurationOptionsUtil=r;class x{constructor(c,m){if(this._env=c,this.options=r.mergeConfigurationOptions(m),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let v=this.options.nodeRequire.main.filename,h=Math.max(v.lastIndexOf("/"),v.lastIndexOf("\\"));this.options.baseUrl=v.substring(0,h+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let c=0;c<this.options.ignoreDuplicateModules.length;c++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[c]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],B.Utilities.forEachProperty(this.options.paths,(c,m)=>{Array.isArray(m)?this.sortedPathsRules.push({from:c,to:m}):this.sortedPathsRules.push({from:c,to:[m]})}),this.sortedPathsRules.sort((c,m)=>m.from.length-c.from.length)}cloneAndMerge(c){return new x(this._env,r.mergeConfigurationOptions(c,this.options))}getOptionsLiteral(){return this.options}_applyPaths(c){let m;for(let v=0,h=this.sortedPathsRules.length;v<h;v++)if(m=this.sortedPathsRules[v],B.Utilities.startsWith(c,m.from)){let l=[];for(let L=0,e=m.to.length;L<e;L++)l.push(m.to[L]+c.substr(m.from.length));return l}return[c]}_addUrlArgsToUrl(c){return B.Utilities.containsQueryString(c)?c+"&"+this.options.urlArgs:c+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(c){return this.options.urlArgs?this._addUrlArgsToUrl(c):c}_addUrlArgsIfNecessaryToUrls(c){if(this.options.urlArgs)for(let m=0,v=c.length;m<v;m++)c[m]=this._addUrlArgsToUrl(c[m]);return c}moduleIdToPaths(c){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(c))return this.isBuild()?["empty:"]:["node|"+c];let m=c,v;if(!B.Utilities.endsWith(m,".js")&&!B.Utilities.isAbsolutePath(m)){v=this._applyPaths(m);for(let h=0,l=v.length;h<l;h++)this.isBuild()&&v[h]==="empty:"||(B.Utilities.isAbsolutePath(v[h])||(v[h]=this.options.baseUrl+v[h]),!B.Utilities.endsWith(v[h],".js")&&!B.Utilities.containsQueryString(v[h])&&(v[h]=v[h]+".js"))}else!B.Utilities.endsWith(m,".js")&&!B.Utilities.containsQueryString(m)&&(m=m+".js"),v=[m];return this._addUrlArgsIfNecessaryToUrls(v)}requireToUrl(c){let m=c;return B.Utilities.isAbsolutePath(m)||(m=this._applyPaths(m)[0],B.Utilities.isAbsolutePath(m)||(m=this.options.baseUrl+m)),this._addUrlArgsIfNecessaryToUrl(m)}isBuild(){return this.options.isBuild}shouldInvokeFactory(c){return!!(!this.options.isBuild||B.Utilities.isAnonymousModule(c)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[c])}isDuplicateMessageIgnoredFor(c){return this.ignoreDuplicateModulesMap.hasOwnProperty(c)}getConfigForModule(c){if(this.options.config)return this.options.config[c]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(c){this.options.onError(c)}}B.Configuration=x})(ue||(ue={}));var ue;(function(B){class n{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,L,e,s){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new A;else if(this._env.isElectronRenderer){const{preferScriptTags:u}=l.getConfig().getOptionsLiteral();u?this._scriptLoader=new r:this._scriptLoader=new c(this._env)}else this._env.isNode?this._scriptLoader=new c(this._env):this._scriptLoader=new r;let o={callback:e,errorback:s};if(this._callbackMap.hasOwnProperty(L)){this._callbackMap[L].push(o);return}this._callbackMap[L]=[o],this._scriptLoader.load(l,L,()=>this.triggerCallback(L),u=>this.triggerErrorback(L,u))}triggerCallback(l){let L=this._callbackMap[l];delete this._callbackMap[l];for(let e=0;e<L.length;e++)L[e].callback()}triggerErrorback(l,L){let e=this._callbackMap[l];delete this._callbackMap[l];for(let s=0;s<e.length;s++)e[s].errorback(L)}}class r{attachListeners(l,L,e){let s=()=>{l.removeEventListener("load",o),l.removeEventListener("error",u)},o=g=>{s(),L()},u=g=>{s(),e(g)};l.addEventListener("load",o),l.addEventListener("error",u)}load(l,L,e,s){if(/^node\|/.test(L)){let o=l.getConfig().getOptionsLiteral(),u=m(l.getRecorder(),o.nodeRequire||B.global.nodeRequire),g=L.split("|"),f=null;try{f=u(g[1])}catch(E){s(E);return}l.enqueueDefineAnonymousModule([],()=>f),e()}else{let o=document.createElement("script");o.setAttribute("async","async"),o.setAttribute("type","text/javascript"),this.attachListeners(o,e,s);const{trustedTypesPolicy:u}=l.getConfig().getOptionsLiteral();u&&(L=u.createScriptURL(L)),o.setAttribute("src",L);const{cspNonce:g}=l.getConfig().getOptionsLiteral();g&&o.setAttribute("nonce",g),document.getElementsByTagName("head")[0].appendChild(o)}}}function x(h){const{trustedTypesPolicy:l}=h.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class A{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=x(l)),this._cachedCanUseEval}load(l,L,e,s){if(/^node\|/.test(L)){const o=l.getConfig().getOptionsLiteral(),u=m(l.getRecorder(),o.nodeRequire||B.global.nodeRequire),g=L.split("|");let f=null;try{f=u(g[1])}catch(E){s(E);return}l.enqueueDefineAnonymousModule([],function(){return f}),e()}else{const{trustedTypesPolicy:o}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(L)&&L.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(L).then(g=>{if(g.status!==200)throw new Error(g.statusText);return g.text()}).then(g=>{g=`${g}
//# sourceURL=${L}`,(o?self.eval(o.createScript("",g)):new Function(g)).call(self),e()}).then(void 0,s);return}try{o&&(L=o.createScriptURL(L)),importScripts(L),e()}catch(g){s(g)}}}}class c{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,L){const{nodeCachedData:e}=L.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const s=this,o=l("module");function u(g){const f=g.constructor;let E=function(N){try{return g.require(N)}finally{}};return E.resolve=function(N,S){return f._resolveFilename(N,g,!1,S)},E.resolve.paths=function(N){return f._resolveLookupPaths(N,g)},E.main=process.mainModule,E.extensions=f._extensions,E.cache=f._cache,E}o.prototype._compile=function(g,f){const E=o.wrap(g.replace(/^#!.*/,"")),_=L.getRecorder(),N=s._getCachedDataPath(e,f),S={filename:f};let C;try{const R=s._fs.readFileSync(N);C=R.slice(0,16),S.cachedData=R.slice(16),_.record(60,N)}catch{_.record(61,N)}const i=new s._vm.Script(E,S),a=i.runInThisContext(S),d=s._path.dirname(f),p=u(this),b=[this.exports,p,this,f,d,process,Ae,Buffer],w=a.apply(this.exports,b);return s._handleCachedData(i,E,N,!S.cachedData,L),s._verifyCachedData(i,E,N,C,L),w}}load(l,L,e,s){const o=l.getConfig().getOptionsLiteral(),u=m(l.getRecorder(),o.nodeRequire||B.global.nodeRequire),g=o.nodeInstrumenter||function(E){return E};this._init(u),this._initNodeRequire(u,l);let f=l.getRecorder();if(/^node\|/.test(L)){let E=L.split("|"),_=null;try{_=u(E[1])}catch(N){s(N);return}l.enqueueDefineAnonymousModule([],()=>_),e()}else{L=B.Utilities.fileUriToFilePath(this._env.isWindows,L);const E=this._path.normalize(L),_=this._getElectronRendererScriptPathOrUri(E),N=!!o.nodeCachedData,S=N?this._getCachedDataPath(o.nodeCachedData,L):void 0;this._readSourceAndCachedData(E,S,f,(C,i,a,d)=>{if(C){s(C);return}let p;i.charCodeAt(0)===c._BOM?p=c._PREFIX+i.substring(1)+c._SUFFIX:p=c._PREFIX+i+c._SUFFIX,p=g(p,E);const b={filename:_,cachedData:a},w=this._createAndEvalScript(l,p,b,e,s);this._handleCachedData(w,p,S,N&&!a,l),this._verifyCachedData(w,p,S,d,l)})}}_createAndEvalScript(l,L,e,s,o){const u=l.getRecorder();u.record(31,e.filename);const g=new this._vm.Script(L,e),f=g.runInThisContext(e),E=l.getGlobalAMDDefineFunc();let _=!1;const N=function(){return _=!0,E.apply(null,arguments)};return N.amd=E.amd,f.call(B.global,l.getGlobalAMDRequireFunc(),N,e.filename,this._path.dirname(e.filename)),u.record(32,e.filename),_?s():o(new Error(`Didn't receive define call in ${e.filename}!`)),g}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let L=l.match(/^([a-z])\:(.*)/i);return L?`file:///${(L[1].toUpperCase()+":"+L[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,L){const e=this._crypto.createHash("md5").update(L,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),s=this._path.basename(L).replace(/\.js$/,"");return this._path.join(l.path,`${s}-${e}.code`)}_handleCachedData(l,L,e,s,o){l.cachedDataRejected?this._fs.unlink(e,u=>{o.getRecorder().record(62,e),this._createAndWriteCachedData(l,L,e,o),u&&o.getConfig().onError(u)}):s&&this._createAndWriteCachedData(l,L,e,o)}_createAndWriteCachedData(l,L,e,s){let o=Math.ceil(s.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),u=-1,g=0,f;const E=()=>{setTimeout(()=>{f||(f=this._crypto.createHash("md5").update(L,"utf8").digest());const _=l.createCachedData();if(!(_.length===0||_.length===u||g>=5)){if(_.length<u){E();return}u=_.length,this._fs.writeFile(e,Buffer.concat([f,_]),N=>{N&&s.getConfig().onError(N),s.getRecorder().record(63,e),E()})}},o*Math.pow(4,g++))};E()}_readSourceAndCachedData(l,L,e,s){if(!L)this._fs.readFile(l,{encoding:"utf8"},s);else{let o,u,g,f=2;const E=_=>{_?s(_):--f===0&&s(void 0,o,u,g)};this._fs.readFile(l,{encoding:"utf8"},(_,N)=>{o=N,E(_)}),this._fs.readFile(L,(_,N)=>{!_&&N&&N.length>0?(g=N.slice(0,16),u=N.slice(16),e.record(60,L)):e.record(61,L),E()})}}_verifyCachedData(l,L,e,s,o){s&&(l.cachedDataRejected||setTimeout(()=>{const u=this._crypto.createHash("md5").update(L,"utf8").digest();s.equals(u)||(o.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,g=>{g&&o.getConfig().onError(g)}))},Math.ceil(5e3*(1+Math.random()))))}}c._BOM=65279,c._PREFIX="(function (require, define, __filename, __dirname) { ",c._SUFFIX=`
});`;function m(h,l){if(l.__$__isRecorded)return l;const L=function(s){h.record(33,s);try{return l(s)}finally{h.record(34,s)}};return L.__$__isRecorded=!0,L}B.ensureRecordedNodeRequire=m;function v(h){return new n(h)}B.createScriptLoader=v})(ue||(ue={}));var ue;(function(B){class n{constructor(h){let l=h.lastIndexOf("/");l!==-1?this.fromModulePath=h.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(h){let l=h,L;for(L=/\/\.\//;L.test(l);)l=l.replace(L,"/");for(l=l.replace(/^\.\//g,""),L=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;L.test(l);)l=l.replace(L,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(h){let l=h;return B.Utilities.isAbsolutePath(l)||(B.Utilities.startsWith(l,"./")||B.Utilities.startsWith(l,"../"))&&(l=n._normalizeModuleId(this.fromModulePath+l)),l}}n.ROOT=new n(""),B.ModuleIdResolver=n;class r{constructor(h,l,L,e,s,o){this.id=h,this.strId=l,this.dependencies=L,this._callback=e,this._errorback=s,this.moduleIdResolver=o,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(h,l){try{return{returnedValue:h.apply(B.global,l),producedError:null}}catch(L){return{returnedValue:null,producedError:L}}}static _invokeFactory(h,l,L,e){return h.shouldInvokeFactory(l)?h.shouldCatchError()?this._safeInvokeFunction(L,e):{returnedValue:L.apply(B.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(h,l,L,e){this._isComplete=!0;let s=null;if(this._callback)if(typeof this._callback=="function"){h.record(21,this.strId);let o=r._invokeFactory(l,this.strId,this._callback,L);s=o.producedError,h.record(22,this.strId),!s&&typeof o.returnedValue<"u"&&(!this.exportsPassedIn||B.Utilities.isEmpty(this.exports))&&(this.exports=o.returnedValue)}else this.exports=this._callback;if(s){let o=B.ensureError(s);o.phase="factory",o.moduleId=this.strId,o.neededBy=e(this.id),this.error=o,l.onError(o)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(h){return this._isComplete=!0,this.error=h,this._errorback?(this._errorback(h),!0):!1}isComplete(){return this._isComplete}}B.Module=r;class x{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(h){let l=this._strModuleIdToIntModuleId.get(h);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(h,l),this._intModuleIdToStrModuleId[l]=h),l}getStrModuleId(h){return this._intModuleIdToStrModuleId[h]}}class A{constructor(h){this.id=h}}A.EXPORTS=new A(0),A.MODULE=new A(1),A.REQUIRE=new A(2),B.RegularDependency=A;class c{constructor(h,l,L){this.id=h,this.pluginId=l,this.pluginParam=L}}B.PluginDependency=c;class m{constructor(h,l,L,e,s=0){this._env=h,this._scriptLoader=l,this._loaderAvailableTimestamp=s,this._defineFunc=L,this._requireFunc=e,this._moduleIdProvider=new x,this._config=new B.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new m(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(h,l){let L=o=>o.replace(/\\/g,"/"),e=L(h),s=l.split(/\n/);for(let o=0;o<s.length;o++){let u=s[o].match(/(.*):(\d+):(\d+)\)?$/);if(u){let g=u[1],f=u[2],E=u[3],_=Math.max(g.lastIndexOf(" ")+1,g.lastIndexOf("(")+1);if(g=g.substr(_),g=L(g),g===e){let N={line:parseInt(f,10),col:parseInt(E,10)};return N.line===1&&(N.col-=53),N}}}throw new Error("Could not correlate define call site for needle "+h)}getBuildInfo(){if(!this._config.isBuild())return null;let h=[],l=0;for(let L=0,e=this._modules2.length;L<e;L++){let s=this._modules2[L];if(!s)continue;let o=this._buildInfoPath[s.id]||null,u=this._buildInfoDefineStack[s.id]||null,g=this._buildInfoDependencies[s.id];h[l++]={id:s.strId,path:o,defineLocation:o&&u?m._findRelevantLocationInStack(o,u):null,dependencies:g,shim:null,exports:s.exports}}return h}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new B.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=B.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(h,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let L=null;this._config.isBuild()&&(L=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:L,dependencies:h,callback:l}}defineModule(h,l,L,e,s,o=new n(h)){let u=this._moduleIdProvider.getModuleId(h);if(this._modules2[u]){this._config.isDuplicateMessageIgnoredFor(h)||console.warn("Duplicate definition of module '"+h+"'");return}let g=new r(u,h,this._normalizeDependencies(l,o),L,e,o);this._modules2[u]=g,this._config.isBuild()&&(this._buildInfoDefineStack[u]=s,this._buildInfoDependencies[u]=(g.dependencies||[]).map(f=>this._moduleIdProvider.getStrModuleId(f.id))),this._resolve(g)}_normalizeDependency(h,l){if(h==="exports")return A.EXPORTS;if(h==="module")return A.MODULE;if(h==="require")return A.REQUIRE;let L=h.indexOf("!");if(L>=0){let e=l.resolveModule(h.substr(0,L)),s=l.resolveModule(h.substr(L+1)),o=this._moduleIdProvider.getModuleId(e+"!"+s),u=this._moduleIdProvider.getModuleId(e);return new c(o,u,s)}return new A(this._moduleIdProvider.getModuleId(l.resolveModule(h)))}_normalizeDependencies(h,l){let L=[],e=0;for(let s=0,o=h.length;s<o;s++)L[e++]=this._normalizeDependency(h[s],l);return L}_relativeRequire(h,l,L,e){if(typeof l=="string")return this.synchronousRequire(l,h);this.defineModule(B.Utilities.generateAnonymousModule(),l,L,e,null,h)}synchronousRequire(h,l=new n(h)){let L=this._normalizeDependency(h,l),e=this._modules2[L.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+h+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+h+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(h,l){let L=this._config.shouldRecordStats();l?this._config=new B.Configuration(this._env,h):this._config=this._config.cloneAndMerge(h),this._config.shouldRecordStats()&&!L&&(this._recorder=null)}getConfig(){return this._config}_onLoad(h){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(h),l.dependencies,l.callback,null,l.stack)}}_createLoadError(h,l){let L=this._moduleIdProvider.getStrModuleId(h),e=(this._inverseDependencies2[h]||[]).map(o=>this._moduleIdProvider.getStrModuleId(o));const s=B.ensureError(l);return s.phase="loading",s.moduleId=L,s.neededBy=e,s}_onLoadError(h,l){const L=this._createLoadError(h,l);this._modules2[h]||(this._modules2[h]=new r(h,this._moduleIdProvider.getStrModuleId(h),[],()=>{},null,null));let e=[];for(let u=0,g=this._moduleIdProvider.getMaxModuleId();u<g;u++)e[u]=!1;let s=!1,o=[];for(o.push(h),e[h]=!0;o.length>0;){let u=o.shift(),g=this._modules2[u];g&&(s=g.onDependencyError(L)||s);let f=this._inverseDependencies2[u];if(f)for(let E=0,_=f.length;E<_;E++){let N=f[E];e[N]||(o.push(N),e[N]=!0)}}s||this._config.onError(L)}_hasDependencyPath(h,l){let L=this._modules2[h];if(!L)return!1;let e=[];for(let o=0,u=this._moduleIdProvider.getMaxModuleId();o<u;o++)e[o]=!1;let s=[];for(s.push(L),e[h]=!0;s.length>0;){let u=s.shift().dependencies;if(u)for(let g=0,f=u.length;g<f;g++){let E=u[g];if(E.id===l)return!0;let _=this._modules2[E.id];_&&!e[E.id]&&(e[E.id]=!0,s.push(_))}}return!1}_findCyclePath(h,l,L){if(h===l||L===50)return[h];let e=this._modules2[h];if(!e)return null;let s=e.dependencies;if(s)for(let o=0,u=s.length;o<u;o++){let g=this._findCyclePath(s[o].id,l,L+1);if(g!==null)return g.push(h),g}return null}_createRequire(h){let l=(L,e,s)=>this._relativeRequire(h,L,e,s);return l.toUrl=L=>this._config.requireToUrl(h.resolveModule(L)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(L,e=!1)=>{this.configure(L,e)},l.__$__nodeRequire=B.global.nodeRequire,l}_loadModule(h){if(this._modules2[h]||this._knownModules2[h])return;this._knownModules2[h]=!0;let l=this._moduleIdProvider.getStrModuleId(h),L=this._config.moduleIdToPaths(l),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||e.test(l))&&L.push("node|"+l);let s=-1,o=u=>{if(s++,s>=L.length)this._onLoadError(h,u);else{let g=L[s],f=this.getRecorder();if(this._config.isBuild()&&g==="empty:"){this._buildInfoPath[h]=g,this.defineModule(this._moduleIdProvider.getStrModuleId(h),[],null,null,null),this._onLoad(h);return}f.record(10,g),this._scriptLoader.load(this,g,()=>{this._config.isBuild()&&(this._buildInfoPath[h]=g),f.record(11,g),this._onLoad(h)},E=>{f.record(12,g),o(E)})}};o(null)}_loadPluginDependency(h,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let L=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],e,null,null)};L.error=e=>{this._config.onError(this._createLoadError(l.id,e))},h.load(l.pluginParam,this._createRequire(n.ROOT),L,this._config.getOptionsLiteral())}_resolve(h){let l=h.dependencies;if(l)for(let L=0,e=l.length;L<e;L++){let s=l[L];if(s===A.EXPORTS){h.exportsPassedIn=!0,h.unresolvedDependenciesCount--;continue}if(s===A.MODULE){h.unresolvedDependenciesCount--;continue}if(s===A.REQUIRE){h.unresolvedDependenciesCount--;continue}let o=this._modules2[s.id];if(o&&o.isComplete()){if(o.error){h.onDependencyError(o.error);return}h.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(s.id,h.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(s.id)+"' and '"+this._moduleIdProvider.getStrModuleId(h.id)+"'. The cyclic path follows:");let u=this._findCyclePath(s.id,h.id,0)||[];u.reverse(),u.push(s.id),console.warn(u.map(g=>this._moduleIdProvider.getStrModuleId(g)).join(` => 
`)),h.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[s.id]=this._inverseDependencies2[s.id]||[],this._inverseDependencies2[s.id].push(h.id),s instanceof c){let u=this._modules2[s.pluginId];if(u&&u.isComplete()){this._loadPluginDependency(u.exports,s);continue}let g=this._inversePluginDependencies2.get(s.pluginId);g||(g=[],this._inversePluginDependencies2.set(s.pluginId,g)),g.push(s),this._loadModule(s.pluginId);continue}this._loadModule(s.id)}h.unresolvedDependenciesCount===0&&this._onModuleComplete(h)}_onModuleComplete(h){let l=this.getRecorder();if(h.isComplete())return;let L=h.dependencies,e=[];if(L)for(let g=0,f=L.length;g<f;g++){let E=L[g];if(E===A.EXPORTS){e[g]=h.exports;continue}if(E===A.MODULE){e[g]={id:h.strId,config:()=>this._config.getConfigForModule(h.strId)};continue}if(E===A.REQUIRE){e[g]=this._createRequire(h.moduleIdResolver);continue}let _=this._modules2[E.id];if(_){e[g]=_.exports;continue}e[g]=null}const s=g=>(this._inverseDependencies2[g]||[]).map(f=>this._moduleIdProvider.getStrModuleId(f));h.complete(l,this._config,e,s);let o=this._inverseDependencies2[h.id];if(this._inverseDependencies2[h.id]=null,o)for(let g=0,f=o.length;g<f;g++){let E=o[g],_=this._modules2[E];_.unresolvedDependenciesCount--,_.unresolvedDependenciesCount===0&&this._onModuleComplete(_)}let u=this._inversePluginDependencies2.get(h.id);if(u){this._inversePluginDependencies2.delete(h.id);for(let g=0,f=u.length;g<f;g++)this._loadPluginDependency(h.exports,u[g])}}}B.ModuleManager=m})(ue||(ue={}));var Y,ue;(function(B){const n=new B.Environment;let r=null;const x=function(v,h,l){typeof v!="string"&&(l=h,h=v,v=null),(typeof h!="object"||!Array.isArray(h))&&(l=h,h=null),h||(h=["require","exports","module"]),v?r.defineModule(v,h,l,null,null):r.enqueueDefineAnonymousModule(h,l)};x.amd={jQuery:!0};const A=function(v,h=!1){r.configure(v,h)},c=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){A(arguments[0]);return}if(typeof arguments[0]=="string")return r.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){r.defineModule(B.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};c.config=A,c.getConfig=function(){return r.getConfig().getOptionsLiteral()},c.reset=function(){r=r.reset()},c.getBuildInfo=function(){return r.getBuildInfo()},c.getStats=function(){return r.getLoaderEvents()},c.define=x;function m(){if(typeof B.global.require<"u"||typeof require<"u"){const v=B.global.require||require;if(typeof v=="function"&&typeof v.resolve=="function"){const h=B.ensureRecordedNodeRequire(r.getRecorder(),v);B.global.nodeRequire=h,c.nodeRequire=h,c.__$__nodeRequire=h}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=c:(n.isElectronRenderer||(B.global.define=x),B.global.require=c)}B.init=m,(typeof B.global.define!="function"||!B.global.define.amd)&&(r=new B.ModuleManager(n,B.createScriptLoader(n),x,c,B.Utilities.getHighPerformanceTimestamp()),typeof B.global.require<"u"&&typeof B.global.require!="function"&&c.config(B.global.require),Y=function(){return x.apply(null,arguments)},Y.amd=x.amd,typeof doNotInitLoader>"u"&&m())})(ue||(ue={})),Y(J[19],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.localize=L,n.localize2=e,n.getConfiguredDefaultLocale=s,n.setPseudoTranslation=o,n.create=u,n.load=g;let r=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const x="i-default";function A(f,E){let _;return E.length===0?_=f:_=f.replace(/\{(\d+)\}/g,(N,S)=>{const C=S[0],i=E[C];let a=N;return typeof i=="string"?a=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(a=String(i)),a}),r&&(_="\uFF3B"+_.replace(/[aouei]/g,"$&$&")+"\uFF3D"),_}function c(f,E){let _=f[E];return _||(_=f["*"],_)?_:null}function m(f){return f.charAt(f.length-1)==="/"?f:f+"/"}async function v(f,E,_){const N=m(f)+m(E)+"vscode/"+m(_),S=await fetch(N);if(S.ok)return await S.json();throw new Error(`${S.status} - ${S.statusText}`)}function h(f){return function(E,_){const N=Array.prototype.slice.call(arguments,2);return A(f[E],N)}}function l(f){return(E,_,...N)=>({value:A(f[E],N),original:A(_,N)})}function L(f,E,..._){return A(E,_)}function e(f,E,..._){const N=A(E,_);return{value:N,original:N}}function s(f){}function o(f){r=f}function u(f,E){var _;return{localize:h(E[f]),localize2:l(E[f]),getConfiguredDefaultLocale:(_=E.getConfiguredDefaultLocale)!==null&&_!==void 0?_:N=>{}}}function g(f,E,_,N){var S;const C=(S=N["vs/nls"])!==null&&S!==void 0?S:{};if(!f||f.length===0)return _({localize:L,localize2:e,getConfiguredDefaultLocale:()=>{var b;return(b=C.availableLanguages)===null||b===void 0?void 0:b["*"]}});const i=C.availableLanguages?c(C.availableLanguages,f):null,a=i===null||i===x;let d=".nls";a||(d=d+"."+i);const p=b=>{Array.isArray(b)?(b.localize=h(b),b.localize2=l(b)):(b.localize=h(b[f]),b.localize2=l(b[f])),b.getConfiguredDefaultLocale=()=>{var w;return(w=C.availableLanguages)===null||w===void 0?void 0:w["*"]},_(b)};typeof C.loadBundle=="function"?C.loadBundle(f,i,(b,w)=>{b?E([f+".nls"],p):p(w)}):C.translationServiceUrl&&!a?(async()=>{var b;try{const w=await v(C.translationServiceUrl,i,f);return p(w)}catch(w){if(!i.includes("-"))return console.error(w),E([f+".nls"],p);try{const R=i.split("-")[0],y=await v(C.translationServiceUrl,R,f);return(b=C.availableLanguages)!==null&&b!==void 0||(C.availableLanguages={}),C.availableLanguages["*"]=R,p(y)}catch(R){return console.error(R),E([f+".nls"],p)}}})():E([f+d],p,b=>{if(d===".nls"){console.error("Failed trying to load default language strings",b);return}console.error(`Failed to load message bundle for language ${i}. Falling back to the default language:`,b),E([f+".nls"],p)})}}),function(){const B=globalThis.MonacoEnvironment,n=B&&B.baseUrl?B.baseUrl:"../../../";function r(L,e){var s;if(B?.createTrustedTypesPolicy)try{return B.createTrustedTypesPolicy(L,e)}catch(o){console.warn(o);return}try{return(s=self.trustedTypes)===null||s===void 0?void 0:s.createPolicy(L,e)}catch(o){console.warn(o);return}}const x=r("amdLoader",{createScriptURL:L=>L,createScript:(L,...e)=>{const s=e.slice(0,-1).join(","),o=e.pop().toString();return`(function anonymous(${s}) { ${o}
})`}});function A(){try{return(x?globalThis.eval(x.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function c(){return new Promise((L,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return L();const s=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(s)&&s.substring(0,globalThis.origin.length)!==globalThis.origin)&&A()){fetch(s).then(u=>{if(u.status!==200)throw new Error(u.statusText);return u.text()}).then(u=>{u=`${u}
//# sourceURL=${s}`,(x?globalThis.eval(x.createScript("",u)):new Function(u)).call(globalThis),L()}).then(void 0,e);return}x?importScripts(x.createScriptURL(s)):importScripts(s),L()})}function m(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:x,amdModulesPattern:/^vs\//})}function v(L){c().then(()=>{m(),require([L],function(e){setTimeout(function(){const s=e.create((o,u)=>{globalThis.postMessage(o,u)},null);for(globalThis.onmessage=o=>s.onmessage(o.data,o.ports);l.length>0;){const o=l.shift();s.onmessage(o.data,o.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&m();let h=!0;const l=[];globalThis.onmessage=L=>{if(!h){l.push(L);return}h=!1,v(L.data)}}(),Y(J[7],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Permutation=n.CallbackIterable=n.ArrayQueue=n.booleanComparator=n.numberComparator=n.CompareResult=void 0,n.tail=r,n.tail2=x,n.equals=A,n.removeFastWithoutKeepingOrder=c,n.binarySearch=m,n.binarySearch2=v,n.quickSelect=h,n.groupBy=l,n.groupAdjacentBy=L,n.forEachAdjacent=e,n.forEachWithNeighbors=s,n.coalesce=o,n.coalesceInPlace=u,n.isFalsyOrEmpty=g,n.isNonEmptyArray=f,n.distinct=E,n.firstOrDefault=_,n.range=N,n.arrayInsert=S,n.pushToStart=C,n.pushToEnd=i,n.pushMany=a,n.asArray=d,n.insertInto=p,n.splice=b,n.compareBy=y,n.tieBreakComparators=M,n.reverseOrder=k;function r(F,I=0){return F[F.length-(1+I)]}function x(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}function A(F,I,W=(V,z)=>V===z){if(F===I)return!0;if(!F||!I||F.length!==I.length)return!1;for(let V=0,z=F.length;V<z;V++)if(!W(F[V],I[V]))return!1;return!0}function c(F,I){const W=F.length-1;I<W&&(F[I]=F[W]),F.pop()}function m(F,I,W){return v(F.length,V=>W(F[V],I))}function v(F,I){let W=0,V=F-1;for(;W<=V;){const z=(W+V)/2|0,U=I(z);if(U<0)W=z+1;else if(U>0)V=z-1;else return z}return-(W+1)}function h(F,I,W){if(F=F|0,F>=I.length)throw new TypeError("invalid index");const V=I[Math.floor(I.length*Math.random())],z=[],U=[],se=[];for(const he of I){const t=W(he,V);t<0?z.push(he):t>0?U.push(he):se.push(he)}return F<z.length?h(F,z,W):F<z.length+se.length?se[0]:h(F-(z.length+se.length),U,W)}function l(F,I){const W=[];let V;for(const z of F.slice(0).sort(I))!V||I(V[0],z)!==0?(V=[z],W.push(V)):V.push(z);return W}function*L(F,I){let W,V;for(const z of F)V!==void 0&&I(V,z)?W.push(z):(W&&(yield W),W=[z]),V=z;W&&(yield W)}function e(F,I){for(let W=0;W<=F.length;W++)I(W===0?void 0:F[W-1],W===F.length?void 0:F[W])}function s(F,I){for(let W=0;W<F.length;W++)I(W===0?void 0:F[W-1],F[W],W+1===F.length?void 0:F[W+1])}function o(F){return F.filter(I=>!!I)}function u(F){let I=0;for(let W=0;W<F.length;W++)F[W]&&(F[I]=F[W],I+=1);F.length=I}function g(F){return!Array.isArray(F)||F.length===0}function f(F){return Array.isArray(F)&&F.length>0}function E(F,I=W=>W){const W=new Set;return F.filter(V=>{const z=I(V);return W.has(z)?!1:(W.add(z),!0)})}function _(F,I){return F.length>0?F[0]:I}function N(F,I){let W=typeof I=="number"?F:0;typeof I=="number"?W=F:(W=0,I=F);const V=[];if(W<=I)for(let z=W;z<I;z++)V.push(z);else for(let z=W;z>I;z--)V.push(z);return V}function S(F,I,W){const V=F.slice(0,I),z=F.slice(I);return V.concat(W,z)}function C(F,I){const W=F.indexOf(I);W>-1&&(F.splice(W,1),F.unshift(I))}function i(F,I){const W=F.indexOf(I);W>-1&&(F.splice(W,1),F.push(I))}function a(F,I){for(const W of I)F.push(W)}function d(F){return Array.isArray(F)?F:[F]}function p(F,I,W){const V=w(F,I),z=F.length,U=W.length;F.length=z+U;for(let se=z-1;se>=V;se--)F[se+U]=F[se];for(let se=0;se<U;se++)F[se+V]=W[se]}function b(F,I,W,V){const z=w(F,I);let U=F.splice(z,W);return U===void 0&&(U=[]),p(F,z,V),U}function w(F,I){return I<0?Math.max(I+F.length,0):Math.min(I,F.length)}var R;(function(F){function I(U){return U<0}F.isLessThan=I;function W(U){return U<=0}F.isLessThanOrEqual=W;function V(U){return U>0}F.isGreaterThan=V;function z(U){return U===0}F.isNeitherLessOrGreaterThan=z,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(R||(n.CompareResult=R={}));function y(F,I){return(W,V)=>I(F(W),F(V))}function M(...F){return(I,W)=>{for(const V of F){const z=V(I,W);if(!R.isNeitherLessOrGreaterThan(z))return z}return R.neitherLessOrGreaterThan}}const D=(F,I)=>F-I;n.numberComparator=D;const T=(F,I)=>(0,n.numberComparator)(F?1:0,I?1:0);n.booleanComparator=T;function k(F){return(I,W)=>-F(I,W)}class q{constructor(I){this.items=I,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(I){let W=this.firstIdx;for(;W<this.items.length&&I(this.items[W]);)W++;const V=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,V}takeFromEndWhile(I){let W=this.lastIdx;for(;W>=0&&I(this.items[W]);)W--;const V=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,V}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const I=this.items[this.firstIdx];return this.firstIdx++,I}takeCount(I){const W=this.items.slice(this.firstIdx,this.firstIdx+I);return this.firstIdx+=I,W}}n.ArrayQueue=q;class H{constructor(I){this.iterate=I}toArray(){const I=[];return this.iterate(W=>(I.push(W),!0)),I}filter(I){return new H(W=>this.iterate(V=>I(V)?W(V):!0))}map(I){return new H(W=>this.iterate(V=>W(I(V))))}findLast(I){let W;return this.iterate(V=>(I(V)&&(W=V),!0)),W}findLastMaxBy(I){let W,V=!0;return this.iterate(z=>((V||R.isGreaterThan(I(z,W)))&&(V=!1,W=z),!0)),W}}n.CallbackIterable=H,H.empty=new H(F=>{});class G{constructor(I){this._indexMap=I}static createSortPermutation(I,W){const V=Array.from(I.keys()).sort((z,U)=>W(I[z],I[U]));return new G(V)}apply(I){return I.map((W,V)=>I[this._indexMap[V]])}inverse(){const I=this._indexMap.slice();for(let W=0;W<this._indexMap.length;W++)I[this._indexMap[W]]=W;return new G(I)}}n.Permutation=G}),Y(J[11],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MonotonousArray=void 0,n.findLast=r,n.findLastIdx=x,n.findLastMonotonous=A,n.findLastIdxMonotonous=c,n.findFirstMonotonous=m,n.findFirstIdxMonotonousOrArrLen=v,n.findFirstMaxBy=l,n.findLastMaxBy=L,n.findFirstMinBy=e,n.findMaxIdxBy=s,n.mapFindFirst=o;function r(u,g,f){const E=x(u,g);if(E!==-1)return u[E]}function x(u,g,f=u.length-1){for(let E=f;E>=0;E--){const _=u[E];if(g(_))return E}return-1}function A(u,g){const f=c(u,g);return f===-1?void 0:u[f]}function c(u,g,f=0,E=u.length){let _=f,N=E;for(;_<N;){const S=Math.floor((_+N)/2);g(u[S])?_=S+1:N=S}return _-1}function m(u,g){const f=v(u,g);return f===u.length?void 0:u[f]}function v(u,g,f=0,E=u.length){let _=f,N=E;for(;_<N;){const S=Math.floor((_+N)/2);g(u[S])?N=S:_=S+1}return _}class h{constructor(g){this._array=g,this._findLastMonotonousLastIdx=0}findLastMonotonous(g){if(h.assertInvariants){if(this._prevFindLastPredicate){for(const E of this._array)if(this._prevFindLastPredicate(E)&&!g(E))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=g}const f=c(this._array,g,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=f+1,f===-1?void 0:this._array[f]}}n.MonotonousArray=h,h.assertInvariants=!1;function l(u,g){if(u.length===0)return;let f=u[0];for(let E=1;E<u.length;E++){const _=u[E];g(_,f)>0&&(f=_)}return f}function L(u,g){if(u.length===0)return;let f=u[0];for(let E=1;E<u.length;E++){const _=u[E];g(_,f)>=0&&(f=_)}return f}function e(u,g){return l(u,(f,E)=>-g(f,E))}function s(u,g){if(u.length===0)return-1;let f=0;for(let E=1;E<u.length;E++){const _=u[E];g(_,u[f])>0&&(f=E)}return f}function o(u,g){for(const f of u){const E=g(f);if(E!==void 0)return E}}}),Y(J[33],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class r{constructor(c){this.fn=c,this.lastCache=void 0,this.lastArgKey=void 0}get(c){const m=JSON.stringify(c);return this.lastArgKey!==m&&(this.lastArgKey=m,this.lastCache=this.fn(c)),this.lastCache}}n.LRUCachedFunction=r;class x{get cachedValues(){return this._map}constructor(c){this.fn=c,this._map=new Map}get(c){if(this._map.has(c))return this._map.get(c);const m=this.fn(c);return this._map.set(c,m),m}}n.CachedFunction=x}),Y(J[34],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function r(v,h){const l=Math.pow(10,h);return Math.round(v*l)/l}class x{constructor(h,l,L,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,L))|0,this.a=r(Math.max(Math.min(1,e),0),3)}static equals(h,l){return h.r===l.r&&h.g===l.g&&h.b===l.b&&h.a===l.a}}n.RGBA=x;class A{constructor(h,l,L,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=r(Math.max(Math.min(1,l),0),3),this.l=r(Math.max(Math.min(1,L),0),3),this.a=r(Math.max(Math.min(1,e),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.l===l.l&&h.a===l.a}static fromRGBA(h){const l=h.r/255,L=h.g/255,e=h.b/255,s=h.a,o=Math.max(l,L,e),u=Math.min(l,L,e);let g=0,f=0;const E=(u+o)/2,_=o-u;if(_>0){switch(f=Math.min(E<=.5?_/(2*E):_/(2-2*E),1),o){case l:g=(L-e)/_+(L<e?6:0);break;case L:g=(e-l)/_+2;break;case e:g=(l-L)/_+4;break}g*=60,g=Math.round(g)}return new A(g,f,E,s)}static _hue2rgb(h,l,L){return L<0&&(L+=1),L>1&&(L-=1),L<1/6?h+(l-h)*6*L:L<1/2?l:L<2/3?h+(l-h)*(2/3-L)*6:h}static toRGBA(h){const l=h.h/360,{s:L,l:e,a:s}=h;let o,u,g;if(L===0)o=u=g=e;else{const f=e<.5?e*(1+L):e+L-e*L,E=2*e-f;o=A._hue2rgb(E,f,l+1/3),u=A._hue2rgb(E,f,l),g=A._hue2rgb(E,f,l-1/3)}return new x(Math.round(o*255),Math.round(u*255),Math.round(g*255),s)}}n.HSLA=A;class c{constructor(h,l,L,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=r(Math.max(Math.min(1,l),0),3),this.v=r(Math.max(Math.min(1,L),0),3),this.a=r(Math.max(Math.min(1,e),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.v===l.v&&h.a===l.a}static fromRGBA(h){const l=h.r/255,L=h.g/255,e=h.b/255,s=Math.max(l,L,e),o=Math.min(l,L,e),u=s-o,g=s===0?0:u/s;let f;return u===0?f=0:s===l?f=((L-e)/u%6+6)%6:s===L?f=(e-l)/u+2:f=(l-L)/u+4,new c(Math.round(f*60),g,s,h.a)}static toRGBA(h){const{h:l,s:L,v:e,a:s}=h,o=e*L,u=o*(1-Math.abs(l/60%2-1)),g=e-o;let[f,E,_]=[0,0,0];return l<60?(f=o,E=u):l<120?(f=u,E=o):l<180?(E=o,_=u):l<240?(E=u,_=o):l<300?(f=u,_=o):l<=360&&(f=o,_=u),f=Math.round((f+g)*255),E=Math.round((E+g)*255),_=Math.round((_+g)*255),new x(f,E,_,s)}}n.HSVA=c;class m{static fromHex(h){return m.Format.CSS.parseHex(h)||m.red}static equals(h,l){return!h&&!l?!0:!h||!l?!1:h.equals(l)}get hsla(){return this._hsla?this._hsla:A.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:c.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof x)this.rgba=h;else if(h instanceof A)this._hsla=h,this.rgba=A.toRGBA(h);else if(h instanceof c)this._hsva=h,this.rgba=c.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&x.equals(this.rgba,h.rgba)&&A.equals(this.hsla,h.hsla)&&c.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=m._relativeLuminanceForComponent(this.rgba.r),l=m._relativeLuminanceForComponent(this.rgba.g),L=m._relativeLuminanceForComponent(this.rgba.b),e=.2126*h+.7152*l+.0722*L;return r(e,4)}static _relativeLuminanceForComponent(h){const l=h/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const l=this.getRelativeLuminance(),L=h.getRelativeLuminance();return l>L}isDarkerThan(h){const l=this.getRelativeLuminance(),L=h.getRelativeLuminance();return l<L}lighten(h){return new m(new A(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new m(new A(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:l,g:L,b:e,a:s}=this.rgba;return new m(new x(l,L,e,s*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new m(new x(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:l,g:L,b:e,a:s}=this.rgba;return new m(new x(h.rgba.r-s*(h.rgba.r-l),h.rgba.g-s*(h.rgba.g-L),h.rgba.b-s*(h.rgba.b-e),1))}toString(){return this._toString||(this._toString=m.Format.CSS.format(this)),this._toString}static getLighterColor(h,l,L){if(h.isLighterThan(l))return h;L=L||.5;const e=h.getRelativeLuminance(),s=l.getRelativeLuminance();return L=L*(s-e)/s,h.lighten(L)}static getDarkerColor(h,l,L){if(h.isDarkerThan(l))return h;L=L||.5;const e=h.getRelativeLuminance(),s=l.getRelativeLuminance();return L=L*(e-s)/e,h.darken(L)}}n.Color=m,m.white=new m(new x(255,255,255,1)),m.black=new m(new x(0,0,0,1)),m.red=new m(new x(255,0,0,1)),m.blue=new m(new x(0,0,255,1)),m.green=new m(new x(0,255,0,1)),m.cyan=new m(new x(0,255,255,1)),m.lightgrey=new m(new x(211,211,211,1)),m.transparent=new m(new x(0,0,0,0)),function(v){let h;(function(l){let L;(function(e){function s(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:v.Format.CSS.formatRGBA(i)}e.formatRGB=s;function o(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}e.formatRGBA=o;function u(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:v.Format.CSS.formatHSLA(i)}e.formatHSL=u;function g(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}e.formatHSLA=g;function f(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function E(i){return`#${f(i.rgba.r)}${f(i.rgba.g)}${f(i.rgba.b)}`}e.formatHex=E;function _(i,a=!1){return a&&i.rgba.a===1?v.Format.CSS.formatHex(i):`#${f(i.rgba.r)}${f(i.rgba.g)}${f(i.rgba.b)}${f(Math.round(i.rgba.a*255))}`}e.formatHexA=_;function N(i){return i.isOpaque()?v.Format.CSS.formatHex(i):v.Format.CSS.formatRGBA(i)}e.format=N;function S(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const d=16*C(i.charCodeAt(1))+C(i.charCodeAt(2)),p=16*C(i.charCodeAt(3))+C(i.charCodeAt(4)),b=16*C(i.charCodeAt(5))+C(i.charCodeAt(6));return new v(new x(d,p,b,1))}if(a===9){const d=16*C(i.charCodeAt(1))+C(i.charCodeAt(2)),p=16*C(i.charCodeAt(3))+C(i.charCodeAt(4)),b=16*C(i.charCodeAt(5))+C(i.charCodeAt(6)),w=16*C(i.charCodeAt(7))+C(i.charCodeAt(8));return new v(new x(d,p,b,w/255))}if(a===4){const d=C(i.charCodeAt(1)),p=C(i.charCodeAt(2)),b=C(i.charCodeAt(3));return new v(new x(16*d+d,16*p+p,16*b+b))}if(a===5){const d=C(i.charCodeAt(1)),p=C(i.charCodeAt(2)),b=C(i.charCodeAt(3)),w=C(i.charCodeAt(4));return new v(new x(16*d+d,16*p+p,16*b+b,(16*w+w)/255))}return null}e.parseHex=S;function C(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(L=l.CSS||(l.CSS={}))})(h=v.Format||(v.Format={}))}(m||(n.Color=m={}))}),Y(J[35],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class r{constructor(A,c,m,v){this.originalStart=A,this.originalLength=c,this.modifiedStart=m,this.modifiedLength=v}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=r}),Y(J[5],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.CancellationError=n.errorHandler=n.ErrorHandler=void 0,n.onUnexpectedError=x,n.onUnexpectedExternalError=A,n.transformErrorForSerialization=c,n.isCancellationError=v,n.canceled=l,n.illegalArgument=L,n.illegalState=e;class r{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(f){setTimeout(()=>{throw f.stack?o.isErrorNoTelemetry(f)?new o(f.message+`

`+f.stack):new Error(f.message+`

`+f.stack):f},0)}}emit(f){this.listeners.forEach(E=>{E(f)})}onUnexpectedError(f){this.unexpectedErrorHandler(f),this.emit(f)}onUnexpectedExternalError(f){this.unexpectedErrorHandler(f)}}n.ErrorHandler=r,n.errorHandler=new r;function x(g){v(g)||n.errorHandler.onUnexpectedError(g)}function A(g){v(g)||n.errorHandler.onUnexpectedExternalError(g)}function c(g){if(g instanceof Error){const{name:f,message:E}=g,_=g.stacktrace||g.stack;return{$isError:!0,name:f,message:E,stack:_,noTelemetry:o.isErrorNoTelemetry(g)}}return g}const m="Canceled";function v(g){return g instanceof h?!0:g instanceof Error&&g.name===m&&g.message===m}class h extends Error{constructor(){super(m),this.name=this.message}}n.CancellationError=h;function l(){const g=new Error(m);return g.name=g.message,g}function L(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}function e(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}class s extends Error{constructor(f){super("NotSupported"),f&&(this.message=f)}}n.NotSupportedError=s;class o extends Error{constructor(f){super(f),this.name="CodeExpectedError"}static fromError(f){if(f instanceof o)return f;const E=new o;return E.message=f.message,E.stack=f.stack,E}static isErrorNoTelemetry(f){return f.name==="CodeExpectedError"}}n.ErrorNoTelemetry=o;class u extends Error{constructor(f){super(f||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}n.BugIndicatingError=u}),Y(J[12],Z([0,1,5]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ok=x,n.assertNever=A,n.softAssert=c,n.assertFn=m,n.checkAdjacentItems=v;function x(h,l){if(!h)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}function A(h,l="Unreachable"){throw new Error(l)}function c(h){h||(0,r.onUnexpectedError)(new r.BugIndicatingError("Soft Assertion Failed"))}function m(h){if(!h()){debugger;h(),(0,r.onUnexpectedError)(new r.BugIndicatingError("Assertion Failed"))}}function v(h,l){let L=0;for(;L<h.length-1;){const e=h[L],s=h[L+1];if(!l(e,s))return!1;L++}return!0}}),Y(J[20],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createSingleCallFunction=r;function r(x,A){const c=this;let m=!1,v;return function(){if(m)return v;if(m=!0,A)try{v=x.apply(c,arguments)}finally{A()}else v=x.apply(c,arguments);return v}}}),Y(J[21],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var r;(function(x){function A(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}x.is=A;const c=Object.freeze([]);function m(){return c}x.empty=m;function*v(i){yield i}x.single=v;function h(i){return A(i)?i:v(i)}x.wrap=h;function l(i){return i||c}x.from=l;function*L(i){for(let a=i.length-1;a>=0;a--)yield i[a]}x.reverse=L;function e(i){return!i||i[Symbol.iterator]().next().done===!0}x.isEmpty=e;function s(i){return i[Symbol.iterator]().next().value}x.first=s;function o(i,a){for(const d of i)if(a(d))return!0;return!1}x.some=o;function u(i,a){for(const d of i)if(a(d))return d}x.find=u;function*g(i,a){for(const d of i)a(d)&&(yield d)}x.filter=g;function*f(i,a){let d=0;for(const p of i)yield a(p,d++)}x.map=f;function*E(...i){for(const a of i)yield*a}x.concat=E;function _(i,a,d){let p=d;for(const b of i)p=a(p,b);return p}x.reduce=_;function*N(i,a,d=i.length){for(a<0&&(a+=i.length),d<0?d+=i.length:d>i.length&&(d=i.length);a<d;a++)yield i[a]}x.slice=N;function S(i,a=Number.POSITIVE_INFINITY){const d=[];if(a===0)return[d,i];const p=i[Symbol.iterator]();for(let b=0;b<a;b++){const w=p.next();if(w.done)return[d,x.empty()];d.push(w.value)}return[d,{[Symbol.iterator](){return p}}]}x.consume=S;async function C(i){const a=[];for await(const d of i)a.push(d);return Promise.resolve(a)}x.asyncToArray=C})(r||(n.Iterable=r={}))}),Y(J[36],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0,n.KeyChord=L;class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,o){this._keyCodeToStr[s]=o,this._strToKeyCode[o.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const x=new r,A=new r,c=new r;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const m=[],v=Object.create(null),h=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],o=[],u=[];for(const g of s){const[f,E,_,N,S,C,i,a,d]=g;if(u[E]||(u[E]=!0,m[E]=_,v[_]=E,h[_.toLowerCase()]=E,f&&(n.IMMUTABLE_CODE_TO_KEY_CODE[E]=N,N!==0&&N!==3&&N!==5&&N!==4&&N!==6&&N!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[N]=E))),!o[N]){if(o[N]=!0,!S)throw new Error(`String representation missing for key code ${N} around scan code ${_}`);x.define(N,S),A.define(N,a||S),c.define(N,d||a||S)}C&&(n.EVENT_KEY_CODE_MAP[C]=N),i&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[i]=N)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var l;(function(e){function s(_){return x.keyCodeToStr(_)}e.toString=s;function o(_){return x.strToKeyCode(_)}e.fromString=o;function u(_){return A.keyCodeToStr(_)}e.toUserSettingsUS=u;function g(_){return c.keyCodeToStr(_)}e.toUserSettingsGeneral=g;function f(_){return A.strToKeyCode(_)||c.strToKeyCode(_)}e.fromUserSettings=f;function E(_){if(_>=98&&_<=113)return null;switch(_){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return x.keyCodeToStr(_)}e.toElectronAccelerator=E})(l||(n.KeyCodeUtils=l={}));function L(e,s){const o=(s&65535)<<16>>>0;return(e|o)>>>0}}),Y(J[37],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class r{constructor(A){this.executor=A,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=r}),Y(J[13],Z([0,1,20,21]),function(B,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=void 0,n.setDisposableTracker=m,n.trackDisposable=v,n.markAsDisposed=h,n.markAsSingleton=e,n.isDisposable=s,n.dispose=o,n.combinedDisposable=u,n.toDisposable=g;const A=!1;let c=null;function m(i){c=i}if(A){const i="__is_disposable_tracked__";m(new class{trackDisposable(a){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[i]||console.log(d)},3e3)}setParent(a,d){if(a&&a!==E.None)try{a[i]=!0}catch{}}markAsDisposed(a){if(a&&a!==E.None)try{a[i]=!0}catch{}}markAsSingleton(a){}})}function v(i){return c?.trackDisposable(i),i}function h(i){c?.markAsDisposed(i)}function l(i,a){c?.setParent(i,a)}function L(i,a){if(c)for(const d of i)c.setParent(d,a)}function e(i){return c?.markAsSingleton(i),i}function s(i){return typeof i.dispose=="function"&&i.dispose.length===0}function o(i){if(x.Iterable.is(i)){const a=[];for(const d of i)if(d)try{d.dispose()}catch(p){a.push(p)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}function u(...i){const a=g(()=>o(i));return L(i,a),a}function g(i){const a=v({dispose:(0,r.createSingleCallFunction)(()=>{h(a),i()})});return a}class f{constructor(){this._toDispose=new Set,this._isDisposed=!1,v(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{o(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return l(a,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}deleteAndLeak(a){a&&this._toDispose.has(a)&&(this._toDispose.delete(a),l(a,null))}}n.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new f,v(this),l(this._store,this)}dispose(){h(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}n.Disposable=E,E.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var d;this._isDisposed||a===this._value||((d=this._value)===null||d===void 0||d.dispose(),a&&l(a,this),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,h(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}n.MutableDisposable=_;class N{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=N;class S{constructor(a){this.object=a}dispose(){}}n.ImmortalReference=S;class C{constructor(){this._store=new Map,this._isDisposed=!1,v(this)}dispose(){h(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{o(this._store.values())}finally{this._store.clear()}}get(a){return this._store.get(a)}set(a,d,p=!1){var b;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||(b=this._store.get(a))===null||b===void 0||b.dispose(),this._store.set(a,d)}deleteAndDispose(a){var d;(d=this._store.get(a))===null||d===void 0||d.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=C}),Y(J[22],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class r{constructor(c){this.element=c,this.next=r.Undefined,this.prev=r.Undefined}}r.Undefined=new r(void 0);class x{constructor(){this._first=r.Undefined,this._last=r.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===r.Undefined}clear(){let c=this._first;for(;c!==r.Undefined;){const m=c.next;c.prev=r.Undefined,c.next=r.Undefined,c=m}this._first=r.Undefined,this._last=r.Undefined,this._size=0}unshift(c){return this._insert(c,!1)}push(c){return this._insert(c,!0)}_insert(c,m){const v=new r(c);if(this._first===r.Undefined)this._first=v,this._last=v;else if(m){const l=this._last;this._last=v,v.prev=l,l.next=v}else{const l=this._first;this._first=v,v.next=l,l.prev=v}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(v))}}shift(){if(this._first!==r.Undefined){const c=this._first.element;return this._remove(this._first),c}}pop(){if(this._last!==r.Undefined){const c=this._last.element;return this._remove(this._last),c}}_remove(c){if(c.prev!==r.Undefined&&c.next!==r.Undefined){const m=c.prev;m.next=c.next,c.next.prev=m}else c.prev===r.Undefined&&c.next===r.Undefined?(this._first=r.Undefined,this._last=r.Undefined):c.next===r.Undefined?(this._last=this._last.prev,this._last.next=r.Undefined):c.prev===r.Undefined&&(this._first=this._first.next,this._first.prev=r.Undefined);this._size-=1}*[Symbol.iterator](){let c=this._first;for(;c!==r.Undefined;)yield c.element,c=c.next}}n.LinkedList=x}),Y(J[38],Z([0,1]),function(B,n){"use strict";var r,x;Object.defineProperty(n,"__esModule",{value:!0}),n.SetMap=n.BidirectionalMap=n.LRUCache=n.LinkedMap=n.ResourceMap=void 0;class A{constructor(s,o){this.uri=s,this.value=o}}function c(e){return Array.isArray(e)}class m{constructor(s,o){if(this[r]="ResourceMap",s instanceof m)this.map=new Map(s.map),this.toKey=o??m.defaultToKey;else if(c(s)){this.map=new Map,this.toKey=o??m.defaultToKey;for(const[u,g]of s)this.set(u,g)}else this.map=new Map,this.toKey=s??m.defaultToKey}set(s,o){return this.map.set(this.toKey(s),new A(s,o)),this}get(s){var o;return(o=this.map.get(this.toKey(s)))===null||o===void 0?void 0:o.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,o){typeof o<"u"&&(s=s.bind(o));for(const[u,g]of this.map)s(g.value,g.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}n.ResourceMap=m,m.defaultToKey=e=>e.toString();class v{constructor(){this[x]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,o=0){const u=this._map.get(s);if(u)return o!==0&&this.touch(u,o),u.value}set(s,o,u=0){let g=this._map.get(s);if(g)g.value=o,u!==0&&this.touch(g,u);else{switch(g={key:s,value:o,next:void 0,previous:void 0},u){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(s,g),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const o=this._map.get(s);if(o)return this._map.delete(s),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,o){const u=this._state;let g=this._head;for(;g;){if(o?s.bind(o)(g.value,g.key,this):s(g.value,g.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const s=this,o=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.key,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return g}values(){const s=this,o=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.value,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return g}entries(){const s=this,o=this._state;let u=this._head;const g={[Symbol.iterator](){return g},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:[u.key,u.value],done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return g}[(x=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let o=this._head,u=this.size;for(;o&&u>s;)this._map.delete(o.key),o=o.next,u--;this._head=o,this._size=u,o&&(o.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const o=s.next,u=s.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}s.next=void 0,s.previous=void 0,this._state++}touch(s,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(s===this._head)return;const u=s.next,g=s.previous;s===this._tail?(g.next=void 0,this._tail=g):(u.previous=g,g.next=u),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(o===2){if(s===this._tail)return;const u=s.next,g=s.previous;s===this._head?(u.previous=void 0,this._head=u):(u.previous=g,g.next=u),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((o,u)=>{s.push([u,o])}),s}fromJSON(s){this.clear();for(const[o,u]of s)this.set(o,u)}}n.LinkedMap=v;class h extends v{constructor(s,o=1){super(),this._limit=s,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get(s,o=2){return super.get(s,o)}peek(s){return super.get(s,0)}set(s,o){return super.set(s,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}n.LRUCache=h;class l{constructor(s){if(this._m1=new Map,this._m2=new Map,s)for(const[o,u]of s)this.set(o,u)}clear(){this._m1.clear(),this._m2.clear()}set(s,o){this._m1.set(s,o),this._m2.set(o,s)}get(s){return this._m1.get(s)}getKey(s){return this._m2.get(s)}delete(s){const o=this._m1.get(s);return o===void 0?!1:(this._m1.delete(s),this._m2.delete(o),!0)}keys(){return this._m1.keys()}values(){return this._m1.values()}}n.BidirectionalMap=l;class L{constructor(){this.map=new Map}add(s,o){let u=this.map.get(s);u||(u=new Set,this.map.set(s,u)),u.add(o)}delete(s,o){const u=this.map.get(s);u&&(u.delete(o),u.size===0&&this.map.delete(s))}forEach(s,o){const u=this.map.get(s);u&&u.forEach(o)}get(s){const o=this.map.get(s);return o||new Set}}n.SetMap=L}),Y(J[23],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class x{static create(c){return new x(c)}constructor(c){this._now=r&&c===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=x}),Y(J[9],Z([0,1,5,20,13,22,23]),function(B,n,r,x,A,c,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const v=!1,h=!1,l=!1;var L;(function(R){R.None=()=>A.Disposable.None;function y(K){if(l){const{onDidAddListener:$}=K,ee=u.create();let X=0;K.onDidAddListener=()=>{++X===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),$?.()}}}function M(K,$){return V(K,()=>{},0,void 0,!0,void 0,$)}R.defer=M;function D(K){return($,ee=null,X)=>{let re=!1,ne;return ne=K(ie=>{if(!re)return ne?ne.dispose():re=!0,$.call(ee,ie)},null,X),re&&ne.dispose(),ne}}R.once=D;function T(K,$,ee){return I((X,re=null,ne)=>K(ie=>X.call(re,$(ie)),null,ne),ee)}R.map=T;function k(K,$,ee){return I((X,re=null,ne)=>K(ie=>{$(ie),X.call(re,ie)},null,ne),ee)}R.forEach=k;function q(K,$,ee){return I((X,re=null,ne)=>K(ie=>$(ie)&&X.call(re,ie),null,ne),ee)}R.filter=q;function H(K){return K}R.signal=H;function G(...K){return($,ee=null,X)=>{const re=(0,A.combinedDisposable)(...K.map(ne=>ne(ie=>$.call(ee,ie))));return W(re,X)}}R.any=G;function F(K,$,ee,X){let re=ee;return T(K,ne=>(re=$(re,ne),re),X)}R.reduce=F;function I(K,$){let ee;const X={onWillAddFirstListener(){ee=K(re.fire,re)},onDidRemoveLastListener(){ee?.dispose()}};$||y(X);const re=new N(X);return $?.add(re),re.event}function W(K,$){return $ instanceof Array?$.push(K):$&&$.add(K),K}function V(K,$,ee=100,X=!1,re=!1,ne,ie){let P,O,j,Q=0,te;const ae={leakWarningThreshold:ne,onWillAddFirstListener(){P=K(ge=>{Q++,O=$(O,ge),X&&!j&&(oe.fire(O),O=void 0),te=()=>{const fe=O;O=void 0,j=void 0,(!X||Q>1)&&oe.fire(fe),Q=0},typeof ee=="number"?(clearTimeout(j),j=setTimeout(te,ee)):j===void 0&&(j=0,queueMicrotask(te))})},onWillRemoveListener(){re&&Q>0&&te?.()},onDidRemoveLastListener(){te=void 0,P.dispose()}};ie||y(ae);const oe=new N(ae);return ie?.add(oe),oe.event}R.debounce=V;function z(K,$=0,ee){return R.debounce(K,(X,re)=>X?(X.push(re),X):[re],$,void 0,!0,void 0,ee)}R.accumulate=z;function U(K,$=(X,re)=>X===re,ee){let X=!0,re;return q(K,ne=>{const ie=X||!$(ne,re);return X=!1,re=ne,ie},ee)}R.latch=U;function se(K,$,ee){return[R.filter(K,$,ee),R.filter(K,X=>!$(X),ee)]}R.split=se;function he(K,$=!1,ee=[],X){let re=ee.slice(),ne=K(O=>{re?re.push(O):P.fire(O)});X&&X.add(ne);const ie=()=>{re?.forEach(O=>P.fire(O)),re=null},P=new N({onWillAddFirstListener(){ne||(ne=K(O=>P.fire(O)),X&&X.add(ne))},onDidAddFirstListener(){re&&($?setTimeout(ie):ie())},onDidRemoveLastListener(){ne&&ne.dispose(),ne=null}});return X&&X.add(P),P.event}R.buffer=he;function t(K,$){return(X,re,ne)=>{const ie=$(new Le);return K(function(P){const O=ie.evaluate(P);O!==me&&X.call(re,O)},void 0,ne)}}R.chain=t;const me=Symbol("HaltChainable");class Le{constructor(){this.steps=[]}map($){return this.steps.push($),this}forEach($){return this.steps.push(ee=>($(ee),ee)),this}filter($){return this.steps.push(ee=>$(ee)?ee:me),this}reduce($,ee){let X=ee;return this.steps.push(re=>(X=$(X,re),X)),this}latch($=(ee,X)=>ee===X){let ee=!0,X;return this.steps.push(re=>{const ne=ee||!$(re,X);return ee=!1,X=re,ne?re:me}),this}evaluate($){for(const ee of this.steps)if($=ee($),$===me)break;return $}}function we(K,$,ee=X=>X){const X=(...P)=>ie.fire(ee(...P)),re=()=>K.on($,X),ne=()=>K.removeListener($,X),ie=new N({onWillAddFirstListener:re,onDidRemoveLastListener:ne});return ie.event}R.fromNodeEventEmitter=we;function _e(K,$,ee=X=>X){const X=(...P)=>ie.fire(ee(...P)),re=()=>K.addEventListener($,X),ne=()=>K.removeEventListener($,X),ie=new N({onWillAddFirstListener:re,onDidRemoveLastListener:ne});return ie.event}R.fromDOMEventEmitter=_e;function Ce(K){return new Promise($=>D(K)($))}R.toPromise=Ce;function be(K){const $=new N;return K.then(ee=>{$.fire(ee)},()=>{$.fire(void 0)}).finally(()=>{$.dispose()}),$.event}R.fromPromise=be;function Se(K,$,ee){return $(ee),K(X=>$(X))}R.runAndSubscribe=Se;class ye{constructor($,ee){this._observable=$,this._counter=0,this._hasChanged=!1;const X={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};ee||y(X),this.emitter=new N(X),ee&&ee.add(this.emitter)}beginUpdate($){this._counter++}handlePossibleChange($){}handleChange($,ee){this._hasChanged=!0}endUpdate($){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Ee(K,$){return new ye(K,$).emitter.event}R.fromObservable=Ee;function ve(K){return($,ee,X)=>{let re=0,ne=!1;const ie={beginUpdate(){re++},endUpdate(){re--,re===0&&(K.reportChanges(),ne&&(ne=!1,$.call(ee)))},handlePossibleChange(){},handleChange(){ne=!0}};K.addObserver(ie),K.reportChanges();const P={dispose(){K.removeObserver(ie)}};return X instanceof A.DisposableStore?X.add(P):Array.isArray(X)&&X.push(P),P}}R.fromObservableLight=ve})(L||(n.Event=L={}));class e{constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${e._idPool++}`,e.all.add(this)}start(y){this._stopWatch=new m.StopWatch,this.listenerCount=y}stop(){if(this._stopWatch){const y=this._stopWatch.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=e,e.all=new Set,e._idPool=0;let s=-1;class o{constructor(y,M=Math.random().toString(18).slice(2,5)){this.threshold=y,this.name=M,this._warnCountdown=0}dispose(){var y;(y=this._stacks)===null||y===void 0||y.clear()}check(y,M){const D=this.threshold;if(D<=0||M<D)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(y.value)||0;if(this._stacks.set(y.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=D*.5;let k,q=0;for(const[H,G]of this._stacks)(!k||q<G)&&(k=H,q=G);console.warn(`[${this.name}] potential listener LEAK detected, having ${M} listeners already. MOST frequent listener (${q}):`),console.warn(k)}return()=>{const k=this._stacks.get(y.value)||0;this._stacks.set(y.value,k-1)}}}class u{static create(){var y;return new u((y=new Error().stack)!==null&&y!==void 0?y:"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(y){this.value=y}}const f=2,E=(R,y)=>{if(R instanceof g)y(R);else for(let M=0;M<R.length;M++){const D=R[M];D&&y(D)}},_=v?new FinalizationRegistry(R=>{typeof R=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(R))}):void 0;class N{constructor(y){var M,D,T,k,q;this._size=0,this._options=y,this._leakageMon=s>0||!((M=this._options)===null||M===void 0)&&M.leakWarningThreshold?new o((T=(D=this._options)===null||D===void 0?void 0:D.leakWarningThreshold)!==null&&T!==void 0?T:s):void 0,this._perfMon=!((k=this._options)===null||k===void 0)&&k._profName?new e(this._options._profName):void 0,this._deliveryQueue=(q=this._options)===null||q===void 0?void 0:q.deliveryQueue}dispose(){var y,M,D,T;if(!this._disposed){if(this._disposed=!0,((y=this._deliveryQueue)===null||y===void 0?void 0:y.current)===this&&this._deliveryQueue.reset(),this._listeners){if(h){const k=this._listeners;queueMicrotask(()=>{E(k,q=>{var H;return(H=q.stack)===null||H===void 0?void 0:H.print()})})}this._listeners=void 0,this._size=0}(D=(M=this._options)===null||M===void 0?void 0:M.onDidRemoveLastListener)===null||D===void 0||D.call(M),(T=this._leakageMon)===null||T===void 0||T.dispose()}}get event(){var y;return(y=this._event)!==null&&y!==void 0||(this._event=(M,D,T)=>{var k,q,H,G,F;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.Disposable.None;if(this._disposed)return A.Disposable.None;D&&(M=M.bind(D));const I=new g(M);let W,V;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(I.stack=u.create(),W=this._leakageMon.check(I.stack,this._size+1)),h&&(I.stack=V??u.create()),this._listeners?this._listeners instanceof g?((F=this._deliveryQueue)!==null&&F!==void 0||(this._deliveryQueue=new C),this._listeners=[this._listeners,I]):this._listeners.push(I):((q=(k=this._options)===null||k===void 0?void 0:k.onWillAddFirstListener)===null||q===void 0||q.call(k,this),this._listeners=I,(G=(H=this._options)===null||H===void 0?void 0:H.onDidAddFirstListener)===null||G===void 0||G.call(H,this)),this._size++;const z=(0,A.toDisposable)(()=>{_?.unregister(z),W?.(),this._removeListener(I)});if(T instanceof A.DisposableStore?T.add(z):Array.isArray(T)&&T.push(z),_){const U=new Error().stack.split(`
`).slice(2).join(`
`).trim();_.register(z,U,z)}return z}),this._event}_removeListener(y){var M,D,T,k;if((D=(M=this._options)===null||M===void 0?void 0:M.onWillRemoveListener)===null||D===void 0||D.call(M,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(k=(T=this._options)===null||T===void 0?void 0:T.onDidRemoveLastListener)===null||k===void 0||k.call(T,this),this._size=0;return}const q=this._listeners,H=q.indexOf(y);if(H===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,q[H]=void 0;const G=this._deliveryQueue.current===this;if(this._size*f<=q.length){let F=0;for(let I=0;I<q.length;I++)q[I]?q[F++]=q[I]:G&&(this._deliveryQueue.end--,F<this._deliveryQueue.i&&this._deliveryQueue.i--);q.length=F}}_deliver(y,M){var D;if(!y)return;const T=((D=this._options)===null||D===void 0?void 0:D.onListenerError)||r.onUnexpectedError;if(!T){y.value(M);return}try{y.value(M)}catch(k){T(k)}}_deliverQueue(y){const M=y.current._listeners;for(;y.i<y.end;)this._deliver(M[y.i++],y.value);y.reset()}fire(y){var M,D,T,k;if(!((M=this._deliveryQueue)===null||M===void 0)&&M.current&&(this._deliverQueue(this._deliveryQueue),(D=this._perfMon)===null||D===void 0||D.stop()),(T=this._perfMon)===null||T===void 0||T.start(this._size),this._listeners)if(this._listeners instanceof g)this._deliver(this._listeners,y);else{const q=this._deliveryQueue;q.enqueue(this,y,this._listeners.length),this._deliverQueue(q)}(k=this._perfMon)===null||k===void 0||k.stop()}hasListeners(){return this._size>0}}n.Emitter=N;const S=()=>new C;n.createEventDeliveryQueue=S;class C{constructor(){this.i=-1,this.end=0}enqueue(y,M,D){this.i=0,this.end=D,this.current=y,this.value=M}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends N{constructor(y){super(y),this._isPaused=0,this._eventQueue=new c.LinkedList,this._mergeFn=y?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const y=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(y))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(y){this._size&&(this._isPaused!==0?this._eventQueue.push(y):super.fire(y))}}n.PauseableEmitter=i;class a extends i{constructor(y){var M;super(y),this._delay=(M=y.delay)!==null&&M!==void 0?M:100}fire(y){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(y)}}n.DebounceEmitter=a;class d extends N{constructor(y){super(y),this._queuedEvents=[],this._mergeFn=y?.merge}fire(y){this.hasListeners()&&(this._queuedEvents.push(y),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(M=>super.fire(M)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=d;class p{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new N({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(y){const M={event:y,listener:null};this.events.push(M),this.hasListeners&&this.hook(M);const D=()=>{this.hasListeners&&this.unhook(M);const T=this.events.indexOf(M);this.events.splice(T,1)};return(0,A.toDisposable)((0,x.createSingleCallFunction)(D))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(y=>this.hook(y))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(y=>this.unhook(y))}hook(y){y.listener=y.event(M=>this.emitter.fire(M))}unhook(y){var M;(M=y.listener)===null||M===void 0||M.dispose(),y.listener=null}dispose(){var y;this.emitter.dispose();for(const M of this.events)(y=M.listener)===null||y===void 0||y.dispose();this.events=[]}}n.EventMultiplexer=p;class b{constructor(){this.buffers=[]}wrapEvent(y){return(M,D,T)=>y(k=>{const q=this.buffers[this.buffers.length-1];q?q.push(()=>M.call(D,k)):M.call(D,k)},void 0,T)}bufferEvents(y){const M=[];this.buffers.push(M);const D=y();return this.buffers.pop(),M.forEach(T=>T()),D}}n.EventBufferer=b;class w{constructor(){this.listening=!1,this.inputEvent=L.None,this.inputEventListener=A.Disposable.None,this.emitter=new N({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(y){this.inputEvent=y,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=y(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=w}),Y(J[39],Z([0,1,9]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const x=Object.freeze(function(v,h){const l=setTimeout(v.bind(h),0);return{dispose(){clearTimeout(l)}}});var A;(function(v){function h(l){return l===v.None||l===v.Cancelled||l instanceof c?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}v.isCancellationToken=h,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:x})})(A||(n.CancellationToken=A={}));class c{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?x:(this._emitter||(this._emitter=new r.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class m{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new c),this._token}cancel(){this._token?this._token instanceof c&&this._token.cancel():this._token=A.Cancelled}dispose(h=!1){var l;h&&this.cancel(),(l=this._parentListener)===null||l===void 0||l.dispose(),this._token?this._token instanceof c&&this._token.dispose():this._token=A.None}}n.CancellationTokenSource=m}),Y(J[6],Z([0,1,33,37]),function(B,n,r,x){"use strict";var A;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.UTF8_BOM_CHARACTER=n.UNUSUAL_LINE_TERMINATORS=n.GraphemeIterator=n.CodePointIterator=void 0,n.isFalsyOrWhitespace=c,n.format=v,n.htmlAttributeEncodeValue=h,n.escape=l,n.escapeRegExpCharacters=L,n.trim=e,n.ltrim=s,n.rtrim=o,n.convertSimple2RegExpPattern=u,n.stripWildcards=g,n.createRegExp=f,n.regExpLeadsToEndlessLoop=E,n.splitLines=_,n.splitLinesIncludeSeparators=N,n.firstNonWhitespaceIndex=S,n.getLeadingWhitespace=C,n.lastNonWhitespaceIndex=i,n.compare=a,n.compareSubstring=d,n.compareIgnoreCase=p,n.compareSubstringIgnoreCase=b,n.isAsciiDigit=w,n.isLowerAsciiLetter=R,n.isUpperAsciiLetter=y,n.equalsIgnoreCase=M,n.startsWithIgnoreCase=D,n.commonPrefixLength=T,n.commonSuffixLength=k,n.isHighSurrogate=q,n.isLowSurrogate=H,n.computeCodePoint=G,n.getNextCodePoint=F,n.nextCharLength=z,n.prevCharLength=U,n.getCharContainingOffset=se,n.containsRTL=me,n.isBasicASCII=we,n.containsUnusualLineTerminators=_e,n.isFullWidthCharacter=Ce,n.isEmojiImprecise=be,n.startsWithUTF8BOM=Se,n.containsUppercaseCharacter=ye,n.singleLetterHash=Ee,n.getLeftDeleteOffset=ee;function c(P){return!P||typeof P!="string"?!0:P.trim().length===0}const m=/{(\d+)}/g;function v(P,...O){return O.length===0?P:P.replace(m,function(j,Q){const te=parseInt(Q,10);return isNaN(te)||te<0||te>=O.length?j:O[te]})}function h(P){return P.replace(/[<>"'&]/g,O=>{switch(O){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return O})}function l(P){return P.replace(/[<>&]/g,function(O){switch(O){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return O}})}function L(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(P,O=" "){const j=s(P,O);return o(j,O)}function s(P,O){if(!P||!O)return P;const j=O.length;if(j===0||P.length===0)return P;let Q=0;for(;P.indexOf(O,Q)===Q;)Q=Q+j;return P.substring(Q)}function o(P,O){if(!P||!O)return P;const j=O.length,Q=P.length;if(j===0||Q===0)return P;let te=Q,ae=-1;for(;ae=P.lastIndexOf(O,te-1),!(ae===-1||ae+j!==te);){if(ae===0)return"";te=ae}return P.substring(0,te)}function u(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function g(P){return P.replace(/\*/g,"")}function f(P,O,j={}){if(!P)throw new Error("Cannot create regex from empty string");O||(P=L(P)),j.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let Q="";return j.global&&(Q+="g"),j.matchCase||(Q+="i"),j.multiline&&(Q+="m"),j.unicode&&(Q+="u"),new RegExp(P,Q)}function E(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}function _(P){return P.split(/\r\n|\r|\n/)}function N(P){var O;const j=[],Q=P.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(Q.length/2);te++)j.push(Q[2*te]+((O=Q[2*te+1])!==null&&O!==void 0?O:""));return j}function S(P){for(let O=0,j=P.length;O<j;O++){const Q=P.charCodeAt(O);if(Q!==32&&Q!==9)return O}return-1}function C(P,O=0,j=P.length){for(let Q=O;Q<j;Q++){const te=P.charCodeAt(Q);if(te!==32&&te!==9)return P.substring(O,Q)}return P.substring(O,j)}function i(P,O=P.length-1){for(let j=O;j>=0;j--){const Q=P.charCodeAt(j);if(Q!==32&&Q!==9)return j}return-1}function a(P,O){return P<O?-1:P>O?1:0}function d(P,O,j=0,Q=P.length,te=0,ae=O.length){for(;j<Q&&te<ae;j++,te++){const fe=P.charCodeAt(j),le=O.charCodeAt(te);if(fe<le)return-1;if(fe>le)return 1}const oe=Q-j,ge=ae-te;return oe<ge?-1:oe>ge?1:0}function p(P,O){return b(P,O,0,P.length,0,O.length)}function b(P,O,j=0,Q=P.length,te=0,ae=O.length){for(;j<Q&&te<ae;j++,te++){let fe=P.charCodeAt(j),le=O.charCodeAt(te);if(fe===le)continue;if(fe>=128||le>=128)return d(P.toLowerCase(),O.toLowerCase(),j,Q,te,ae);R(fe)&&(fe-=32),R(le)&&(le-=32);const ce=fe-le;if(ce!==0)return ce}const oe=Q-j,ge=ae-te;return oe<ge?-1:oe>ge?1:0}function w(P){return P>=48&&P<=57}function R(P){return P>=97&&P<=122}function y(P){return P>=65&&P<=90}function M(P,O){return P.length===O.length&&b(P,O)===0}function D(P,O){const j=O.length;return O.length>P.length?!1:b(P,O,0,j)===0}function T(P,O){const j=Math.min(P.length,O.length);let Q;for(Q=0;Q<j;Q++)if(P.charCodeAt(Q)!==O.charCodeAt(Q))return Q;return j}function k(P,O){const j=Math.min(P.length,O.length);let Q;const te=P.length-1,ae=O.length-1;for(Q=0;Q<j;Q++)if(P.charCodeAt(te-Q)!==O.charCodeAt(ae-Q))return Q;return j}function q(P){return 55296<=P&&P<=56319}function H(P){return 56320<=P&&P<=57343}function G(P,O){return(P-55296<<10)+(O-56320)+65536}function F(P,O,j){const Q=P.charCodeAt(j);if(q(Q)&&j+1<O){const te=P.charCodeAt(j+1);if(H(te))return G(Q,te)}return Q}function I(P,O){const j=P.charCodeAt(O-1);if(H(j)&&O>1){const Q=P.charCodeAt(O-2);if(q(Q))return G(Q,j)}return j}class W{get offset(){return this._offset}constructor(O,j=0){this._str=O,this._len=O.length,this._offset=j}setOffset(O){this._offset=O}prevCodePoint(){const O=I(this._str,this._offset);return this._offset-=O>=65536?2:1,O}nextCodePoint(){const O=F(this._str,this._len,this._offset);return this._offset+=O>=65536?2:1,O}eol(){return this._offset>=this._len}}n.CodePointIterator=W;class V{get offset(){return this._iterator.offset}constructor(O,j=0){this._iterator=new W(O,j)}nextGraphemeLength(){const O=K.getInstance(),j=this._iterator,Q=j.offset;let te=O.getGraphemeBreakType(j.nextCodePoint());for(;!j.eol();){const ae=j.offset,oe=O.getGraphemeBreakType(j.nextCodePoint());if(ve(te,oe)){j.setOffset(ae);break}te=oe}return j.offset-Q}prevGraphemeLength(){const O=K.getInstance(),j=this._iterator,Q=j.offset;let te=O.getGraphemeBreakType(j.prevCodePoint());for(;j.offset>0;){const ae=j.offset,oe=O.getGraphemeBreakType(j.prevCodePoint());if(ve(oe,te)){j.setOffset(ae);break}te=oe}return Q-j.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=V;function z(P,O){return new V(P,O).nextGraphemeLength()}function U(P,O){return new V(P,O).prevGraphemeLength()}function se(P,O){O>0&&H(P.charCodeAt(O))&&O--;const j=O+z(P,O);return[j-U(P,j),j]}let he;function t(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function me(P){return he||(he=t()),he.test(P)}const Le=/^[\t\n\r\x20-\x7E]*$/;function we(P){return Le.test(P)}n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _e(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}function Ce(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}function be(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.UTF8_BOM_CHARACTER="\uFEFF";function Se(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}function ye(P,O=!1){return P?(O&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}function Ee(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}function ve(P,O){return P===0?O!==5&&O!==7:P===2&&O===3?!1:P===4||P===2||P===3||O===4||O===2||O===3?!0:!(P===8&&(O===8||O===9||O===11||O===12)||(P===11||P===9)&&(O===9||O===10)||(P===12||P===10)&&O===10||O===5||O===13||O===7||P===1||P===13&&O===14||P===6&&O===6)}class K{static getInstance(){return K._INSTANCE||(K._INSTANCE=new K),K._INSTANCE}constructor(){this._data=$()}getGraphemeBreakType(O){if(O<32)return O===10?3:O===13?2:4;if(O<127)return 0;const j=this._data,Q=j.length/3;let te=1;for(;te<=Q;)if(O<j[3*te])te=2*te;else if(O>j[3*te+1])te=2*te+1;else return j[3*te+2];return 0}}K._INSTANCE=null;function $(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ee(P,O){if(P===0)return 0;const j=X(P,O);if(j!==void 0)return j;const Q=new W(O,P);return Q.prevCodePoint(),Q.offset}function X(P,O){const j=new W(O,P);let Q=j.prevCodePoint();for(;re(Q)||Q===65039||Q===8419;){if(j.offset===0)return;Q=j.prevCodePoint()}if(!be(Q))return;let te=j.offset;return te>0&&j.prevCodePoint()===8205&&(te=j.offset),te}function re(P){return 127995<=P&&P<=127999}n.noBreakWhitespace="\xA0";class ne{static getInstance(O){return A.cache.get(Array.from(O))}static getLocales(){return A._locales.value}constructor(O){this.confusableDictionary=O}isAmbiguous(O){return this.confusableDictionary.has(O)}getPrimaryConfusable(O){return this.confusableDictionary.get(O)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=ne,A=ne,ne.ambiguousCharacterData=new x.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ne.cache=new r.LRUCachedFunction(P=>{function O(le){const ce=new Map;for(let de=0;de<le.length;de+=2)ce.set(le[de],le[de+1]);return ce}function j(le,ce){const de=new Map(le);for(const[pe,Ne]of ce)de.set(pe,Ne);return de}function Q(le,ce){if(!le)return ce;const de=new Map;for(const[pe,Ne]of le)ce.has(pe)&&de.set(pe,Ne);return de}const te=A.ambiguousCharacterData.value;let ae=P.filter(le=>!le.startsWith("_")&&le in te);ae.length===0&&(ae=["_default"]);let oe;for(const le of ae){const ce=O(te[le]);oe=Q(oe,ce)}const ge=O(te._common),fe=j(ge,oe);return new A(fe)}),ne._locales=new x.Lazy(()=>Object.keys(A.ambiguousCharacterData.value).filter(P=>!P.startsWith("_")));class ie{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ie.getRawData())),this._data}static isInvisibleCharacter(O){return ie.getData().has(O)}static get codePoints(){return ie.getData()}}n.InvisibleCharacters=ie,ie._data=void 0}),Y(J[40],Z([0,1,6]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=void 0,n.hash=x,n.doHash=A,n.numberHash=c,n.stringHash=v,n.toHexString=o;function x(g){return A(g,0)}function A(g,f){switch(typeof g){case"object":return g===null?c(349,f):Array.isArray(g)?h(g,f):l(g,f);case"string":return v(g,f);case"boolean":return m(g,f);case"number":return c(g,f);case"undefined":return c(937,f);default:return c(617,f)}}function c(g,f){return(f<<5)-f+g|0}function m(g,f){return c(g?433:863,f)}function v(g,f){f=c(149417,f);for(let E=0,_=g.length;E<_;E++)f=c(g.charCodeAt(E),f);return f}function h(g,f){return f=c(104579,f),g.reduce((E,_)=>A(_,E),f)}function l(g,f){return f=c(181387,f),Object.keys(g).sort().reduce((E,_)=>(E=v(_,E),A(g[_],E)),f)}function L(g,f,E=32){const _=E-f,N=~((1<<_)-1);return(g<<f|(N&g)>>>_)>>>0}function e(g,f=0,E=g.byteLength,_=0){for(let N=0;N<E;N++)g[f+N]=_}function s(g,f,E="0"){for(;g.length<f;)g=E+g;return g}function o(g,f=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(E=>E.toString(16).padStart(2,"0")).join(""):s((g>>>0).toString(16),f/4)}class u{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const E=f.length;if(E===0)return;const _=this._buff;let N=this._buffLen,S=this._leftoverHighSurrogate,C,i;for(S!==0?(C=S,i=-1,S=0):(C=f.charCodeAt(0),i=0);;){let a=C;if(r.isHighSurrogate(C))if(i+1<E){const d=f.charCodeAt(i+1);r.isLowSurrogate(d)?(i++,a=r.computeCodePoint(C,d)):a=65533}else{S=C;break}else r.isLowSurrogate(C)&&(a=65533);if(N=this._push(_,N,a),i++,i<E)C=f.charCodeAt(i);else break}this._buffLen=N,this._leftoverHighSurrogate=S}_push(f,E,_){return _<128?f[E++]=_:_<2048?(f[E++]=192|(_&1984)>>>6,f[E++]=128|(_&63)>>>0):_<65536?(f[E++]=224|(_&61440)>>>12,f[E++]=128|(_&4032)>>>6,f[E++]=128|(_&63)>>>0):(f[E++]=240|(_&1835008)>>>18,f[E++]=128|(_&258048)>>>12,f[E++]=128|(_&4032)>>>6,f[E++]=128|(_&63)>>>0),E>=64&&(this._step(),E-=64,this._totalLen+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),E}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),o(this._h0)+o(this._h1)+o(this._h2)+o(this._h3)+o(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=u._bigBlock32,E=this._buffDV;for(let b=0;b<64;b+=4)f.setUint32(b,E.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)f.setUint32(b,L(f.getUint32(b-12,!1)^f.getUint32(b-32,!1)^f.getUint32(b-56,!1)^f.getUint32(b-64,!1),1),!1);let _=this._h0,N=this._h1,S=this._h2,C=this._h3,i=this._h4,a,d,p;for(let b=0;b<80;b++)b<20?(a=N&S|~N&C,d=1518500249):b<40?(a=N^S^C,d=1859775393):b<60?(a=N&S|N&C|S&C,d=2400959708):(a=N^S^C,d=3395469782),p=L(_,5)+a+i+d+f.getUint32(b*4,!1)&4294967295,i=C,C=S,S=L(N,30),N=_,_=p;this._h0=this._h0+_&4294967295,this._h1=this._h1+N&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+C&4294967295,this._h4=this._h4+i&4294967295}}n.StringSHA1=u,u._bigBlock32=new DataView(new ArrayBuffer(320))}),Y(J[24],Z([0,1,35,40]),function(B,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.StringDiffSequence=void 0,n.stringDiff=c;class A{constructor(e){this.source=e}getElements(){const e=this.source,s=new Int32Array(e.length);for(let o=0,u=e.length;o<u;o++)s[o]=e.charCodeAt(o);return s}}n.StringDiffSequence=A;function c(L,e,s){return new l(new A(L),new A(e)).ComputeDiff(s).changes}class m{static Assert(e,s){if(!e)throw new Error(s)}}class v{static Copy(e,s,o,u,g){for(let f=0;f<g;f++)o[u+f]=e[s+f]}static Copy2(e,s,o,u,g){for(let f=0;f<g;f++)o[u+f]=e[s+f]}}class h{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new r.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,s){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_originalCount++}AddModifiedElement(e,s){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class l{constructor(e,s,o=null){this.ContinueProcessingPredicate=o,this._originalSequence=e,this._modifiedSequence=s;const[u,g,f]=l._getElements(e),[E,_,N]=l._getElements(s);this._hasStrings=f&&N,this._originalStringElements=u,this._originalElementsOrHash=g,this._modifiedStringElements=E,this._modifiedElementsOrHash=_,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const s=e.getElements();if(l._isStringArray(s)){const o=new Int32Array(s.length);for(let u=0,g=s.length;u<g;u++)o[u]=(0,x.stringHash)(s[u],0);return[s,o,!0]}return s instanceof Int32Array?[[],s,!1]:[[],new Int32Array(s),!1]}ElementsAreEqual(e,s){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[s]:!0}ElementsAreStrictEqual(e,s){if(!this.ElementsAreEqual(e,s))return!1;const o=l._getStrictElement(this._originalSequence,e),u=l._getStrictElement(this._modifiedSequence,s);return o===u}static _getStrictElement(e,s){return typeof e.getStrictElement=="function"?e.getStrictElement(s):null}OriginalElementsAreEqual(e,s){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[s]:!0}ModifiedElementsAreEqual(e,s){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[s]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,s,o,u,g){const f=[!1];let E=this.ComputeDiffRecursive(e,s,o,u,f);return g&&(E=this.PrettifyChanges(E)),{quitEarly:f[0],changes:E}}ComputeDiffRecursive(e,s,o,u,g){for(g[0]=!1;e<=s&&o<=u&&this.ElementsAreEqual(e,o);)e++,o++;for(;s>=e&&u>=o&&this.ElementsAreEqual(s,u);)s--,u--;if(e>s||o>u){let C;return o<=u?(m.Assert(e===s+1,"originalStart should only be one more than originalEnd"),C=[new r.DiffChange(e,0,o,u-o+1)]):e<=s?(m.Assert(o===u+1,"modifiedStart should only be one more than modifiedEnd"),C=[new r.DiffChange(e,s-e+1,o,0)]):(m.Assert(e===s+1,"originalStart should only be one more than originalEnd"),m.Assert(o===u+1,"modifiedStart should only be one more than modifiedEnd"),C=[]),C}const f=[0],E=[0],_=this.ComputeRecursionPoint(e,s,o,u,f,E,g),N=f[0],S=E[0];if(_!==null)return _;if(!g[0]){const C=this.ComputeDiffRecursive(e,N,o,S,g);let i=[];return g[0]?i=[new r.DiffChange(N+1,s-(N+1)+1,S+1,u-(S+1)+1)]:i=this.ComputeDiffRecursive(N+1,s,S+1,u,g),this.ConcatenateChanges(C,i)}return[new r.DiffChange(e,s-e+1,o,u-o+1)]}WALKTRACE(e,s,o,u,g,f,E,_,N,S,C,i,a,d,p,b,w,R){let y=null,M=null,D=new h,T=s,k=o,q=a[0]-b[0]-u,H=-1073741824,G=this.m_forwardHistory.length-1;do{const F=q+e;F===T||F<k&&N[F-1]<N[F+1]?(C=N[F+1],d=C-q-u,C<H&&D.MarkNextChange(),H=C,D.AddModifiedElement(C+1,d),q=F+1-e):(C=N[F-1]+1,d=C-q-u,C<H&&D.MarkNextChange(),H=C-1,D.AddOriginalElement(C,d+1),q=F-1-e),G>=0&&(N=this.m_forwardHistory[G],e=N[0],T=1,k=N.length-1)}while(--G>=-1);if(y=D.getReverseChanges(),R[0]){let F=a[0]+1,I=b[0]+1;if(y!==null&&y.length>0){const W=y[y.length-1];F=Math.max(F,W.getOriginalEnd()),I=Math.max(I,W.getModifiedEnd())}M=[new r.DiffChange(F,i-F+1,I,p-I+1)]}else{D=new h,T=f,k=E,q=a[0]-b[0]-_,H=1073741824,G=w?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const F=q+g;F===T||F<k&&S[F-1]>=S[F+1]?(C=S[F+1]-1,d=C-q-_,C>H&&D.MarkNextChange(),H=C+1,D.AddOriginalElement(C+1,d+1),q=F+1-g):(C=S[F-1],d=C-q-_,C>H&&D.MarkNextChange(),H=C,D.AddModifiedElement(C+1,d+1),q=F-1-g),G>=0&&(S=this.m_reverseHistory[G],g=S[0],T=1,k=S.length-1)}while(--G>=-1);M=D.getChanges()}return this.ConcatenateChanges(y,M)}ComputeRecursionPoint(e,s,o,u,g,f,E){let _=0,N=0,S=0,C=0,i=0,a=0;e--,o--,g[0]=0,f[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const d=s-e+(u-o),p=d+1,b=new Int32Array(p),w=new Int32Array(p),R=u-o,y=s-e,M=e-o,D=s-u,k=(y-R)%2===0;b[R]=e,w[y]=s,E[0]=!1;for(let q=1;q<=d/2+1;q++){let H=0,G=0;S=this.ClipDiagonalBound(R-q,q,R,p),C=this.ClipDiagonalBound(R+q,q,R,p);for(let I=S;I<=C;I+=2){I===S||I<C&&b[I-1]<b[I+1]?_=b[I+1]:_=b[I-1]+1,N=_-(I-R)-M;const W=_;for(;_<s&&N<u&&this.ElementsAreEqual(_+1,N+1);)_++,N++;if(b[I]=_,_+N>H+G&&(H=_,G=N),!k&&Math.abs(I-y)<=q-1&&_>=w[I])return g[0]=_,f[0]=N,W<=w[I]&&1447>0&&q<=1448?this.WALKTRACE(R,S,C,M,y,i,a,D,b,w,_,s,g,N,u,f,k,E):null}const F=(H-e+(G-o)-q)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(H,F))return E[0]=!0,g[0]=H,f[0]=G,F>0&&1447>0&&q<=1448?this.WALKTRACE(R,S,C,M,y,i,a,D,b,w,_,s,g,N,u,f,k,E):(e++,o++,[new r.DiffChange(e,s-e+1,o,u-o+1)]);i=this.ClipDiagonalBound(y-q,q,y,p),a=this.ClipDiagonalBound(y+q,q,y,p);for(let I=i;I<=a;I+=2){I===i||I<a&&w[I-1]>=w[I+1]?_=w[I+1]-1:_=w[I-1],N=_-(I-y)-D;const W=_;for(;_>e&&N>o&&this.ElementsAreEqual(_,N);)_--,N--;if(w[I]=_,k&&Math.abs(I-R)<=q&&_<=b[I])return g[0]=_,f[0]=N,W>=b[I]&&1447>0&&q<=1448?this.WALKTRACE(R,S,C,M,y,i,a,D,b,w,_,s,g,N,u,f,k,E):null}if(q<=1447){let I=new Int32Array(C-S+2);I[0]=R-S+1,v.Copy2(b,S,I,1,C-S+1),this.m_forwardHistory.push(I),I=new Int32Array(a-i+2),I[0]=y-i+1,v.Copy2(w,i,I,1,a-i+1),this.m_reverseHistory.push(I)}}return this.WALKTRACE(R,S,C,M,y,i,a,D,b,w,_,s,g,N,u,f,k,E)}PrettifyChanges(e){for(let s=0;s<e.length;s++){const o=e[s],u=s<e.length-1?e[s+1].originalStart:this._originalElementsOrHash.length,g=s<e.length-1?e[s+1].modifiedStart:this._modifiedElementsOrHash.length,f=o.originalLength>0,E=o.modifiedLength>0;for(;o.originalStart+o.originalLength<u&&o.modifiedStart+o.modifiedLength<g&&(!f||this.OriginalElementsAreEqual(o.originalStart,o.originalStart+o.originalLength))&&(!E||this.ModifiedElementsAreEqual(o.modifiedStart,o.modifiedStart+o.modifiedLength));){const N=this.ElementsAreStrictEqual(o.originalStart,o.modifiedStart);if(this.ElementsAreStrictEqual(o.originalStart+o.originalLength,o.modifiedStart+o.modifiedLength)&&!N)break;o.originalStart++,o.modifiedStart++}const _=[null];if(s<e.length-1&&this.ChangesOverlap(e[s],e[s+1],_)){e[s]=_[0],e.splice(s+1,1),s--;continue}}for(let s=e.length-1;s>=0;s--){const o=e[s];let u=0,g=0;if(s>0){const C=e[s-1];u=C.originalStart+C.originalLength,g=C.modifiedStart+C.modifiedLength}const f=o.originalLength>0,E=o.modifiedLength>0;let _=0,N=this._boundaryScore(o.originalStart,o.originalLength,o.modifiedStart,o.modifiedLength);for(let C=1;;C++){const i=o.originalStart-C,a=o.modifiedStart-C;if(i<u||a<g||f&&!this.OriginalElementsAreEqual(i,i+o.originalLength)||E&&!this.ModifiedElementsAreEqual(a,a+o.modifiedLength))break;const p=(i===u&&a===g?5:0)+this._boundaryScore(i,o.originalLength,a,o.modifiedLength);p>N&&(N=p,_=C)}o.originalStart-=_,o.modifiedStart-=_;const S=[null];if(s>0&&this.ChangesOverlap(e[s-1],e[s],S)){e[s-1]=S[0],e.splice(s,1),s++;continue}}if(this._hasStrings)for(let s=1,o=e.length;s<o;s++){const u=e[s-1],g=e[s],f=g.originalStart-u.originalStart-u.originalLength,E=u.originalStart,_=g.originalStart+g.originalLength,N=_-E,S=u.modifiedStart,C=g.modifiedStart+g.modifiedLength,i=C-S;if(f<5&&N<20&&i<20){const a=this._findBetterContiguousSequence(E,N,S,i,f);if(a){const[d,p]=a;(d!==u.originalStart+u.originalLength||p!==u.modifiedStart+u.modifiedLength)&&(u.originalLength=d-u.originalStart,u.modifiedLength=p-u.modifiedStart,g.originalStart=d+f,g.modifiedStart=p+f,g.originalLength=_-g.originalStart,g.modifiedLength=C-g.modifiedStart)}}}return e}_findBetterContiguousSequence(e,s,o,u,g){if(s<g||u<g)return null;const f=e+s-g+1,E=o+u-g+1;let _=0,N=0,S=0;for(let C=e;C<f;C++)for(let i=o;i<E;i++){const a=this._contiguousSequenceScore(C,i,g);a>0&&a>_&&(_=a,N=C,S=i)}return _>0?[N,S]:null}_contiguousSequenceScore(e,s,o){let u=0;for(let g=0;g<o;g++){if(!this.ElementsAreEqual(e+g,s+g))return 0;u+=this._originalStringElements[e+g].length}return u}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,s){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(s>0){const o=e+s;if(this._OriginalIsBoundary(o-1)||this._OriginalIsBoundary(o))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,s){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(s>0){const o=e+s;if(this._ModifiedIsBoundary(o-1)||this._ModifiedIsBoundary(o))return!0}return!1}_boundaryScore(e,s,o,u){const g=this._OriginalRegionIsBoundary(e,s)?1:0,f=this._ModifiedRegionIsBoundary(o,u)?1:0;return g+f}ConcatenateChanges(e,s){const o=[];if(e.length===0||s.length===0)return s.length>0?s:e;if(this.ChangesOverlap(e[e.length-1],s[0],o)){const u=new Array(e.length+s.length-1);return v.Copy(e,0,u,0,e.length-1),u[e.length-1]=o[0],v.Copy(s,1,u,e.length,s.length-1),u}else{const u=new Array(e.length+s.length);return v.Copy(e,0,u,0,e.length),v.Copy(s,0,u,e.length,s.length),u}}ChangesOverlap(e,s,o){if(m.Assert(e.originalStart<=s.originalStart,"Left change is not less than or equal to right change"),m.Assert(e.modifiedStart<=s.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=s.originalStart||e.modifiedStart+e.modifiedLength>=s.modifiedStart){const u=e.originalStart;let g=e.originalLength;const f=e.modifiedStart;let E=e.modifiedLength;return e.originalStart+e.originalLength>=s.originalStart&&(g=s.originalStart+s.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=s.modifiedStart&&(E=s.modifiedStart+s.modifiedLength-e.modifiedStart),o[0]=new r.DiffChange(u,g,f,E),!0}else return o[0]=null,!1}ClipDiagonalBound(e,s,o,u){if(e>=0&&e<u)return e;const g=o,f=u-o-1,E=s%2===0;if(e<0){const _=g%2===0;return E===_?0:1}else{const _=f%2===0;return E===_?u-1:u-2}}}n.LcsDiff=l}),Y(J[25],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isString=r,n.isObject=x,n.isTypedArray=A,n.isNumber=c,n.isIterable=m,n.isBoolean=v,n.isUndefined=h,n.isDefined=l,n.isUndefinedOrNull=L,n.assertType=e,n.assertIsDefined=s,n.isFunction=o,n.validateConstraints=u,n.validateConstraint=g;function r(f){return typeof f=="string"}function x(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}function A(f){const E=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof E}function c(f){return typeof f=="number"&&!isNaN(f)}function m(f){return!!f&&typeof f[Symbol.iterator]=="function"}function v(f){return f===!0||f===!1}function h(f){return typeof f>"u"}function l(f){return!L(f)}function L(f){return h(f)||f===null}function e(f,E){if(!f)throw new Error(E?`Unexpected type, expected '${E}'`:"Unexpected type")}function s(f){if(L(f))throw new Error("Assertion Failed: argument is undefined or null");return f}function o(f){return typeof f=="function"}function u(f,E){const _=Math.min(f.length,E.length);for(let N=0;N<_;N++)g(f[N],E[N])}function g(f,E){if(r(E)){if(typeof f!==E)throw new Error(`argument does not match constraint: typeof ${E}`)}else if(o(E)){try{if(f instanceof E)return}catch{}if(!L(f)&&f.constructor===E||E.length===1&&E.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),Y(J[26],Z([0,1,25]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.register=A,n.getCodiconFontCharacters=c;const x=Object.create(null);function A(m,v){if((0,r.isString)(v)){const h=x[v];if(h===void 0)throw new Error(`${m} references an unknown codicon: ${v}`);v=h}return x[m]=v,{id:m}}function c(){return x}}),Y(J[41],Z([0,1,26]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.codiconsLibrary=void 0,n.codiconsLibrary={add:(0,r.register)("add",6e4),plus:(0,r.register)("plus",6e4),gistNew:(0,r.register)("gist-new",6e4),repoCreate:(0,r.register)("repo-create",6e4),lightbulb:(0,r.register)("lightbulb",60001),lightBulb:(0,r.register)("light-bulb",60001),repo:(0,r.register)("repo",60002),repoDelete:(0,r.register)("repo-delete",60002),gistFork:(0,r.register)("gist-fork",60003),repoForked:(0,r.register)("repo-forked",60003),gitPullRequest:(0,r.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.register)("git-pull-request-abandoned",60004),recordKeys:(0,r.register)("record-keys",60005),keyboard:(0,r.register)("keyboard",60005),tag:(0,r.register)("tag",60006),gitPullRequestLabel:(0,r.register)("git-pull-request-label",60006),tagAdd:(0,r.register)("tag-add",60006),tagRemove:(0,r.register)("tag-remove",60006),person:(0,r.register)("person",60007),personFollow:(0,r.register)("person-follow",60007),personOutline:(0,r.register)("person-outline",60007),personFilled:(0,r.register)("person-filled",60007),gitBranch:(0,r.register)("git-branch",60008),gitBranchCreate:(0,r.register)("git-branch-create",60008),gitBranchDelete:(0,r.register)("git-branch-delete",60008),sourceControl:(0,r.register)("source-control",60008),mirror:(0,r.register)("mirror",60009),mirrorPublic:(0,r.register)("mirror-public",60009),star:(0,r.register)("star",60010),starAdd:(0,r.register)("star-add",60010),starDelete:(0,r.register)("star-delete",60010),starEmpty:(0,r.register)("star-empty",60010),comment:(0,r.register)("comment",60011),commentAdd:(0,r.register)("comment-add",60011),alert:(0,r.register)("alert",60012),warning:(0,r.register)("warning",60012),search:(0,r.register)("search",60013),searchSave:(0,r.register)("search-save",60013),logOut:(0,r.register)("log-out",60014),signOut:(0,r.register)("sign-out",60014),logIn:(0,r.register)("log-in",60015),signIn:(0,r.register)("sign-in",60015),eye:(0,r.register)("eye",60016),eyeUnwatch:(0,r.register)("eye-unwatch",60016),eyeWatch:(0,r.register)("eye-watch",60016),circleFilled:(0,r.register)("circle-filled",60017),primitiveDot:(0,r.register)("primitive-dot",60017),closeDirty:(0,r.register)("close-dirty",60017),debugBreakpoint:(0,r.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.register)("debug-breakpoint-disabled",60017),debugHint:(0,r.register)("debug-hint",60017),terminalDecorationSuccess:(0,r.register)("terminal-decoration-success",60017),primitiveSquare:(0,r.register)("primitive-square",60018),edit:(0,r.register)("edit",60019),pencil:(0,r.register)("pencil",60019),info:(0,r.register)("info",60020),issueOpened:(0,r.register)("issue-opened",60020),gistPrivate:(0,r.register)("gist-private",60021),gitForkPrivate:(0,r.register)("git-fork-private",60021),lock:(0,r.register)("lock",60021),mirrorPrivate:(0,r.register)("mirror-private",60021),close:(0,r.register)("close",60022),removeClose:(0,r.register)("remove-close",60022),x:(0,r.register)("x",60022),repoSync:(0,r.register)("repo-sync",60023),sync:(0,r.register)("sync",60023),clone:(0,r.register)("clone",60024),desktopDownload:(0,r.register)("desktop-download",60024),beaker:(0,r.register)("beaker",60025),microscope:(0,r.register)("microscope",60025),vm:(0,r.register)("vm",60026),deviceDesktop:(0,r.register)("device-desktop",60026),file:(0,r.register)("file",60027),fileText:(0,r.register)("file-text",60027),more:(0,r.register)("more",60028),ellipsis:(0,r.register)("ellipsis",60028),kebabHorizontal:(0,r.register)("kebab-horizontal",60028),mailReply:(0,r.register)("mail-reply",60029),reply:(0,r.register)("reply",60029),organization:(0,r.register)("organization",60030),organizationFilled:(0,r.register)("organization-filled",60030),organizationOutline:(0,r.register)("organization-outline",60030),newFile:(0,r.register)("new-file",60031),fileAdd:(0,r.register)("file-add",60031),newFolder:(0,r.register)("new-folder",60032),fileDirectoryCreate:(0,r.register)("file-directory-create",60032),trash:(0,r.register)("trash",60033),trashcan:(0,r.register)("trashcan",60033),history:(0,r.register)("history",60034),clock:(0,r.register)("clock",60034),folder:(0,r.register)("folder",60035),fileDirectory:(0,r.register)("file-directory",60035),symbolFolder:(0,r.register)("symbol-folder",60035),logoGithub:(0,r.register)("logo-github",60036),markGithub:(0,r.register)("mark-github",60036),github:(0,r.register)("github",60036),terminal:(0,r.register)("terminal",60037),console:(0,r.register)("console",60037),repl:(0,r.register)("repl",60037),zap:(0,r.register)("zap",60038),symbolEvent:(0,r.register)("symbol-event",60038),error:(0,r.register)("error",60039),stop:(0,r.register)("stop",60039),variable:(0,r.register)("variable",60040),symbolVariable:(0,r.register)("symbol-variable",60040),array:(0,r.register)("array",60042),symbolArray:(0,r.register)("symbol-array",60042),symbolModule:(0,r.register)("symbol-module",60043),symbolPackage:(0,r.register)("symbol-package",60043),symbolNamespace:(0,r.register)("symbol-namespace",60043),symbolObject:(0,r.register)("symbol-object",60043),symbolMethod:(0,r.register)("symbol-method",60044),symbolFunction:(0,r.register)("symbol-function",60044),symbolConstructor:(0,r.register)("symbol-constructor",60044),symbolBoolean:(0,r.register)("symbol-boolean",60047),symbolNull:(0,r.register)("symbol-null",60047),symbolNumeric:(0,r.register)("symbol-numeric",60048),symbolNumber:(0,r.register)("symbol-number",60048),symbolStructure:(0,r.register)("symbol-structure",60049),symbolStruct:(0,r.register)("symbol-struct",60049),symbolParameter:(0,r.register)("symbol-parameter",60050),symbolTypeParameter:(0,r.register)("symbol-type-parameter",60050),symbolKey:(0,r.register)("symbol-key",60051),symbolText:(0,r.register)("symbol-text",60051),symbolReference:(0,r.register)("symbol-reference",60052),goToFile:(0,r.register)("go-to-file",60052),symbolEnum:(0,r.register)("symbol-enum",60053),symbolValue:(0,r.register)("symbol-value",60053),symbolRuler:(0,r.register)("symbol-ruler",60054),symbolUnit:(0,r.register)("symbol-unit",60054),activateBreakpoints:(0,r.register)("activate-breakpoints",60055),archive:(0,r.register)("archive",60056),arrowBoth:(0,r.register)("arrow-both",60057),arrowDown:(0,r.register)("arrow-down",60058),arrowLeft:(0,r.register)("arrow-left",60059),arrowRight:(0,r.register)("arrow-right",60060),arrowSmallDown:(0,r.register)("arrow-small-down",60061),arrowSmallLeft:(0,r.register)("arrow-small-left",60062),arrowSmallRight:(0,r.register)("arrow-small-right",60063),arrowSmallUp:(0,r.register)("arrow-small-up",60064),arrowUp:(0,r.register)("arrow-up",60065),bell:(0,r.register)("bell",60066),bold:(0,r.register)("bold",60067),book:(0,r.register)("book",60068),bookmark:(0,r.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.register)("briefcase",60076),broadcast:(0,r.register)("broadcast",60077),browser:(0,r.register)("browser",60078),bug:(0,r.register)("bug",60079),calendar:(0,r.register)("calendar",60080),caseSensitive:(0,r.register)("case-sensitive",60081),check:(0,r.register)("check",60082),checklist:(0,r.register)("checklist",60083),chevronDown:(0,r.register)("chevron-down",60084),chevronLeft:(0,r.register)("chevron-left",60085),chevronRight:(0,r.register)("chevron-right",60086),chevronUp:(0,r.register)("chevron-up",60087),chromeClose:(0,r.register)("chrome-close",60088),chromeMaximize:(0,r.register)("chrome-maximize",60089),chromeMinimize:(0,r.register)("chrome-minimize",60090),chromeRestore:(0,r.register)("chrome-restore",60091),circleOutline:(0,r.register)("circle-outline",60092),circle:(0,r.register)("circle",60092),debugBreakpointUnverified:(0,r.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.register)("terminal-decoration-incomplete",60092),circleSlash:(0,r.register)("circle-slash",60093),circuitBoard:(0,r.register)("circuit-board",60094),clearAll:(0,r.register)("clear-all",60095),clippy:(0,r.register)("clippy",60096),closeAll:(0,r.register)("close-all",60097),cloudDownload:(0,r.register)("cloud-download",60098),cloudUpload:(0,r.register)("cloud-upload",60099),code:(0,r.register)("code",60100),collapseAll:(0,r.register)("collapse-all",60101),colorMode:(0,r.register)("color-mode",60102),commentDiscussion:(0,r.register)("comment-discussion",60103),creditCard:(0,r.register)("credit-card",60105),dash:(0,r.register)("dash",60108),dashboard:(0,r.register)("dashboard",60109),database:(0,r.register)("database",60110),debugContinue:(0,r.register)("debug-continue",60111),debugDisconnect:(0,r.register)("debug-disconnect",60112),debugPause:(0,r.register)("debug-pause",60113),debugRestart:(0,r.register)("debug-restart",60114),debugStart:(0,r.register)("debug-start",60115),debugStepInto:(0,r.register)("debug-step-into",60116),debugStepOut:(0,r.register)("debug-step-out",60117),debugStepOver:(0,r.register)("debug-step-over",60118),debugStop:(0,r.register)("debug-stop",60119),debug:(0,r.register)("debug",60120),deviceCameraVideo:(0,r.register)("device-camera-video",60121),deviceCamera:(0,r.register)("device-camera",60122),deviceMobile:(0,r.register)("device-mobile",60123),diffAdded:(0,r.register)("diff-added",60124),diffIgnored:(0,r.register)("diff-ignored",60125),diffModified:(0,r.register)("diff-modified",60126),diffRemoved:(0,r.register)("diff-removed",60127),diffRenamed:(0,r.register)("diff-renamed",60128),diff:(0,r.register)("diff",60129),diffSidebyside:(0,r.register)("diff-sidebyside",60129),discard:(0,r.register)("discard",60130),editorLayout:(0,r.register)("editor-layout",60131),emptyWindow:(0,r.register)("empty-window",60132),exclude:(0,r.register)("exclude",60133),extensions:(0,r.register)("extensions",60134),eyeClosed:(0,r.register)("eye-closed",60135),fileBinary:(0,r.register)("file-binary",60136),fileCode:(0,r.register)("file-code",60137),fileMedia:(0,r.register)("file-media",60138),filePdf:(0,r.register)("file-pdf",60139),fileSubmodule:(0,r.register)("file-submodule",60140),fileSymlinkDirectory:(0,r.register)("file-symlink-directory",60141),fileSymlinkFile:(0,r.register)("file-symlink-file",60142),fileZip:(0,r.register)("file-zip",60143),files:(0,r.register)("files",60144),filter:(0,r.register)("filter",60145),flame:(0,r.register)("flame",60146),foldDown:(0,r.register)("fold-down",60147),foldUp:(0,r.register)("fold-up",60148),fold:(0,r.register)("fold",60149),folderActive:(0,r.register)("folder-active",60150),folderOpened:(0,r.register)("folder-opened",60151),gear:(0,r.register)("gear",60152),gift:(0,r.register)("gift",60153),gistSecret:(0,r.register)("gist-secret",60154),gist:(0,r.register)("gist",60155),gitCommit:(0,r.register)("git-commit",60156),gitCompare:(0,r.register)("git-compare",60157),compareChanges:(0,r.register)("compare-changes",60157),gitMerge:(0,r.register)("git-merge",60158),githubAction:(0,r.register)("github-action",60159),githubAlt:(0,r.register)("github-alt",60160),globe:(0,r.register)("globe",60161),grabber:(0,r.register)("grabber",60162),graph:(0,r.register)("graph",60163),gripper:(0,r.register)("gripper",60164),heart:(0,r.register)("heart",60165),home:(0,r.register)("home",60166),horizontalRule:(0,r.register)("horizontal-rule",60167),hubot:(0,r.register)("hubot",60168),inbox:(0,r.register)("inbox",60169),issueReopened:(0,r.register)("issue-reopened",60171),issues:(0,r.register)("issues",60172),italic:(0,r.register)("italic",60173),jersey:(0,r.register)("jersey",60174),json:(0,r.register)("json",60175),kebabVertical:(0,r.register)("kebab-vertical",60176),key:(0,r.register)("key",60177),law:(0,r.register)("law",60178),lightbulbAutofix:(0,r.register)("lightbulb-autofix",60179),linkExternal:(0,r.register)("link-external",60180),link:(0,r.register)("link",60181),listOrdered:(0,r.register)("list-ordered",60182),listUnordered:(0,r.register)("list-unordered",60183),liveShare:(0,r.register)("live-share",60184),loading:(0,r.register)("loading",60185),location:(0,r.register)("location",60186),mailRead:(0,r.register)("mail-read",60187),mail:(0,r.register)("mail",60188),markdown:(0,r.register)("markdown",60189),megaphone:(0,r.register)("megaphone",60190),mention:(0,r.register)("mention",60191),milestone:(0,r.register)("milestone",60192),gitPullRequestMilestone:(0,r.register)("git-pull-request-milestone",60192),mortarBoard:(0,r.register)("mortar-board",60193),move:(0,r.register)("move",60194),multipleWindows:(0,r.register)("multiple-windows",60195),mute:(0,r.register)("mute",60196),noNewline:(0,r.register)("no-newline",60197),note:(0,r.register)("note",60198),octoface:(0,r.register)("octoface",60199),openPreview:(0,r.register)("open-preview",60200),package:(0,r.register)("package",60201),paintcan:(0,r.register)("paintcan",60202),pin:(0,r.register)("pin",60203),play:(0,r.register)("play",60204),run:(0,r.register)("run",60204),plug:(0,r.register)("plug",60205),preserveCase:(0,r.register)("preserve-case",60206),preview:(0,r.register)("preview",60207),project:(0,r.register)("project",60208),pulse:(0,r.register)("pulse",60209),question:(0,r.register)("question",60210),quote:(0,r.register)("quote",60211),radioTower:(0,r.register)("radio-tower",60212),reactions:(0,r.register)("reactions",60213),references:(0,r.register)("references",60214),refresh:(0,r.register)("refresh",60215),regex:(0,r.register)("regex",60216),remoteExplorer:(0,r.register)("remote-explorer",60217),remote:(0,r.register)("remote",60218),remove:(0,r.register)("remove",60219),replaceAll:(0,r.register)("replace-all",60220),replace:(0,r.register)("replace",60221),repoClone:(0,r.register)("repo-clone",60222),repoForcePush:(0,r.register)("repo-force-push",60223),repoPull:(0,r.register)("repo-pull",60224),repoPush:(0,r.register)("repo-push",60225),report:(0,r.register)("report",60226),requestChanges:(0,r.register)("request-changes",60227),rocket:(0,r.register)("rocket",60228),rootFolderOpened:(0,r.register)("root-folder-opened",60229),rootFolder:(0,r.register)("root-folder",60230),rss:(0,r.register)("rss",60231),ruby:(0,r.register)("ruby",60232),saveAll:(0,r.register)("save-all",60233),saveAs:(0,r.register)("save-as",60234),save:(0,r.register)("save",60235),screenFull:(0,r.register)("screen-full",60236),screenNormal:(0,r.register)("screen-normal",60237),searchStop:(0,r.register)("search-stop",60238),server:(0,r.register)("server",60240),settingsGear:(0,r.register)("settings-gear",60241),settings:(0,r.register)("settings",60242),shield:(0,r.register)("shield",60243),smiley:(0,r.register)("smiley",60244),sortPrecedence:(0,r.register)("sort-precedence",60245),splitHorizontal:(0,r.register)("split-horizontal",60246),splitVertical:(0,r.register)("split-vertical",60247),squirrel:(0,r.register)("squirrel",60248),starFull:(0,r.register)("star-full",60249),starHalf:(0,r.register)("star-half",60250),symbolClass:(0,r.register)("symbol-class",60251),symbolColor:(0,r.register)("symbol-color",60252),symbolConstant:(0,r.register)("symbol-constant",60253),symbolEnumMember:(0,r.register)("symbol-enum-member",60254),symbolField:(0,r.register)("symbol-field",60255),symbolFile:(0,r.register)("symbol-file",60256),symbolInterface:(0,r.register)("symbol-interface",60257),symbolKeyword:(0,r.register)("symbol-keyword",60258),symbolMisc:(0,r.register)("symbol-misc",60259),symbolOperator:(0,r.register)("symbol-operator",60260),symbolProperty:(0,r.register)("symbol-property",60261),wrench:(0,r.register)("wrench",60261),wrenchSubaction:(0,r.register)("wrench-subaction",60261),symbolSnippet:(0,r.register)("symbol-snippet",60262),tasklist:(0,r.register)("tasklist",60263),telescope:(0,r.register)("telescope",60264),textSize:(0,r.register)("text-size",60265),threeBars:(0,r.register)("three-bars",60266),thumbsdown:(0,r.register)("thumbsdown",60267),thumbsup:(0,r.register)("thumbsup",60268),tools:(0,r.register)("tools",60269),triangleDown:(0,r.register)("triangle-down",60270),triangleLeft:(0,r.register)("triangle-left",60271),triangleRight:(0,r.register)("triangle-right",60272),triangleUp:(0,r.register)("triangle-up",60273),twitter:(0,r.register)("twitter",60274),unfold:(0,r.register)("unfold",60275),unlock:(0,r.register)("unlock",60276),unmute:(0,r.register)("unmute",60277),unverified:(0,r.register)("unverified",60278),verified:(0,r.register)("verified",60279),versions:(0,r.register)("versions",60280),vmActive:(0,r.register)("vm-active",60281),vmOutline:(0,r.register)("vm-outline",60282),vmRunning:(0,r.register)("vm-running",60283),watch:(0,r.register)("watch",60284),whitespace:(0,r.register)("whitespace",60285),wholeWord:(0,r.register)("whole-word",60286),window:(0,r.register)("window",60287),wordWrap:(0,r.register)("word-wrap",60288),zoomIn:(0,r.register)("zoom-in",60289),zoomOut:(0,r.register)("zoom-out",60290),listFilter:(0,r.register)("list-filter",60291),listFlat:(0,r.register)("list-flat",60292),listSelection:(0,r.register)("list-selection",60293),selection:(0,r.register)("selection",60293),listTree:(0,r.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.register)("debug-stackframe-active",60297),circleSmallFilled:(0,r.register)("circle-small-filled",60298),debugStackframeDot:(0,r.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.register)("terminal-decoration-mark",60298),debugStackframe:(0,r.register)("debug-stackframe",60299),debugStackframeFocused:(0,r.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.register)("debug-breakpoint-unsupported",60300),symbolString:(0,r.register)("symbol-string",60301),debugReverseContinue:(0,r.register)("debug-reverse-continue",60302),debugStepBack:(0,r.register)("debug-step-back",60303),debugRestartFrame:(0,r.register)("debug-restart-frame",60304),debugAlt:(0,r.register)("debug-alt",60305),callIncoming:(0,r.register)("call-incoming",60306),callOutgoing:(0,r.register)("call-outgoing",60307),menu:(0,r.register)("menu",60308),expandAll:(0,r.register)("expand-all",60309),feedback:(0,r.register)("feedback",60310),gitPullRequestReviewer:(0,r.register)("git-pull-request-reviewer",60310),groupByRefType:(0,r.register)("group-by-ref-type",60311),ungroupByRefType:(0,r.register)("ungroup-by-ref-type",60312),account:(0,r.register)("account",60313),gitPullRequestAssignee:(0,r.register)("git-pull-request-assignee",60313),bellDot:(0,r.register)("bell-dot",60314),debugConsole:(0,r.register)("debug-console",60315),library:(0,r.register)("library",60316),output:(0,r.register)("output",60317),runAll:(0,r.register)("run-all",60318),syncIgnored:(0,r.register)("sync-ignored",60319),pinned:(0,r.register)("pinned",60320),githubInverted:(0,r.register)("github-inverted",60321),serverProcess:(0,r.register)("server-process",60322),serverEnvironment:(0,r.register)("server-environment",60323),pass:(0,r.register)("pass",60324),issueClosed:(0,r.register)("issue-closed",60324),stopCircle:(0,r.register)("stop-circle",60325),playCircle:(0,r.register)("play-circle",60326),record:(0,r.register)("record",60327),debugAltSmall:(0,r.register)("debug-alt-small",60328),vmConnect:(0,r.register)("vm-connect",60329),cloud:(0,r.register)("cloud",60330),merge:(0,r.register)("merge",60331),export:(0,r.register)("export",60332),graphLeft:(0,r.register)("graph-left",60333),magnet:(0,r.register)("magnet",60334),notebook:(0,r.register)("notebook",60335),redo:(0,r.register)("redo",60336),checkAll:(0,r.register)("check-all",60337),pinnedDirty:(0,r.register)("pinned-dirty",60338),passFilled:(0,r.register)("pass-filled",60339),circleLargeFilled:(0,r.register)("circle-large-filled",60340),circleLarge:(0,r.register)("circle-large",60341),circleLargeOutline:(0,r.register)("circle-large-outline",60341),combine:(0,r.register)("combine",60342),gather:(0,r.register)("gather",60342),table:(0,r.register)("table",60343),variableGroup:(0,r.register)("variable-group",60344),typeHierarchy:(0,r.register)("type-hierarchy",60345),typeHierarchySub:(0,r.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.register)("git-pull-request-create",60348),runAbove:(0,r.register)("run-above",60349),runBelow:(0,r.register)("run-below",60350),notebookTemplate:(0,r.register)("notebook-template",60351),debugRerun:(0,r.register)("debug-rerun",60352),workspaceTrusted:(0,r.register)("workspace-trusted",60353),workspaceUntrusted:(0,r.register)("workspace-untrusted",60354),workspaceUnknown:(0,r.register)("workspace-unknown",60355),terminalCmd:(0,r.register)("terminal-cmd",60356),terminalDebian:(0,r.register)("terminal-debian",60357),terminalLinux:(0,r.register)("terminal-linux",60358),terminalPowershell:(0,r.register)("terminal-powershell",60359),terminalTmux:(0,r.register)("terminal-tmux",60360),terminalUbuntu:(0,r.register)("terminal-ubuntu",60361),terminalBash:(0,r.register)("terminal-bash",60362),arrowSwap:(0,r.register)("arrow-swap",60363),copy:(0,r.register)("copy",60364),personAdd:(0,r.register)("person-add",60365),filterFilled:(0,r.register)("filter-filled",60366),wand:(0,r.register)("wand",60367),debugLineByLine:(0,r.register)("debug-line-by-line",60368),inspect:(0,r.register)("inspect",60369),layers:(0,r.register)("layers",60370),layersDot:(0,r.register)("layers-dot",60371),layersActive:(0,r.register)("layers-active",60372),compass:(0,r.register)("compass",60373),compassDot:(0,r.register)("compass-dot",60374),compassActive:(0,r.register)("compass-active",60375),azure:(0,r.register)("azure",60376),issueDraft:(0,r.register)("issue-draft",60377),gitPullRequestClosed:(0,r.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.register)("git-pull-request-draft",60379),debugAll:(0,r.register)("debug-all",60380),debugCoverage:(0,r.register)("debug-coverage",60381),runErrors:(0,r.register)("run-errors",60382),folderLibrary:(0,r.register)("folder-library",60383),debugContinueSmall:(0,r.register)("debug-continue-small",60384),beakerStop:(0,r.register)("beaker-stop",60385),graphLine:(0,r.register)("graph-line",60386),graphScatter:(0,r.register)("graph-scatter",60387),pieChart:(0,r.register)("pie-chart",60388),bracket:(0,r.register)("bracket",60175),bracketDot:(0,r.register)("bracket-dot",60389),bracketError:(0,r.register)("bracket-error",60390),lockSmall:(0,r.register)("lock-small",60391),azureDevops:(0,r.register)("azure-devops",60392),verifiedFilled:(0,r.register)("verified-filled",60393),newline:(0,r.register)("newline",60394),layout:(0,r.register)("layout",60395),layoutActivitybarLeft:(0,r.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.register)("layout-panel-left",60398),layoutPanelCenter:(0,r.register)("layout-panel-center",60399),layoutPanelJustify:(0,r.register)("layout-panel-justify",60400),layoutPanelRight:(0,r.register)("layout-panel-right",60401),layoutPanel:(0,r.register)("layout-panel",60402),layoutSidebarLeft:(0,r.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.register)("layout-sidebar-right",60404),layoutStatusbar:(0,r.register)("layout-statusbar",60405),layoutMenubar:(0,r.register)("layout-menubar",60406),layoutCentered:(0,r.register)("layout-centered",60407),target:(0,r.register)("target",60408),indent:(0,r.register)("indent",60409),recordSmall:(0,r.register)("record-small",60410),errorSmall:(0,r.register)("error-small",60411),terminalDecorationError:(0,r.register)("terminal-decoration-error",60411),arrowCircleDown:(0,r.register)("arrow-circle-down",60412),arrowCircleLeft:(0,r.register)("arrow-circle-left",60413),arrowCircleRight:(0,r.register)("arrow-circle-right",60414),arrowCircleUp:(0,r.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.register)("layout-sidebar-left-off",60418),blank:(0,r.register)("blank",60419),heartFilled:(0,r.register)("heart-filled",60420),map:(0,r.register)("map",60421),mapFilled:(0,r.register)("map-filled",60422),circleSmall:(0,r.register)("circle-small",60423),bellSlash:(0,r.register)("bell-slash",60424),bellSlashDot:(0,r.register)("bell-slash-dot",60425),commentUnresolved:(0,r.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.register)("search-fuzzy",60429),commentDraft:(0,r.register)("comment-draft",60430),send:(0,r.register)("send",60431),sparkle:(0,r.register)("sparkle",60432),insert:(0,r.register)("insert",60433),mic:(0,r.register)("mic",60434),thumbsdownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsupFilled:(0,r.register)("thumbsup-filled",60436),coffee:(0,r.register)("coffee",60437),snake:(0,r.register)("snake",60438),game:(0,r.register)("game",60439),vr:(0,r.register)("vr",60440),chip:(0,r.register)("chip",60441),piano:(0,r.register)("piano",60442),music:(0,r.register)("music",60443),micFilled:(0,r.register)("mic-filled",60444),repoFetch:(0,r.register)("repo-fetch",60445),copilot:(0,r.register)("copilot",60446),lightbulbSparkle:(0,r.register)("lightbulb-sparkle",60447),robot:(0,r.register)("robot",60448),sparkleFilled:(0,r.register)("sparkle-filled",60449),diffSingle:(0,r.register)("diff-single",60450),diffMultiple:(0,r.register)("diff-multiple",60451),surroundWith:(0,r.register)("surround-with",60452),share:(0,r.register)("share",60453),gitStash:(0,r.register)("git-stash",60454),gitStashApply:(0,r.register)("git-stash-apply",60455),gitStashPop:(0,r.register)("git-stash-pop",60456),vscode:(0,r.register)("vscode",60457),vscodeInsiders:(0,r.register)("vscode-insiders",60458),codeOss:(0,r.register)("code-oss",60459),runCoverage:(0,r.register)("run-coverage",60460),runAllCoverage:(0,r.register)("run-all-coverage",60461),coverage:(0,r.register)("coverage",60462),githubProject:(0,r.register)("github-project",60463)}}),Y(J[42],Z([0,1,26,41]),function(B,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.codiconsDerived=void 0,n.codiconsDerived={dialogError:(0,r.register)("dialog-error","error"),dialogWarning:(0,r.register)("dialog-warning","warning"),dialogInfo:(0,r.register)("dialog-info","info"),dialogClose:(0,r.register)("dialog-close","close"),treeItemExpanded:(0,r.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.register)("tree-filter-clear","close"),treeItemLoading:(0,r.register)("tree-item-loading","loading"),menuSelection:(0,r.register)("menu-selection","check"),menuSubmenu:(0,r.register)("menu-submenu","chevron-right"),menuBarMore:(0,r.register)("menubar-more","more"),scrollbarButtonLeft:(0,r.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.register)("toolbar-more","more"),quickInputBack:(0,r.register)("quick-input-back","arrow-left"),dropDownButton:(0,r.register)("drop-down-button",60084),symbolCustomColor:(0,r.register)("symbol-customcolor",60252),exportIcon:(0,r.register)("export",60332),workspaceUnspecified:(0,r.register)("workspace-unspecified",60355),newLine:(0,r.register)("newline",60394),thumbsDownFilled:(0,r.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.register)("thumbsup-filled",60436),gitFetch:(0,r.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.register)("debug-breakpoint-pending",60377)},n.Codicon={...x.codiconsLibrary,...n.codiconsDerived}}),Y(J[14],Z([0,1,25]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.deepClone=x,n.deepFreeze=A,n.cloneAndChange=m,n.mixin=h,n.equals=l,n.getAllPropertyNames=L,n.getAllMethodNames=e,n.createProxyObject=s;function x(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const u=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([g,f])=>{u[g]=f&&typeof f=="object"?x(f):f}),u}function A(o){if(!o||typeof o!="object")return o;const u=[o];for(;u.length>0;){const g=u.shift();Object.freeze(g);for(const f in g)if(c.call(g,f)){const E=g[f];typeof E=="object"&&!Object.isFrozen(E)&&!(0,r.isTypedArray)(E)&&u.push(E)}}return o}const c=Object.prototype.hasOwnProperty;function m(o,u){return v(o,u,new Set)}function v(o,u,g){if((0,r.isUndefinedOrNull)(o))return o;const f=u(o);if(typeof f<"u")return f;if(Array.isArray(o)){const E=[];for(const _ of o)E.push(v(_,u,g));return E}if((0,r.isObject)(o)){if(g.has(o))throw new Error("Cannot clone recursive data-structure");g.add(o);const E={};for(const _ in o)c.call(o,_)&&(E[_]=v(o[_],u,g));return g.delete(o),E}return o}function h(o,u,g=!0){return(0,r.isObject)(o)?((0,r.isObject)(u)&&Object.keys(u).forEach(f=>{f in o?g&&((0,r.isObject)(o[f])&&(0,r.isObject)(u[f])?h(o[f],u[f],g):o[f]=u[f]):o[f]=u[f]}),o):u}function l(o,u){if(o===u)return!0;if(o==null||u===null||u===void 0||typeof o!=typeof u||typeof o!="object"||Array.isArray(o)!==Array.isArray(u))return!1;let g,f;if(Array.isArray(o)){if(o.length!==u.length)return!1;for(g=0;g<o.length;g++)if(!l(o[g],u[g]))return!1}else{const E=[];for(f in o)E.push(f);E.sort();const _=[];for(f in u)_.push(f);if(_.sort(),!l(E,_))return!1;for(g=0;g<E.length;g++)if(!l(o[E[g]],u[E[g]]))return!1}return!0}function L(o){let u=[];for(;Object.prototype!==o;)u=u.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return u}function e(o){const u=[];for(const g of L(o))typeof o[g]=="function"&&u.push(g);return u}function s(o,u){const g=E=>function(){const _=Array.prototype.slice.call(arguments,0);return u(E,_)},f={};for(const E of o)f[E]=g(E);return f}}),Y(J[27],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint8=r,n.toUint32=x;function r(A){return A<0?0:A>255?255:A|0}function x(A){return A<0?0:A>4294967295?4294967295:A|0}}),Y(J[28],Z([0,1,27]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class x{constructor(m){const v=(0,r.toUint8)(m);this._defaultValue=v,this._asciiMap=x._createAsciiMap(v),this._map=new Map}static _createAsciiMap(m){const v=new Uint8Array(256);return v.fill(m),v}set(m,v){const h=(0,r.toUint8)(v);m>=0&&m<256?this._asciiMap[m]=h:this._map.set(m,h)}get(m){return m>=0&&m<256?this._asciiMap[m]:this._map.get(m)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=x;class A{constructor(){this._actual=new x(0)}add(m){this._actual.set(m,1)}has(m){return this._actual.get(m)===1}clear(){return this._actual.clear()}}n.CharacterSet=A}),Y(J[3],Z([0,1,5]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRangeSet=n.OffsetRange=void 0;class x{static addRange(m,v){let h=0;for(;h<v.length&&v[h].endExclusive<m.start;)h++;let l=h;for(;l<v.length&&v[l].start<=m.endExclusive;)l++;if(h===l)v.splice(h,0,m);else{const L=Math.min(m.start,v[h].start),e=Math.max(m.endExclusive,v[l-1].endExclusive);v.splice(h,l-h,new x(L,e))}}static ofLength(m){return new x(0,m)}static ofStartAndLength(m,v){return new x(m,m+v)}constructor(m,v){if(this.start=m,this.endExclusive=v,m>v)throw new r.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(m){return new x(this.start+m,this.endExclusive+m)}deltaStart(m){return new x(this.start+m,this.endExclusive)}deltaEnd(m){return new x(this.start,this.endExclusive+m)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}contains(m){return this.start<=m&&m<this.endExclusive}join(m){return new x(Math.min(this.start,m.start),Math.max(this.endExclusive,m.endExclusive))}intersect(m){const v=Math.max(this.start,m.start),h=Math.min(this.endExclusive,m.endExclusive);if(v<=h)return new x(v,h)}intersects(m){const v=Math.max(this.start,m.start),h=Math.min(this.endExclusive,m.endExclusive);return v<h}isBefore(m){return this.endExclusive<=m.start}isAfter(m){return this.start>=m.endExclusive}slice(m){return m.slice(this.start,this.endExclusive)}substring(m){return m.substring(this.start,this.endExclusive)}clip(m){if(this.isEmpty)throw new r.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,m))}clipCyclic(m){if(this.isEmpty)throw new r.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return m<this.start?this.endExclusive-(this.start-m)%this.length:m>=this.endExclusive?this.start+(m-this.start)%this.length:m}forEach(m){for(let v=this.start;v<this.endExclusive;v++)m(v)}}n.OffsetRange=x;class A{constructor(){this._sortedRanges=[]}addRange(m){let v=0;for(;v<this._sortedRanges.length&&this._sortedRanges[v].endExclusive<m.start;)v++;let h=v;for(;h<this._sortedRanges.length&&this._sortedRanges[h].start<=m.endExclusive;)h++;if(v===h)this._sortedRanges.splice(v,0,m);else{const l=Math.min(m.start,this._sortedRanges[v].start),L=Math.max(m.endExclusive,this._sortedRanges[h-1].endExclusive);this._sortedRanges.splice(v,h-v,new x(l,L))}}toString(){return this._sortedRanges.map(m=>m.toString()).join(", ")}intersectsStrict(m){let v=0;for(;v<this._sortedRanges.length&&this._sortedRanges[v].endExclusive<=m.start;)v++;return v<this._sortedRanges.length&&this._sortedRanges[v].start<m.endExclusive}intersectWithRange(m){const v=new A;for(const h of this._sortedRanges){const l=h.intersect(m);l&&v.addRange(l)}return v}intersectWithRangeLength(m){return this.intersectWithRange(m).length}get length(){return this._sortedRanges.reduce((m,v)=>m+v.length,0)}}n.OffsetRangeSet=A}),Y(J[4],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class r{constructor(A,c){this.lineNumber=A,this.column=c}with(A=this.lineNumber,c=this.column){return A===this.lineNumber&&c===this.column?this:new r(A,c)}delta(A=0,c=0){return this.with(this.lineNumber+A,this.column+c)}equals(A){return r.equals(this,A)}static equals(A,c){return!A&&!c?!0:!!A&&!!c&&A.lineNumber===c.lineNumber&&A.column===c.column}isBefore(A){return r.isBefore(this,A)}static isBefore(A,c){return A.lineNumber<c.lineNumber?!0:c.lineNumber<A.lineNumber?!1:A.column<c.column}isBeforeOrEqual(A){return r.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,c){return A.lineNumber<c.lineNumber?!0:c.lineNumber<A.lineNumber?!1:A.column<=c.column}static compare(A,c){const m=A.lineNumber|0,v=c.lineNumber|0;if(m===v){const h=A.column|0,l=c.column|0;return h-l}return m-v}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new r(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}n.Position=r}),Y(J[2],Z([0,1,4]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class x{constructor(c,m,v,h){c>v||c===v&&m>h?(this.startLineNumber=v,this.startColumn=h,this.endLineNumber=c,this.endColumn=m):(this.startLineNumber=c,this.startColumn=m,this.endLineNumber=v,this.endColumn=h)}isEmpty(){return x.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return x.containsPosition(this,c)}static containsPosition(c,m){return!(m.lineNumber<c.startLineNumber||m.lineNumber>c.endLineNumber||m.lineNumber===c.startLineNumber&&m.column<c.startColumn||m.lineNumber===c.endLineNumber&&m.column>c.endColumn)}static strictContainsPosition(c,m){return!(m.lineNumber<c.startLineNumber||m.lineNumber>c.endLineNumber||m.lineNumber===c.startLineNumber&&m.column<=c.startColumn||m.lineNumber===c.endLineNumber&&m.column>=c.endColumn)}containsRange(c){return x.containsRange(this,c)}static containsRange(c,m){return!(m.startLineNumber<c.startLineNumber||m.endLineNumber<c.startLineNumber||m.startLineNumber>c.endLineNumber||m.endLineNumber>c.endLineNumber||m.startLineNumber===c.startLineNumber&&m.startColumn<c.startColumn||m.endLineNumber===c.endLineNumber&&m.endColumn>c.endColumn)}strictContainsRange(c){return x.strictContainsRange(this,c)}static strictContainsRange(c,m){return!(m.startLineNumber<c.startLineNumber||m.endLineNumber<c.startLineNumber||m.startLineNumber>c.endLineNumber||m.endLineNumber>c.endLineNumber||m.startLineNumber===c.startLineNumber&&m.startColumn<=c.startColumn||m.endLineNumber===c.endLineNumber&&m.endColumn>=c.endColumn)}plusRange(c){return x.plusRange(this,c)}static plusRange(c,m){let v,h,l,L;return m.startLineNumber<c.startLineNumber?(v=m.startLineNumber,h=m.startColumn):m.startLineNumber===c.startLineNumber?(v=m.startLineNumber,h=Math.min(m.startColumn,c.startColumn)):(v=c.startLineNumber,h=c.startColumn),m.endLineNumber>c.endLineNumber?(l=m.endLineNumber,L=m.endColumn):m.endLineNumber===c.endLineNumber?(l=m.endLineNumber,L=Math.max(m.endColumn,c.endColumn)):(l=c.endLineNumber,L=c.endColumn),new x(v,h,l,L)}intersectRanges(c){return x.intersectRanges(this,c)}static intersectRanges(c,m){let v=c.startLineNumber,h=c.startColumn,l=c.endLineNumber,L=c.endColumn;const e=m.startLineNumber,s=m.startColumn,o=m.endLineNumber,u=m.endColumn;return v<e?(v=e,h=s):v===e&&(h=Math.max(h,s)),l>o?(l=o,L=u):l===o&&(L=Math.min(L,u)),v>l||v===l&&h>L?null:new x(v,h,l,L)}equalsRange(c){return x.equalsRange(this,c)}static equalsRange(c,m){return!c&&!m?!0:!!c&&!!m&&c.startLineNumber===m.startLineNumber&&c.startColumn===m.startColumn&&c.endLineNumber===m.endLineNumber&&c.endColumn===m.endColumn}getEndPosition(){return x.getEndPosition(this)}static getEndPosition(c){return new r.Position(c.endLineNumber,c.endColumn)}getStartPosition(){return x.getStartPosition(this)}static getStartPosition(c){return new r.Position(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,m){return new x(this.startLineNumber,this.startColumn,c,m)}setStartPosition(c,m){return new x(c,m,this.endLineNumber,this.endColumn)}collapseToStart(){return x.collapseToStart(this)}static collapseToStart(c){return new x(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}collapseToEnd(){return x.collapseToEnd(this)}static collapseToEnd(c){return new x(c.endLineNumber,c.endColumn,c.endLineNumber,c.endColumn)}delta(c){return new x(this.startLineNumber+c,this.startColumn,this.endLineNumber+c,this.endColumn)}static fromPositions(c,m=c){return new x(c.lineNumber,c.column,m.lineNumber,m.column)}static lift(c){return c?new x(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,m){return!(c.endLineNumber<m.startLineNumber||c.endLineNumber===m.startLineNumber&&c.endColumn<m.startColumn||m.endLineNumber<c.startLineNumber||m.endLineNumber===c.startLineNumber&&m.endColumn<c.startColumn)}static areIntersecting(c,m){return!(c.endLineNumber<m.startLineNumber||c.endLineNumber===m.startLineNumber&&c.endColumn<=m.startColumn||m.endLineNumber<c.startLineNumber||m.endLineNumber===c.startLineNumber&&m.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,m){if(c&&m){const l=c.startLineNumber|0,L=m.startLineNumber|0;if(l===L){const e=c.startColumn|0,s=m.startColumn|0;if(e===s){const o=c.endLineNumber|0,u=m.endLineNumber|0;if(o===u){const g=c.endColumn|0,f=m.endColumn|0;return g-f}return o-u}return e-s}return l-L}return(c?1:0)-(m?1:0)}static compareRangesUsingEnds(c,m){return c.endLineNumber===m.endLineNumber?c.endColumn===m.endColumn?c.startLineNumber===m.startLineNumber?c.startColumn-m.startColumn:c.startLineNumber-m.startLineNumber:c.endColumn-m.endColumn:c.endLineNumber-m.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}toJSON(){return this}}n.Range=x}),Y(J[10],Z([0,1,5,3,2,11]),function(B,n,r,x,A,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeSet=n.LineRange=void 0;class m{static fromRangeInclusive(l){return new m(l.startLineNumber,l.endLineNumber+1)}static joinMany(l){if(l.length===0)return[];let L=new v(l[0].slice());for(let e=1;e<l.length;e++)L=L.getUnion(new v(l[e].slice()));return L.ranges}static ofLength(l,L){return new m(l,l+L)}static deserialize(l){return new m(l[0],l[1])}constructor(l,L){if(l>L)throw new r.BugIndicatingError(`startLineNumber ${l} cannot be after endLineNumberExclusive ${L}`);this.startLineNumber=l,this.endLineNumberExclusive=L}contains(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(l){return new m(this.startLineNumber+l,this.endLineNumberExclusive+l)}deltaLength(l){return new m(this.startLineNumber,this.endLineNumberExclusive+l)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(l){return new m(Math.min(this.startLineNumber,l.startLineNumber),Math.max(this.endLineNumberExclusive,l.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(l){const L=Math.max(this.startLineNumber,l.startLineNumber),e=Math.min(this.endLineNumberExclusive,l.endLineNumberExclusive);if(L<=e)return new m(L,e)}intersectsStrict(l){return this.startLineNumber<l.endLineNumberExclusive&&l.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(l){return this.startLineNumber<=l.endLineNumberExclusive&&l.startLineNumber<=this.endLineNumberExclusive}equals(l){return this.startLineNumber===l.startLineNumber&&this.endLineNumberExclusive===l.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new A.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new A.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(l){const L=[];for(let e=this.startLineNumber;e<this.endLineNumberExclusive;e++)L.push(l(e));return L}forEach(l){for(let L=this.startLineNumber;L<this.endLineNumberExclusive;L++)l(L)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}toOffsetRange(){return new x.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}n.LineRange=m;class v{constructor(l=[]){this._normalizedRanges=l}get ranges(){return this._normalizedRanges}addRange(l){if(l.length===0)return;const L=(0,c.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,s=>s.endLineNumberExclusive>=l.startLineNumber),e=(0,c.findLastIdxMonotonous)(this._normalizedRanges,s=>s.startLineNumber<=l.endLineNumberExclusive)+1;if(L===e)this._normalizedRanges.splice(L,0,l);else if(L===e-1){const s=this._normalizedRanges[L];this._normalizedRanges[L]=s.join(l)}else{const s=this._normalizedRanges[L].join(this._normalizedRanges[e-1]).join(l);this._normalizedRanges.splice(L,e-L,s)}}contains(l){const L=(0,c.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=l);return!!L&&L.endLineNumberExclusive>l}intersects(l){const L=(0,c.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<l.endLineNumberExclusive);return!!L&&L.endLineNumberExclusive>l.startLineNumber}getUnion(l){if(this._normalizedRanges.length===0)return l;if(l._normalizedRanges.length===0)return this;const L=[];let e=0,s=0,o=null;for(;e<this._normalizedRanges.length||s<l._normalizedRanges.length;){let u=null;if(e<this._normalizedRanges.length&&s<l._normalizedRanges.length){const g=this._normalizedRanges[e],f=l._normalizedRanges[s];g.startLineNumber<f.startLineNumber?(u=g,e++):(u=f,s++)}else e<this._normalizedRanges.length?(u=this._normalizedRanges[e],e++):(u=l._normalizedRanges[s],s++);o===null?o=u:o.endLineNumberExclusive>=u.startLineNumber?o=new m(o.startLineNumber,Math.max(o.endLineNumberExclusive,u.endLineNumberExclusive)):(L.push(o),o=u)}return o!==null&&L.push(o),new v(L)}subtractFrom(l){const L=(0,c.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,u=>u.endLineNumberExclusive>=l.startLineNumber),e=(0,c.findLastIdxMonotonous)(this._normalizedRanges,u=>u.startLineNumber<=l.endLineNumberExclusive)+1;if(L===e)return new v([l]);const s=[];let o=l.startLineNumber;for(let u=L;u<e;u++){const g=this._normalizedRanges[u];g.startLineNumber>o&&s.push(new m(o,g.startLineNumber)),o=g.endLineNumberExclusive}return o<l.endLineNumberExclusive&&s.push(new m(o,l.endLineNumberExclusive)),new v(s)}toString(){return this._normalizedRanges.map(l=>l.toString()).join(", ")}getIntersection(l){const L=[];let e=0,s=0;for(;e<this._normalizedRanges.length&&s<l._normalizedRanges.length;){const o=this._normalizedRanges[e],u=l._normalizedRanges[s],g=o.intersect(u);g&&!g.isEmpty&&L.push(g),o.endLineNumberExclusive<u.endLineNumberExclusive?e++:s++}return new v(L)}getWithDelta(l){return new v(this._normalizedRanges.map(L=>L.delta(l)))}}n.LineRangeSet=v}),Y(J[43],Z([0,1,4,2]),function(B,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class A extends x.Range{constructor(m,v,h,l){super(m,v,h,l),this.selectionStartLineNumber=m,this.selectionStartColumn=v,this.positionLineNumber=h,this.positionColumn=l}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return A.selectionsEqual(this,m)}static selectionsEqual(m,v){return m.selectionStartLineNumber===v.selectionStartLineNumber&&m.selectionStartColumn===v.selectionStartColumn&&m.positionLineNumber===v.positionLineNumber&&m.positionColumn===v.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,v){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,m,v):new A(m,v,this.startLineNumber,this.startColumn)}getPosition(){return new r.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,v){return this.getDirection()===0?new A(m,v,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,m,v)}static fromPositions(m,v=m){return new A(m.lineNumber,m.column,v.lineNumber,v.column)}static fromRange(m,v){return v===0?new A(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new A(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new A(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,v){if(m&&!v||!m&&v)return!1;if(!m&&!v)return!0;if(m.length!==v.length)return!1;for(let h=0,l=m.length;h<l;h++)if(!this.selectionsEqual(m[h],v[h]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,v,h,l,L){return L===0?new A(m,v,h,l):new A(h,l,m,v)}}n.Selection=A}),Y(J[44],Z([0,1,28]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class x extends r.CharacterClassifier{constructor(m){super(0);for(let v=0,h=m.length;v<h;v++)this.set(m.charCodeAt(v),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=x;function A(c){const m={};return v=>(m.hasOwnProperty(v)||(m[v]=c(v)),m[v])}n.getMapForWordSeparators=A(c=>new x(c))}),Y(J[29],Z([0,1,21,22]),function(B,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.ensureValidWordDefinition=c,n.getWordAtText=v,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(l=""){let L="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)l.indexOf(e)>=0||(L+="\\"+e);return L+="\\s]+)",new RegExp(L,"g")}n.DEFAULT_WORD_REGEXP=A();function c(l){let L=n.DEFAULT_WORD_REGEXP;if(l&&l instanceof RegExp)if(l.global)L=l;else{let e="g";l.ignoreCase&&(e+="i"),l.multiline&&(e+="m"),l.unicode&&(e+="u"),L=new RegExp(l.source,e)}return L.lastIndex=0,L}const m=new x.LinkedList;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(l,L,e,s,o){if(L=c(L),o||(o=r.Iterable.first(m)),e.length>o.maxLen){let _=l-o.maxLen/2;return _<0?_=0:s+=_,e=e.substring(_,l+o.maxLen/2),v(l,L,e,s,o)}const u=Date.now(),g=l-1-s;let f=-1,E=null;for(let _=1;!(Date.now()-u>=o.timeBudget);_++){const N=g-o.windowSize*_;L.lastIndex=Math.max(0,N);const S=h(L,e,g,f);if(!S&&E||(E=S,N<=0))break;f=N}if(E){const _={word:E[0],startColumn:s+1+E.index,endColumn:s+1+E.index+E[0].length};return L.lastIndex=0,_}return null}function h(l,L,e,s){let o;for(;o=l.exec(L);){const u=o.index||0;if(u<=e&&l.lastIndex>=e)return o;if(s>0&&u>s)return null}return null}}),Y(J[8],Z([0,1,7,5,3]),function(B,n,r,x,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.OffsetPair=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class c{static trivial(e,s){return new c([new m(A.OffsetRange.ofLength(e.length),A.OffsetRange.ofLength(s.length))],!1)}static trivialTimedOut(e,s){return new c([new m(A.OffsetRange.ofLength(e.length),A.OffsetRange.ofLength(s.length))],!0)}constructor(e,s){this.diffs=e,this.hitTimeout=s}}n.DiffAlgorithmResult=c;class m{static invert(e,s){const o=[];return(0,r.forEachAdjacent)(e,(u,g)=>{o.push(m.fromOffsetPairs(u?u.getEndExclusives():v.zero,g?g.getStarts():new v(s,(u?u.seq2Range.endExclusive-u.seq1Range.endExclusive:0)+s)))}),o}static fromOffsetPairs(e,s){return new m(new A.OffsetRange(e.offset1,s.offset1),new A.OffsetRange(e.offset2,s.offset2))}constructor(e,s){this.seq1Range=e,this.seq2Range=s}swap(){return new m(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(e){return new m(this.seq1Range.join(e.seq1Range),this.seq2Range.join(e.seq2Range))}delta(e){return e===0?this:new m(this.seq1Range.delta(e),this.seq2Range.delta(e))}deltaStart(e){return e===0?this:new m(this.seq1Range.deltaStart(e),this.seq2Range.deltaStart(e))}deltaEnd(e){return e===0?this:new m(this.seq1Range.deltaEnd(e),this.seq2Range.deltaEnd(e))}intersect(e){const s=this.seq1Range.intersect(e.seq1Range),o=this.seq2Range.intersect(e.seq2Range);if(!(!s||!o))return new m(s,o)}getStarts(){return new v(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new v(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}n.SequenceDiff=m;class v{constructor(e,s){this.offset1=e,this.offset2=s}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(e){return e===0?this:new v(this.offset1+e,this.offset2+e)}equals(e){return this.offset1===e.offset1&&this.offset2===e.offset2}}n.OffsetPair=v,v.zero=new v(0,0),v.max=new v(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class h{isValid(){return!0}}n.InfiniteTimeout=h,h.instance=new h;class l{constructor(e){if(this.timeout=e,this.startTime=Date.now(),this.valid=!0,e<=0)throw new x.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=l}),Y(J[30],Z([0,1,3,8]),function(B,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class A{compute(l,L,e=x.InfiniteTimeout.instance){if(l.length===0||L.length===0)return x.DiffAlgorithmResult.trivial(l,L);const s=l,o=L;function u(a,d){for(;a<s.length&&d<o.length&&s.getElement(a)===o.getElement(d);)a++,d++;return a}let g=0;const f=new m;f.set(0,u(0,0));const E=new v;E.set(0,f.get(0)===0?null:new c(null,0,0,f.get(0)));let _=0;e:for(;;){if(g++,!e.isValid())return x.DiffAlgorithmResult.trivialTimedOut(s,o);const a=-Math.min(g,o.length+g%2),d=Math.min(g,s.length+g%2);for(_=a;_<=d;_+=2){let p=0;const b=_===d?-1:f.get(_+1),w=_===a?-1:f.get(_-1)+1;p++;const R=Math.min(Math.max(b,w),s.length),y=R-_;if(p++,R>s.length||y>o.length)continue;const M=u(R,y);f.set(_,M);const D=R===b?E.get(_+1):E.get(_-1);if(E.set(_,M!==R?new c(D,R,y,M-R):D),f.get(_)===s.length&&f.get(_)-_===o.length)break e}}let N=E.get(_);const S=[];let C=s.length,i=o.length;for(;;){const a=N?N.x+N.length:0,d=N?N.y+N.length:0;if((a!==C||d!==i)&&S.push(new x.SequenceDiff(new r.OffsetRange(a,C),new r.OffsetRange(d,i))),!N)break;C=N.x,i=N.y,N=N.prev}return S.reverse(),new x.DiffAlgorithmResult(S,!1)}}n.MyersDiffAlgorithm=A;class c{constructor(l,L,e,s){this.prev=l,this.x=L,this.y=e,this.length=s}}class m{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,L){if(l<0){if(l=-l-1,l>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[l]=L}else{if(l>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[l]=L}}}class v{constructor(){this.positiveArr=[],this.negativeArr=[]}get(l){return l<0?(l=-l-1,this.negativeArr[l]):this.positiveArr[l]}set(l,L){l<0?(l=-l-1,this.negativeArr[l]=L):this.positiveArr[l]=L}}}),Y(J[45],Z([0,1,7,3,8]),function(B,n,r,x,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.optimizeSequenceDiffs=c,n.removeShortMatches=l,n.extendDiffsToEntireWordIfAppropriate=L,n.removeVeryShortMatchingLinesBetweenDiffs=s,n.removeVeryShortMatchingTextBetweenLongDiffs=o;function c(u,g,f){let E=f;return E=m(u,g,E),E=m(u,g,E),E=v(u,g,E),E}function m(u,g,f){if(f.length===0)return f;const E=[];E.push(f[0]);for(let N=1;N<f.length;N++){const S=E[E.length-1];let C=f[N];if(C.seq1Range.isEmpty||C.seq2Range.isEmpty){const i=C.seq1Range.start-S.seq1Range.endExclusive;let a;for(a=1;a<=i&&!(u.getElement(C.seq1Range.start-a)!==u.getElement(C.seq1Range.endExclusive-a)||g.getElement(C.seq2Range.start-a)!==g.getElement(C.seq2Range.endExclusive-a));a++);if(a--,a===i){E[E.length-1]=new A.SequenceDiff(new x.OffsetRange(S.seq1Range.start,C.seq1Range.endExclusive-i),new x.OffsetRange(S.seq2Range.start,C.seq2Range.endExclusive-i));continue}C=C.delta(-a)}E.push(C)}const _=[];for(let N=0;N<E.length-1;N++){const S=E[N+1];let C=E[N];if(C.seq1Range.isEmpty||C.seq2Range.isEmpty){const i=S.seq1Range.start-C.seq1Range.endExclusive;let a;for(a=0;a<i&&!(!u.isStronglyEqual(C.seq1Range.start+a,C.seq1Range.endExclusive+a)||!g.isStronglyEqual(C.seq2Range.start+a,C.seq2Range.endExclusive+a));a++);if(a===i){E[N+1]=new A.SequenceDiff(new x.OffsetRange(C.seq1Range.start+i,S.seq1Range.endExclusive),new x.OffsetRange(C.seq2Range.start+i,S.seq2Range.endExclusive));continue}a>0&&(C=C.delta(a))}_.push(C)}return E.length>0&&_.push(E[E.length-1]),_}function v(u,g,f){if(!u.getBoundaryScore||!g.getBoundaryScore)return f;for(let E=0;E<f.length;E++){const _=E>0?f[E-1]:void 0,N=f[E],S=E+1<f.length?f[E+1]:void 0,C=new x.OffsetRange(_?_.seq1Range.endExclusive+1:0,S?S.seq1Range.start-1:u.length),i=new x.OffsetRange(_?_.seq2Range.endExclusive+1:0,S?S.seq2Range.start-1:g.length);N.seq1Range.isEmpty?f[E]=h(N,u,g,C,i):N.seq2Range.isEmpty&&(f[E]=h(N.swap(),g,u,i,C).swap())}return f}function h(u,g,f,E,_){let S=1;for(;u.seq1Range.start-S>=E.start&&u.seq2Range.start-S>=_.start&&f.isStronglyEqual(u.seq2Range.start-S,u.seq2Range.endExclusive-S)&&S<100;)S++;S--;let C=0;for(;u.seq1Range.start+C<E.endExclusive&&u.seq2Range.endExclusive+C<_.endExclusive&&f.isStronglyEqual(u.seq2Range.start+C,u.seq2Range.endExclusive+C)&&C<100;)C++;if(S===0&&C===0)return u;let i=0,a=-1;for(let d=-S;d<=C;d++){const p=u.seq2Range.start+d,b=u.seq2Range.endExclusive+d,w=u.seq1Range.start+d,R=g.getBoundaryScore(w)+f.getBoundaryScore(p)+f.getBoundaryScore(b);R>a&&(a=R,i=d)}return u.delta(i)}function l(u,g,f){const E=[];for(const _ of f){const N=E[E.length-1];if(!N){E.push(_);continue}_.seq1Range.start-N.seq1Range.endExclusive<=2||_.seq2Range.start-N.seq2Range.endExclusive<=2?E[E.length-1]=new A.SequenceDiff(N.seq1Range.join(_.seq1Range),N.seq2Range.join(_.seq2Range)):E.push(_)}return E}function L(u,g,f){const E=A.SequenceDiff.invert(f,u.length),_=[];let N=new A.OffsetPair(0,0);function S(i,a){if(i.offset1<N.offset1||i.offset2<N.offset2)return;const d=u.findWordContaining(i.offset1),p=g.findWordContaining(i.offset2);if(!d||!p)return;let b=new A.SequenceDiff(d,p);const w=b.intersect(a);let R=w.seq1Range.length,y=w.seq2Range.length;for(;E.length>0;){const M=E[0];if(!(M.seq1Range.intersects(b.seq1Range)||M.seq2Range.intersects(b.seq2Range)))break;const T=u.findWordContaining(M.seq1Range.start),k=g.findWordContaining(M.seq2Range.start),q=new A.SequenceDiff(T,k),H=q.intersect(M);if(R+=H.seq1Range.length,y+=H.seq2Range.length,b=b.join(q),b.seq1Range.endExclusive>=M.seq1Range.endExclusive)E.shift();else break}R+y<(b.seq1Range.length+b.seq2Range.length)*2/3&&_.push(b),N=b.getEndExclusives()}for(;E.length>0;){const i=E.shift();i.seq1Range.isEmpty||(S(i.getStarts(),i),S(i.getEndExclusives().delta(-1),i))}return e(f,_)}function e(u,g){const f=[];for(;u.length>0||g.length>0;){const E=u[0],_=g[0];let N;E&&(!_||E.seq1Range.start<_.seq1Range.start)?N=u.shift():N=g.shift(),f.length>0&&f[f.length-1].seq1Range.endExclusive>=N.seq1Range.start?f[f.length-1]=f[f.length-1].join(N):f.push(N)}return f}function s(u,g,f){let E=f;if(E.length===0)return E;let _=0,N;do{N=!1;const S=[E[0]];for(let C=1;C<E.length;C++){let d=function(b,w){const R=new x.OffsetRange(a.seq1Range.endExclusive,i.seq1Range.start);return u.getText(R).replace(/\s/g,"").length<=4&&(b.seq1Range.length+b.seq2Range.length>5||w.seq1Range.length+w.seq2Range.length>5)};const i=E[C],a=S[S.length-1];d(a,i)?(N=!0,S[S.length-1]=S[S.length-1].join(i)):S.push(i)}E=S}while(_++<10&&N);return E}function o(u,g,f){let E=f;if(E.length===0)return E;let _=0,N;do{N=!1;const C=[E[0]];for(let i=1;i<E.length;i++){let p=function(w,R){const y=new x.OffsetRange(d.seq1Range.endExclusive,a.seq1Range.start);if(u.countLinesIn(y)>5||y.length>500)return!1;const D=u.getText(y).trim();if(D.length>20||D.split(/\r\n|\r|\n/).length>1)return!1;const T=u.countLinesIn(w.seq1Range),k=w.seq1Range.length,q=g.countLinesIn(w.seq2Range),H=w.seq2Range.length,G=u.countLinesIn(R.seq1Range),F=R.seq1Range.length,I=g.countLinesIn(R.seq2Range),W=R.seq2Range.length,V=2*40+50;function z(U){return Math.min(U,V)}return Math.pow(Math.pow(z(T*40+k),1.5)+Math.pow(z(q*40+H),1.5),1.5)+Math.pow(Math.pow(z(G*40+F),1.5)+Math.pow(z(I*40+W),1.5),1.5)>(V**1.5)**1.5*1.3};const a=E[i],d=C[C.length-1];p(d,a)?(N=!0,C[C.length-1]=C[C.length-1].join(a)):C.push(a)}E=C}while(_++<10&&N);const S=[];return(0,r.forEachWithNeighbors)(E,(C,i,a)=>{let d=i;function p(D){return D.length>0&&D.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const b=u.extendToFullLines(i.seq1Range),w=u.getText(new x.OffsetRange(b.start,i.seq1Range.start));p(w)&&(d=d.deltaStart(-w.length));const R=u.getText(new x.OffsetRange(i.seq1Range.endExclusive,b.endExclusive));p(R)&&(d=d.deltaEnd(R.length));const y=A.SequenceDiff.fromOffsetPairs(C?C.getEndExclusives():A.OffsetPair.zero,a?a.getStarts():A.OffsetPair.max),M=d.intersect(y);S.length>0&&M.getStarts().equals(S[S.length-1].getEndExclusives())?S[S.length-1]=S[S.length-1].join(M):S.push(M)}),S}}),Y(J[46],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=void 0;class r{constructor(c,m){this.trimmedHash=c,this.lines=m}getElement(c){return this.trimmedHash[c]}get length(){return this.trimmedHash.length}getBoundaryScore(c){const m=c===0?0:x(this.lines[c-1]),v=c===this.lines.length?0:x(this.lines[c]);return 1e3-(m+v)}getText(c){return this.lines.slice(c.start,c.endExclusive).join(`
`)}isStronglyEqual(c,m){return this.lines[c]===this.lines[m]}}n.LineSequence=r;function x(A){let c=0;for(;c<A.length&&(A.charCodeAt(c)===32||A.charCodeAt(c)===9);)c++;return c}}),Y(J[15],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeFragment=n.Array2D=void 0,n.isSpace=x;class r{constructor(m,v){this.width=m,this.height=v,this.array=[],this.array=new Array(m*v)}get(m,v){return this.array[m+v*this.width]}set(m,v,h){this.array[m+v*this.width]=h}}n.Array2D=r;function x(c){return c===32||c===9}class A{static getKey(m){let v=this.chrKeys.get(m);return v===void 0&&(v=this.chrKeys.size,this.chrKeys.set(m,v)),v}constructor(m,v,h){this.range=m,this.lines=v,this.source=h,this.histogram=[];let l=0;for(let L=m.startLineNumber-1;L<m.endLineNumberExclusive-1;L++){const e=v[L];for(let o=0;o<e.length;o++){l++;const u=e[o],g=A.getKey(u);this.histogram[g]=(this.histogram[g]||0)+1}l++;const s=A.getKey(`
`);this.histogram[s]=(this.histogram[s]||0)+1}this.totalCount=l}computeSimilarity(m){var v,h;let l=0;const L=Math.max(this.histogram.length,m.histogram.length);for(let e=0;e<L;e++)l+=Math.abs(((v=this.histogram[e])!==null&&v!==void 0?v:0)-((h=m.histogram[e])!==null&&h!==void 0?h:0));return 1-l/(this.totalCount+m.totalCount)}}n.LineRangeFragment=A,A.chrKeys=new Map}),Y(J[47],Z([0,1,3,8,15]),function(B,n,r,x,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class c{compute(v,h,l=x.InfiniteTimeout.instance,L){if(v.length===0||h.length===0)return x.DiffAlgorithmResult.trivial(v,h);const e=new A.Array2D(v.length,h.length),s=new A.Array2D(v.length,h.length),o=new A.Array2D(v.length,h.length);for(let S=0;S<v.length;S++)for(let C=0;C<h.length;C++){if(!l.isValid())return x.DiffAlgorithmResult.trivialTimedOut(v,h);const i=S===0?0:e.get(S-1,C),a=C===0?0:e.get(S,C-1);let d;v.getElement(S)===h.getElement(C)?(S===0||C===0?d=0:d=e.get(S-1,C-1),S>0&&C>0&&s.get(S-1,C-1)===3&&(d+=o.get(S-1,C-1)),d+=L?L(S,C):1):d=-1;const p=Math.max(i,a,d);if(p===d){const b=S>0&&C>0?o.get(S-1,C-1):0;o.set(S,C,b+1),s.set(S,C,3)}else p===i?(o.set(S,C,0),s.set(S,C,1)):p===a&&(o.set(S,C,0),s.set(S,C,2));e.set(S,C,p)}const u=[];let g=v.length,f=h.length;function E(S,C){(S+1!==g||C+1!==f)&&u.push(new x.SequenceDiff(new r.OffsetRange(S+1,g),new r.OffsetRange(C+1,f))),g=S,f=C}let _=v.length-1,N=h.length-1;for(;_>=0&&N>=0;)s.get(_,N)===3?(E(_,N),_--,N--):s.get(_,N)===1?_--:N--;return E(-1,-1),u.reverse(),new x.DiffAlgorithmResult(u,!1)}}n.DynamicProgrammingDiffing=c}),Y(J[31],Z([0,1,11,3,4,2,15]),function(B,n,r,x,A,c,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinesSliceCharSequence=void 0;class v{constructor(o,u,g){this.lines=o,this.considerWhitespaceChanges=g,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let f=!1;u.start>0&&u.endExclusive>=o.length&&(u=new x.OffsetRange(u.start-1,u.endExclusive),f=!0),this.lineRange=u,this.firstCharOffsetByLine[0]=0;for(let E=this.lineRange.start;E<this.lineRange.endExclusive;E++){let _=o[E],N=0;if(f)N=_.length,_="",f=!1;else if(!g){const S=_.trimStart();N=_.length-S.length,_=S.trimEnd()}this.additionalOffsetByLine.push(N);for(let S=0;S<_.length;S++)this.elements.push(_.charCodeAt(S));E<o.length-1&&(this.elements.push(10),this.firstCharOffsetByLine[E-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new x.OffsetRange(0,this.length))}getText(o){return this.elements.slice(o.start,o.endExclusive).map(u=>String.fromCharCode(u)).join("")}getElement(o){return this.elements[o]}get length(){return this.elements.length}getBoundaryScore(o){const u=e(o>0?this.elements[o-1]:-1),g=e(o<this.elements.length?this.elements[o]:-1);if(u===7&&g===8)return 0;if(u===8)return 150;let f=0;return u!==g&&(f+=10,u===0&&g===1&&(f+=1)),f+=L(u),f+=L(g),f}translateOffset(o){if(this.lineRange.isEmpty)return new A.Position(this.lineRange.start+1,1);const u=(0,r.findLastIdxMonotonous)(this.firstCharOffsetByLine,g=>g<=o);return new A.Position(this.lineRange.start+u+1,o-this.firstCharOffsetByLine[u]+this.additionalOffsetByLine[u]+1)}translateRange(o){return c.Range.fromPositions(this.translateOffset(o.start),this.translateOffset(o.endExclusive))}findWordContaining(o){if(o<0||o>=this.elements.length||!h(this.elements[o]))return;let u=o;for(;u>0&&h(this.elements[u-1]);)u--;let g=o;for(;g<this.elements.length&&h(this.elements[g]);)g++;return new x.OffsetRange(u,g)}countLinesIn(o){return this.translateOffset(o.endExclusive).lineNumber-this.translateOffset(o.start).lineNumber}isStronglyEqual(o,u){return this.elements[o]===this.elements[u]}extendToFullLines(o){var u,g;const f=(u=(0,r.findLastMonotonous)(this.firstCharOffsetByLine,_=>_<=o.start))!==null&&u!==void 0?u:0,E=(g=(0,r.findFirstMonotonous)(this.firstCharOffsetByLine,_=>o.endExclusive<=_))!==null&&g!==void 0?g:this.elements.length;return new x.OffsetRange(f,E)}}n.LinesSliceCharSequence=v;function h(s){return s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57}const l={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function L(s){return l[s]}function e(s){return s===10?8:s===13?7:(0,m.isSpace)(s)?6:s>=97&&s<=122?0:s>=65&&s<=90?1:s>=48&&s<=57?2:s===-1?3:s===44||s===59?5:4}}),Y(J[32],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.LinesDiff=void 0;class r{constructor(c,m,v){this.changes=c,this.moves=m,this.hitTimeout=v}}n.LinesDiff=r;class x{constructor(c,m){this.lineRangeMapping=c,this.changes=m}}n.MovedText=x}),Y(J[16],Z([0,1,10]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.RangeMapping=n.DetailedLineRangeMapping=n.LineRangeMapping=void 0;class x{static inverse(v,h,l){const L=[];let e=1,s=1;for(const u of v){const g=new x(new r.LineRange(e,u.original.startLineNumber),new r.LineRange(s,u.modified.startLineNumber));g.modified.isEmpty||L.push(g),e=u.original.endLineNumberExclusive,s=u.modified.endLineNumberExclusive}const o=new x(new r.LineRange(e,h+1),new r.LineRange(s,l+1));return o.modified.isEmpty||L.push(o),L}static clip(v,h,l){const L=[];for(const e of v){const s=e.original.intersect(h),o=e.modified.intersect(l);s&&!s.isEmpty&&o&&!o.isEmpty&&L.push(new x(s,o))}return L}constructor(v,h){this.original=v,this.modified=h}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new x(this.modified,this.original)}join(v){return new x(this.original.join(v.original),this.modified.join(v.modified))}}n.LineRangeMapping=x;class A extends x{constructor(v,h,l){super(v,h),this.innerChanges=l}flip(){var v;return new A(this.modified,this.original,(v=this.innerChanges)===null||v===void 0?void 0:v.map(h=>h.flip()))}}n.DetailedLineRangeMapping=A;class c{constructor(v,h){this.originalRange=v,this.modifiedRange=h}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new c(this.modifiedRange,this.originalRange)}}n.RangeMapping=c}),Y(J[48],Z([0,1,8,16,7,11,38,10,3,31,15,30]),function(B,n,r,x,A,c,m,v,h,l,L,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeMovedLines=s;function s(N,S,C,i,a,d){let{moves:p,excludedChanges:b}=u(N,S,C,d);if(!d.isValid())return[];const w=N.filter(y=>!b.has(y)),R=g(w,i,a,S,C,d);return(0,A.pushMany)(p,R),p=E(p),p=p.filter(y=>{const M=y.original.toOffsetRange().slice(S).map(T=>T.trim());return M.join(`
`).length>=15&&o(M,T=>T.length>=2)>=2}),p=_(N,p),p}function o(N,S){let C=0;for(const i of N)S(i)&&C++;return C}function u(N,S,C,i){const a=[],d=N.filter(w=>w.modified.isEmpty&&w.original.length>=3).map(w=>new L.LineRangeFragment(w.original,S,w)),p=new Set(N.filter(w=>w.original.isEmpty&&w.modified.length>=3).map(w=>new L.LineRangeFragment(w.modified,C,w))),b=new Set;for(const w of d){let R=-1,y;for(const M of p){const D=w.computeSimilarity(M);D>R&&(R=D,y=M)}if(R>.9&&y&&(p.delete(y),a.push(new x.LineRangeMapping(w.range,y.range)),b.add(w.source),b.add(y.source)),!i.isValid())return{moves:a,excludedChanges:b}}return{moves:a,excludedChanges:b}}function g(N,S,C,i,a,d){const p=[],b=new m.SetMap;for(const D of N)for(let T=D.original.startLineNumber;T<D.original.endLineNumberExclusive-2;T++){const k=`${S[T-1]}:${S[T+1-1]}:${S[T+2-1]}`;b.add(k,{range:new v.LineRange(T,T+3)})}const w=[];N.sort((0,A.compareBy)(D=>D.modified.startLineNumber,A.numberComparator));for(const D of N){let T=[];for(let k=D.modified.startLineNumber;k<D.modified.endLineNumberExclusive-2;k++){const q=`${C[k-1]}:${C[k+1-1]}:${C[k+2-1]}`,H=new v.LineRange(k,k+3),G=[];b.forEach(q,({range:F})=>{for(const W of T)if(W.originalLineRange.endLineNumberExclusive+1===F.endLineNumberExclusive&&W.modifiedLineRange.endLineNumberExclusive+1===H.endLineNumberExclusive){W.originalLineRange=new v.LineRange(W.originalLineRange.startLineNumber,F.endLineNumberExclusive),W.modifiedLineRange=new v.LineRange(W.modifiedLineRange.startLineNumber,H.endLineNumberExclusive),G.push(W);return}const I={modifiedLineRange:H,originalLineRange:F};w.push(I),G.push(I)}),T=G}if(!d.isValid())return[]}w.sort((0,A.reverseOrder)((0,A.compareBy)(D=>D.modifiedLineRange.length,A.numberComparator)));const R=new v.LineRangeSet,y=new v.LineRangeSet;for(const D of w){const T=D.modifiedLineRange.startLineNumber-D.originalLineRange.startLineNumber,k=R.subtractFrom(D.modifiedLineRange),q=y.subtractFrom(D.originalLineRange).getWithDelta(T),H=k.getIntersection(q);for(const G of H.ranges){if(G.length<3)continue;const F=G,I=G.delta(-T);p.push(new x.LineRangeMapping(I,F)),R.addRange(F),y.addRange(I)}}p.sort((0,A.compareBy)(D=>D.original.startLineNumber,A.numberComparator));const M=new c.MonotonousArray(N);for(let D=0;D<p.length;D++){const T=p[D],k=M.findLastMonotonous(z=>z.original.startLineNumber<=T.original.startLineNumber),q=(0,c.findLastMonotonous)(N,z=>z.modified.startLineNumber<=T.modified.startLineNumber),H=Math.max(T.original.startLineNumber-k.original.startLineNumber,T.modified.startLineNumber-q.modified.startLineNumber),G=M.findLastMonotonous(z=>z.original.startLineNumber<T.original.endLineNumberExclusive),F=(0,c.findLastMonotonous)(N,z=>z.modified.startLineNumber<T.modified.endLineNumberExclusive),I=Math.max(G.original.endLineNumberExclusive-T.original.endLineNumberExclusive,F.modified.endLineNumberExclusive-T.modified.endLineNumberExclusive);let W;for(W=0;W<H;W++){const z=T.original.startLineNumber-W-1,U=T.modified.startLineNumber-W-1;if(z>i.length||U>a.length||R.contains(U)||y.contains(z)||!f(i[z-1],a[U-1],d))break}W>0&&(y.addRange(new v.LineRange(T.original.startLineNumber-W,T.original.startLineNumber)),R.addRange(new v.LineRange(T.modified.startLineNumber-W,T.modified.startLineNumber)));let V;for(V=0;V<I;V++){const z=T.original.endLineNumberExclusive+V,U=T.modified.endLineNumberExclusive+V;if(z>i.length||U>a.length||R.contains(U)||y.contains(z)||!f(i[z-1],a[U-1],d))break}V>0&&(y.addRange(new v.LineRange(T.original.endLineNumberExclusive,T.original.endLineNumberExclusive+V)),R.addRange(new v.LineRange(T.modified.endLineNumberExclusive,T.modified.endLineNumberExclusive+V))),(W>0||V>0)&&(p[D]=new x.LineRangeMapping(new v.LineRange(T.original.startLineNumber-W,T.original.endLineNumberExclusive+V),new v.LineRange(T.modified.startLineNumber-W,T.modified.endLineNumberExclusive+V)))}return p}function f(N,S,C){if(N.trim()===S.trim())return!0;if(N.length>300&&S.length>300)return!1;const a=new e.MyersDiffAlgorithm().compute(new l.LinesSliceCharSequence([N],new h.OffsetRange(0,1),!1),new l.LinesSliceCharSequence([S],new h.OffsetRange(0,1),!1),C);let d=0;const p=r.SequenceDiff.invert(a.diffs,N.length);for(const y of p)y.seq1Range.forEach(M=>{(0,L.isSpace)(N.charCodeAt(M))||d++});function b(y){let M=0;for(let D=0;D<N.length;D++)(0,L.isSpace)(y.charCodeAt(D))||M++;return M}const w=b(N.length>S.length?N:S);return d/w>.6&&w>10}function E(N){if(N.length===0)return N;N.sort((0,A.compareBy)(C=>C.original.startLineNumber,A.numberComparator));const S=[N[0]];for(let C=1;C<N.length;C++){const i=S[S.length-1],a=N[C],d=a.original.startLineNumber-i.original.endLineNumberExclusive,p=a.modified.startLineNumber-i.modified.endLineNumberExclusive;if(d>=0&&p>=0&&d+p<=2){S[S.length-1]=i.join(a);continue}S.push(a)}return S}function _(N,S){const C=new c.MonotonousArray(N);return S=S.filter(i=>{const a=C.findLastMonotonous(b=>b.original.startLineNumber<i.original.endLineNumberExclusive)||new x.LineRangeMapping(new v.LineRange(1,1),new v.LineRange(1,1)),d=(0,c.findLastMonotonous)(N,b=>b.modified.startLineNumber<i.modified.endLineNumberExclusive);return a!==d}),S}}),Y(J[49],Z([0,1,7,12,10,3,2,8,47,30,48,45,46,31,32,16]),function(B,n,r,x,A,c,m,v,h,l,L,e,s,o,u,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DefaultLinesDiffComputer=void 0,n.lineRangeMappingFromRangeMappings=E,n.getLineRangeMapping=_;class f{constructor(){this.dynamicProgrammingDiffing=new h.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new l.MyersDiffAlgorithm}computeDiff(S,C,i){if(S.length<=1&&(0,r.equals)(S,C,(V,z)=>V===z))return new u.LinesDiff([],[],!1);if(S.length===1&&S[0].length===0||C.length===1&&C[0].length===0)return new u.LinesDiff([new g.DetailedLineRangeMapping(new A.LineRange(1,S.length+1),new A.LineRange(1,C.length+1),[new g.RangeMapping(new m.Range(1,1,S.length,S[0].length+1),new m.Range(1,1,C.length,C[0].length+1))])],[],!1);const a=i.maxComputationTimeMs===0?v.InfiniteTimeout.instance:new v.DateTimeout(i.maxComputationTimeMs),d=!i.ignoreTrimWhitespace,p=new Map;function b(V){let z=p.get(V);return z===void 0&&(z=p.size,p.set(V,z)),z}const w=S.map(V=>b(V.trim())),R=C.map(V=>b(V.trim())),y=new s.LineSequence(w,S),M=new s.LineSequence(R,C),D=y.length+M.length<1700?this.dynamicProgrammingDiffing.compute(y,M,a,(V,z)=>S[V]===C[z]?C[z].length===0?.1:1+Math.log(1+C[z].length):.99):this.myersDiffingAlgorithm.compute(y,M);let T=D.diffs,k=D.hitTimeout;T=(0,e.optimizeSequenceDiffs)(y,M,T),T=(0,e.removeVeryShortMatchingLinesBetweenDiffs)(y,M,T);const q=[],H=V=>{if(d)for(let z=0;z<V;z++){const U=G+z,se=F+z;if(S[U]!==C[se]){const he=this.refineDiff(S,C,new v.SequenceDiff(new c.OffsetRange(U,U+1),new c.OffsetRange(se,se+1)),a,d);for(const t of he.mappings)q.push(t);he.hitTimeout&&(k=!0)}}};let G=0,F=0;for(const V of T){(0,x.assertFn)(()=>V.seq1Range.start-G===V.seq2Range.start-F);const z=V.seq1Range.start-G;H(z),G=V.seq1Range.endExclusive,F=V.seq2Range.endExclusive;const U=this.refineDiff(S,C,V,a,d);U.hitTimeout&&(k=!0);for(const se of U.mappings)q.push(se)}H(S.length-G);const I=E(q,S,C);let W=[];return i.computeMoves&&(W=this.computeMoves(I,S,C,w,R,a,d)),(0,x.assertFn)(()=>{function V(U,se){if(U.lineNumber<1||U.lineNumber>se.length)return!1;const he=se[U.lineNumber-1];return!(U.column<1||U.column>he.length+1)}function z(U,se){return!(U.startLineNumber<1||U.startLineNumber>se.length+1||U.endLineNumberExclusive<1||U.endLineNumberExclusive>se.length+1)}for(const U of I){if(!U.innerChanges)return!1;for(const se of U.innerChanges)if(!(V(se.modifiedRange.getStartPosition(),C)&&V(se.modifiedRange.getEndPosition(),C)&&V(se.originalRange.getStartPosition(),S)&&V(se.originalRange.getEndPosition(),S)))return!1;if(!z(U.modified,C)||!z(U.original,S))return!1}return!0}),new u.LinesDiff(I,W,k)}computeMoves(S,C,i,a,d,p,b){return(0,L.computeMovedLines)(S,C,i,a,d,p).map(y=>{const M=this.refineDiff(C,i,new v.SequenceDiff(y.original.toOffsetRange(),y.modified.toOffsetRange()),p,b),D=E(M.mappings,C,i,!0);return new u.MovedText(y,D)})}refineDiff(S,C,i,a,d){const p=new o.LinesSliceCharSequence(S,i.seq1Range,d),b=new o.LinesSliceCharSequence(C,i.seq2Range,d),w=p.length+b.length<500?this.dynamicProgrammingDiffing.compute(p,b,a):this.myersDiffingAlgorithm.compute(p,b,a);let R=w.diffs;return R=(0,e.optimizeSequenceDiffs)(p,b,R),R=(0,e.extendDiffsToEntireWordIfAppropriate)(p,b,R),R=(0,e.removeShortMatches)(p,b,R),R=(0,e.removeVeryShortMatchingTextBetweenLongDiffs)(p,b,R),{mappings:R.map(M=>new g.RangeMapping(p.translateRange(M.seq1Range),b.translateRange(M.seq2Range))),hitTimeout:w.hitTimeout}}}n.DefaultLinesDiffComputer=f;function E(N,S,C,i=!1){const a=[];for(const d of(0,r.groupAdjacentBy)(N.map(p=>_(p,S,C)),(p,b)=>p.original.overlapOrTouch(b.original)||p.modified.overlapOrTouch(b.modified))){const p=d[0],b=d[d.length-1];a.push(new g.DetailedLineRangeMapping(p.original.join(b.original),p.modified.join(b.modified),d.map(w=>w.innerChanges[0])))}return(0,x.assertFn)(()=>!i&&a.length>0&&(a[0].modified.startLineNumber!==a[0].original.startLineNumber||C.length-a[a.length-1].modified.endLineNumberExclusive!==S.length-a[a.length-1].original.endLineNumberExclusive)?!1:(0,x.checkAdjacentItems)(a,(d,p)=>p.original.startLineNumber-d.original.endLineNumberExclusive===p.modified.startLineNumber-d.modified.endLineNumberExclusive&&d.original.endLineNumberExclusive<p.original.startLineNumber&&d.modified.endLineNumberExclusive<p.modified.startLineNumber)),a}function _(N,S,C){let i=0,a=0;N.modifiedRange.endColumn===1&&N.originalRange.endColumn===1&&N.originalRange.startLineNumber+i<=N.originalRange.endLineNumber&&N.modifiedRange.startLineNumber+i<=N.modifiedRange.endLineNumber&&(a=-1),N.modifiedRange.startColumn-1>=C[N.modifiedRange.startLineNumber-1].length&&N.originalRange.startColumn-1>=S[N.originalRange.startLineNumber-1].length&&N.originalRange.startLineNumber<=N.originalRange.endLineNumber+a&&N.modifiedRange.startLineNumber<=N.modifiedRange.endLineNumber+a&&(i=1);const d=new A.LineRange(N.originalRange.startLineNumber+i,N.originalRange.endLineNumber+1+a),p=new A.LineRange(N.modifiedRange.startLineNumber+i,N.modifiedRange.endLineNumber+1+a);return new g.DetailedLineRangeMapping(d,p,[N])}}),Y(J[50],Z([0,1,24,32,16,6,2,12,10]),function(B,n,r,x,A,c,m,v,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.LegacyLinesDiffComputer=void 0;const l=3;class L{computeDiff(i,a,d){var p;const w=new E(i,a,{maxComputationTime:d.maxComputationTimeMs,shouldIgnoreTrimWhitespace:d.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),R=[];let y=null;for(const M of w.changes){let D;M.originalEndLineNumber===0?D=new h.LineRange(M.originalStartLineNumber+1,M.originalStartLineNumber+1):D=new h.LineRange(M.originalStartLineNumber,M.originalEndLineNumber+1);let T;M.modifiedEndLineNumber===0?T=new h.LineRange(M.modifiedStartLineNumber+1,M.modifiedStartLineNumber+1):T=new h.LineRange(M.modifiedStartLineNumber,M.modifiedEndLineNumber+1);let k=new A.DetailedLineRangeMapping(D,T,(p=M.charChanges)===null||p===void 0?void 0:p.map(q=>new A.RangeMapping(new m.Range(q.originalStartLineNumber,q.originalStartColumn,q.originalEndLineNumber,q.originalEndColumn),new m.Range(q.modifiedStartLineNumber,q.modifiedStartColumn,q.modifiedEndLineNumber,q.modifiedEndColumn))));y&&(y.modified.endLineNumberExclusive===k.modified.startLineNumber||y.original.endLineNumberExclusive===k.original.startLineNumber)&&(k=new A.DetailedLineRangeMapping(y.original.join(k.original),y.modified.join(k.modified),y.innerChanges&&k.innerChanges?y.innerChanges.concat(k.innerChanges):void 0),R.pop()),R.push(k),y=k}return(0,v.assertFn)(()=>(0,v.checkAdjacentItems)(R,(M,D)=>D.original.startLineNumber-M.original.endLineNumberExclusive===D.modified.startLineNumber-M.modified.endLineNumberExclusive&&M.original.endLineNumberExclusive<D.original.startLineNumber&&M.modified.endLineNumberExclusive<D.modified.startLineNumber)),new x.LinesDiff(R,[],w.quitEarly)}}n.LegacyLinesDiffComputer=L;function e(C,i,a,d){return new r.LcsDiff(C,i,a).ComputeDiff(d)}class s{constructor(i){const a=[],d=[];for(let p=0,b=i.length;p<b;p++)a[p]=_(i[p],1),d[p]=N(i[p],1);this.lines=i,this._startColumns=a,this._endColumns=d}getElements(){const i=[];for(let a=0,d=this.lines.length;a<d;a++)i[a]=this.lines[a].substring(this._startColumns[a]-1,this._endColumns[a]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,a,d){const p=[],b=[],w=[];let R=0;for(let y=a;y<=d;y++){const M=this.lines[y],D=i?this._startColumns[y]:1,T=i?this._endColumns[y]:M.length+1;for(let k=D;k<T;k++)p[R]=M.charCodeAt(k-1),b[R]=y+1,w[R]=k,R++;!i&&y<d&&(p[R]=10,b[R]=y+1,w[R]=M.length+1,R++)}return new o(p,b,w)}}class o{constructor(i,a,d){this._charCodes=i,this._lineNumbers=a,this._columns=d}toString(){return"["+this._charCodes.map((i,a)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this._lineNumbers[a]},${this._columns[a]})`).join(", ")+"]"}_assertIndex(i,a){if(i<0||i>=a.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(i){return i>0&&i===this._lineNumbers.length?this.getEndLineNumber(i-1):(this._assertIndex(i,this._lineNumbers),this._lineNumbers[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this._assertIndex(i,this._lineNumbers),this._charCodes[i]===10?this._lineNumbers[i]+1:this._lineNumbers[i])}getStartColumn(i){return i>0&&i===this._columns.length?this.getEndColumn(i-1):(this._assertIndex(i,this._columns),this._columns[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this._assertIndex(i,this._columns),this._charCodes[i]===10?1:this._columns[i]+1)}}class u{constructor(i,a,d,p,b,w,R,y){this.originalStartLineNumber=i,this.originalStartColumn=a,this.originalEndLineNumber=d,this.originalEndColumn=p,this.modifiedStartLineNumber=b,this.modifiedStartColumn=w,this.modifiedEndLineNumber=R,this.modifiedEndColumn=y}static createFromDiffChange(i,a,d){const p=a.getStartLineNumber(i.originalStart),b=a.getStartColumn(i.originalStart),w=a.getEndLineNumber(i.originalStart+i.originalLength-1),R=a.getEndColumn(i.originalStart+i.originalLength-1),y=d.getStartLineNumber(i.modifiedStart),M=d.getStartColumn(i.modifiedStart),D=d.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),T=d.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new u(p,b,w,R,y,M,D,T)}}function g(C){if(C.length<=1)return C;const i=[C[0]];let a=i[0];for(let d=1,p=C.length;d<p;d++){const b=C[d],w=b.originalStart-(a.originalStart+a.originalLength),R=b.modifiedStart-(a.modifiedStart+a.modifiedLength);Math.min(w,R)<l?(a.originalLength=b.originalStart+b.originalLength-a.originalStart,a.modifiedLength=b.modifiedStart+b.modifiedLength-a.modifiedStart):(i.push(b),a=b)}return i}class f{constructor(i,a,d,p,b){this.originalStartLineNumber=i,this.originalEndLineNumber=a,this.modifiedStartLineNumber=d,this.modifiedEndLineNumber=p,this.charChanges=b}static createFromDiffResult(i,a,d,p,b,w,R){let y,M,D,T,k;if(a.originalLength===0?(y=d.getStartLineNumber(a.originalStart)-1,M=0):(y=d.getStartLineNumber(a.originalStart),M=d.getEndLineNumber(a.originalStart+a.originalLength-1)),a.modifiedLength===0?(D=p.getStartLineNumber(a.modifiedStart)-1,T=0):(D=p.getStartLineNumber(a.modifiedStart),T=p.getEndLineNumber(a.modifiedStart+a.modifiedLength-1)),w&&a.originalLength>0&&a.originalLength<20&&a.modifiedLength>0&&a.modifiedLength<20&&b()){const q=d.createCharSequence(i,a.originalStart,a.originalStart+a.originalLength-1),H=p.createCharSequence(i,a.modifiedStart,a.modifiedStart+a.modifiedLength-1);if(q.getElements().length>0&&H.getElements().length>0){let G=e(q,H,b,!0).changes;R&&(G=g(G)),k=[];for(let F=0,I=G.length;F<I;F++)k.push(u.createFromDiffChange(G[F],q,H))}}return new f(y,M,D,T,k)}}class E{constructor(i,a,d){this.shouldComputeCharChanges=d.shouldComputeCharChanges,this.shouldPostProcessCharChanges=d.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=d.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=d.shouldMakePrettyDiff,this.originalLines=i,this.modifiedLines=a,this.original=new s(i),this.modified=new s(a),this.continueLineDiff=S(d.maxComputationTime),this.continueCharDiff=S(d.maxComputationTime===0?0:Math.min(d.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=e(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),a=i.changes,d=i.quitEarly;if(this.shouldIgnoreTrimWhitespace){const R=[];for(let y=0,M=a.length;y<M;y++)R.push(f.createFromDiffResult(this.shouldIgnoreTrimWhitespace,a[y],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:d,changes:R}}const p=[];let b=0,w=0;for(let R=-1,y=a.length;R<y;R++){const M=R+1<y?a[R+1]:null,D=M?M.originalStart:this.originalLines.length,T=M?M.modifiedStart:this.modifiedLines.length;for(;b<D&&w<T;){const k=this.originalLines[b],q=this.modifiedLines[w];if(k!==q){{let H=_(k,1),G=_(q,1);for(;H>1&&G>1;){const F=k.charCodeAt(H-2),I=q.charCodeAt(G-2);if(F!==I)break;H--,G--}(H>1||G>1)&&this._pushTrimWhitespaceCharChange(p,b+1,1,H,w+1,1,G)}{let H=N(k,1),G=N(q,1);const F=k.length+1,I=q.length+1;for(;H<F&&G<I;){const W=k.charCodeAt(H-1),V=k.charCodeAt(G-1);if(W!==V)break;H++,G++}(H<F||G<I)&&this._pushTrimWhitespaceCharChange(p,b+1,H,F,w+1,G,I)}}b++,w++}M&&(p.push(f.createFromDiffResult(this.shouldIgnoreTrimWhitespace,M,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),b+=M.originalLength,w+=M.modifiedLength)}return{quitEarly:d,changes:p}}_pushTrimWhitespaceCharChange(i,a,d,p,b,w,R){if(this._mergeTrimWhitespaceCharChange(i,a,d,p,b,w,R))return;let y;this.shouldComputeCharChanges&&(y=[new u(a,d,a,p,b,w,b,R)]),i.push(new f(a,a,b,b,y))}_mergeTrimWhitespaceCharChange(i,a,d,p,b,w,R){const y=i.length;if(y===0)return!1;const M=i[y-1];return M.originalEndLineNumber===0||M.modifiedEndLineNumber===0?!1:M.originalEndLineNumber===a&&M.modifiedEndLineNumber===b?(this.shouldComputeCharChanges&&M.charChanges&&M.charChanges.push(new u(a,d,a,p,b,w,b,R)),!0):M.originalEndLineNumber+1===a&&M.modifiedEndLineNumber+1===b?(M.originalEndLineNumber=a,M.modifiedEndLineNumber=b,this.shouldComputeCharChanges&&M.charChanges&&M.charChanges.push(new u(a,d,a,p,b,w,b,R)),!0):!1}}n.DiffComputer=E;function _(C,i){const a=c.firstNonWhitespaceIndex(C);return a===-1?i:a+1}function N(C,i){const a=c.lastNonWhitespaceIndex(C);return a===-1?i:a+2}function S(C){if(C===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<C}}),Y(J[51],Z([0,1,50,49]),function(B,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new r.LegacyLinesDiffComputer,getDefault:()=>new x.DefaultLinesDiffComputer}}),Y(J[52],Z([0,1,34]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=e;function x(s){const o=[];for(const u of s){const g=Number(u);(g||g===0&&u.replace(/\s/g,"")!=="")&&o.push(g)}return o}function A(s,o,u,g){return{red:s/255,blue:u/255,green:o/255,alpha:g}}function c(s,o){const u=o.index,g=o[0].length;if(!u)return;const f=s.positionAt(u);return{startLineNumber:f.lineNumber,startColumn:f.column,endLineNumber:f.lineNumber,endColumn:f.column+g}}function m(s,o){if(!s)return;const u=r.Color.Format.CSS.parseHex(o);if(u)return{range:s,color:A(u.rgba.r,u.rgba.g,u.rgba.b,u.rgba.a)}}function v(s,o,u){if(!s||o.length!==1)return;const f=o[0].values(),E=x(f);return{range:s,color:A(E[0],E[1],E[2],u?E[3]:1)}}function h(s,o,u){if(!s||o.length!==1)return;const f=o[0].values(),E=x(f),_=new r.Color(new r.HSLA(E[0],E[1]/100,E[2]/100,u?E[3]:1));return{range:s,color:A(_.rgba.r,_.rgba.g,_.rgba.b,_.rgba.a)}}function l(s,o){return typeof s=="string"?[...s.matchAll(o)]:s.findMatches(o)}function L(s){const o=[],g=l(s,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(g.length>0)for(const f of g){const E=f.filter(C=>C!==void 0),_=E[1],N=E[2];if(!N)continue;let S;if(_==="rgb"){const C=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;S=v(c(s,f),l(N,C),!1)}else if(_==="rgba"){const C=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=v(c(s,f),l(N,C),!0)}else if(_==="hsl"){const C=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;S=h(c(s,f),l(N,C),!1)}else if(_==="hsla"){const C=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=h(c(s,f),l(N,C),!0)}else _==="#"&&(S=m(c(s,f),_+N));S&&o.push(S)}return o}function e(s){return!s||typeof s.getValue!="function"||typeof s.positionAt!="function"?[]:L(s)}}),Y(J[53],Z([0,1,28]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkComputer=n.StateMachine=void 0,n.computeLinks=L;class x{constructor(s,o,u){const g=new Uint8Array(s*o);for(let f=0,E=s*o;f<E;f++)g[f]=u;this._data=g,this.rows=s,this.cols=o}get(s,o){return this._data[s*this.cols+o]}set(s,o,u){this._data[s*this.cols+o]=u}}class A{constructor(s){let o=0,u=0;for(let f=0,E=s.length;f<E;f++){const[_,N,S]=s[f];N>o&&(o=N),_>u&&(u=_),S>u&&(u=S)}o++,u++;const g=new x(u,o,0);for(let f=0,E=s.length;f<E;f++){const[_,N,S]=s[f];g.set(_,N,S)}this._states=g,this._maxCharCode=o}nextState(s,o){return o<0||o>=this._maxCharCode?0:this._states.get(s,o)}}n.StateMachine=A;let c=null;function m(){return c===null&&(c=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),c}let v=null;function h(){if(v===null){v=new r.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let o=0;o<e.length;o++)v.set(e.charCodeAt(o),1);const s=".,;:";for(let o=0;o<s.length;o++)v.set(s.charCodeAt(o),2)}return v}class l{static _createLink(s,o,u,g,f){let E=f-1;do{const _=o.charCodeAt(E);if(s.get(_)!==2)break;E--}while(E>g);if(g>0){const _=o.charCodeAt(g-1),N=o.charCodeAt(E);(_===40&&N===41||_===91&&N===93||_===123&&N===125)&&E--}return{range:{startLineNumber:u,startColumn:g+1,endLineNumber:u,endColumn:E+2},url:o.substring(g,E+1)}}static computeLinks(s,o=m()){const u=h(),g=[];for(let f=1,E=s.getLineCount();f<=E;f++){const _=s.getLineContent(f),N=_.length;let S=0,C=0,i=0,a=1,d=!1,p=!1,b=!1,w=!1;for(;S<N;){let R=!1;const y=_.charCodeAt(S);if(a===13){let M;switch(y){case 40:d=!0,M=0;break;case 41:M=d?0:1;break;case 91:b=!0,p=!0,M=0;break;case 93:b=!1,M=p?0:1;break;case 123:w=!0,M=0;break;case 125:M=w?0:1;break;case 39:case 34:case 96:i===y?M=1:i===39||i===34||i===96?M=0:M=1;break;case 42:M=i===42?1:0;break;case 124:M=i===124?1:0;break;case 32:M=b?0:1;break;default:M=u.get(y)}M===1&&(g.push(l._createLink(u,_,f,C,S)),R=!0)}else if(a===12){let M;y===91?(p=!0,M=0):M=u.get(y),M===1?R=!0:a=13}else a=o.nextState(a,y),a===0&&(R=!0);R&&(a=1,d=!1,p=!1,w=!1,C=S+1,i=y),S++}a===13&&g.push(l._createLink(u,_,f,C,N))}return g}}n.LinkComputer=l;function L(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:l.computeLinks(e)}}),Y(J[54],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class r{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(A,c,m,v,h){if(A&&c){const l=this.doNavigateValueSet(c,h);if(l)return{range:A,value:l}}if(m&&v){const l=this.doNavigateValueSet(v,h);if(l)return{range:m,value:l}}return null}doNavigateValueSet(A,c){const m=this.numberReplace(A,c);return m!==null?m:this.textReplace(A,c)}numberReplace(A,c){const m=Math.pow(10,A.length-(A.lastIndexOf(".")+1));let v=Number(A);const h=parseFloat(A);return!isNaN(v)&&!isNaN(h)&&v===h?v===0&&!c?null:(v=Math.floor(v*m),v+=c?m:-m,String(v/m)):null}textReplace(A,c){return this.valueSetsReplace(this._defaultValueSet,A,c)}valueSetsReplace(A,c,m){let v=null;for(let h=0,l=A.length;v===null&&h<l;h++)v=this.valueSetReplace(A[h],c,m);return v}valueSetReplace(A,c,m){let v=A.indexOf(c);return v>=0?(v+=m?1:-1,v<0?v=A.length-1:v%=A.length,A[v]):null}}n.BasicInplaceReplace=r,r.INSTANCE=new r}),Y(J[55],Z([0,1,14]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.GlyphMarginLane=n.OverviewRulerLane=void 0,n.isITextSnapshot=l,n.shouldSynchronizeModel=o;var x;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(x||(n.OverviewRulerLane=x={}));var A;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=3]="Right"})(A||(n.GlyphMarginLane=A={}));var c;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(c||(n.MinimapPosition=c={}));var m;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(m||(n.InjectedTextCursorStops=m={}));class v{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),g.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,g.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!g.insertSpaces,this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=!!g.trimAutoWhitespace,this.bracketPairColorizationOptions=g.bracketPairColorizationOptions}equals(g){return this.tabSize===g.tabSize&&this._indentSizeIsTabSize===g._indentSizeIsTabSize&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace&&(0,r.equals)(this.bracketPairColorizationOptions,g.bracketPairColorizationOptions)}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}n.TextModelResolvedOptions=v;class h{constructor(g,f){this._findMatchBrand=void 0,this.range=g,this.matches=f}}n.FindMatch=h;function l(u){return u&&typeof u.read=="function"}class L{constructor(g,f,E,_,N,S){this.identifier=g,this.range=f,this.text=E,this.forceMoveMarkers=_,this.isAutoWhitespaceEdit=N,this._isTracked=S}}n.ValidAnnotatedEditOperation=L;class e{constructor(g,f,E){this.regex=g,this.wordSeparators=f,this.simpleSearch=E}}n.SearchData=e;class s{constructor(g,f,E){this.reverseEdits=g,this.changes=f,this.trimAutoWhitespaceLineNumbers=E}}n.ApplyEditsResult=s;function o(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}}),Y(J[56],Z([0,1,7,27]),function(B,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class A{constructor(h){this.values=h,this.prefixSum=new Uint32Array(h.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(h,l){h=(0,x.toUint32)(h);const L=this.values,e=this.prefixSum,s=l.length;return s===0?!1:(this.values=new Uint32Array(L.length+s),this.values.set(L.subarray(0,h),0),this.values.set(L.subarray(h),h+s),this.values.set(l,h),h-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=h-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(h,l){return h=(0,x.toUint32)(h),l=(0,x.toUint32)(l),this.values[h]===l?!1:(this.values[h]=l,h-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=h-1),!0)}removeValues(h,l){h=(0,x.toUint32)(h),l=(0,x.toUint32)(l);const L=this.values,e=this.prefixSum;if(h>=L.length)return!1;const s=L.length-h;return l>=s&&(l=s),l===0?!1:(this.values=new Uint32Array(L.length-l),this.values.set(L.subarray(0,h),0),this.values.set(L.subarray(h+l),h),this.prefixSum=new Uint32Array(this.values.length),h-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=h-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(h){return h<0?0:(h=(0,x.toUint32)(h),this._getPrefixSum(h))}_getPrefixSum(h){if(h<=this.prefixSumValidIndex[0])return this.prefixSum[h];let l=this.prefixSumValidIndex[0]+1;l===0&&(this.prefixSum[0]=this.values[0],l++),h>=this.values.length&&(h=this.values.length-1);for(let L=l;L<=h;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],h),this.prefixSum[h]}getIndexOf(h){h=Math.floor(h),this.getTotalSum();let l=0,L=this.values.length-1,e=0,s=0,o=0;for(;l<=L;)if(e=l+(L-l)/2|0,s=this.prefixSum[e],o=s-this.values[e],h<o)L=e-1;else if(h>=s)l=e+1;else break;return new m(e,h-o)}}n.PrefixSumComputer=A;class c{constructor(h){this._values=h,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(h){return this._ensureValid(),h===0?0:this._prefixSum[h-1]}getIndexOf(h){this._ensureValid();const l=this._indexBySum[h],L=l>0?this._prefixSum[l-1]:0;return new m(l,h-L)}removeValues(h,l){this._values.splice(h,l),this._invalidate(h)}insertValues(h,l){this._values=(0,r.arrayInsert)(this._values,h,l),this._invalidate(h)}_invalidate(h){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,h-1)}_ensureValid(){if(!this._isValid){for(let h=this._validEndIndex+1,l=this._values.length;h<l;h++){const L=this._values[h],e=h>0?this._prefixSum[h-1]:0;this._prefixSum[h]=e+L;for(let s=0;s<L;s++)this._indexBySum[e+s]=h}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(h,l){this._values[h]!==l&&(this._values[h]=l,this._invalidate(h))}}n.ConstantTimePrefixSumComputer=c;class m{constructor(h,l){this.index=h,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=h,this.remainder=l}}n.PrefixSumIndexOfResult=m}),Y(J[57],Z([0,1,6,4,56]),function(B,n,r,x,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class c{constructor(v,h,l,L){this._uri=v,this._lines=h,this._eol=l,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(v){v.eol&&v.eol!==this._eol&&(this._eol=v.eol,this._lineStarts=null);const h=v.changes;for(const l of h)this._acceptDeleteRange(l.range),this._acceptInsertText(new x.Position(l.range.startLineNumber,l.range.startColumn),l.text);this._versionId=v.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const v=this._eol.length,h=this._lines.length,l=new Uint32Array(h);for(let L=0;L<h;L++)l[L]=this._lines[L].length+v;this._lineStarts=new A.PrefixSumComputer(l)}}_setLineText(v,h){this._lines[v]=h,this._lineStarts&&this._lineStarts.setValue(v,this._lines[v].length+this._eol.length)}_acceptDeleteRange(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.startLineNumber-1].substring(v.endColumn-1));return}this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.endLineNumber-1].substring(v.endColumn-1)),this._lines.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}_acceptInsertText(v,h){if(h.length===0)return;const l=(0,r.splitLines)(h);if(l.length===1){this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+l[0]+this._lines[v.lineNumber-1].substring(v.column-1));return}l[l.length-1]+=this._lines[v.lineNumber-1].substring(v.column-1),this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+l[0]);const L=new Uint32Array(l.length-1);for(let e=1;e<l.length;e++)this._lines.splice(v.lineNumber+e-1,0,l[e]),L[e-1]=l[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(v.lineNumber,L)}}n.MirrorTextModel=c}),Y(J[58],Z([0,1,6,44,4,2,55]),function(B,n,r,x,A,c,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.TextModelSearch=n.SearchParams=void 0,n.isMultilineRegexSource=l,n.createFindMatch=L,n.isValidMatch=g;const v=999;class h{constructor(_,N,S,C){this.searchString=_,this.isRegex=N,this.matchCase=S,this.wordSeparators=C}parseSearchRequest(){if(this.searchString==="")return null;let _;this.isRegex?_=l(this.searchString):_=this.searchString.indexOf(`
`)>=0;let N=null;try{N=r.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:_,global:!0,unicode:!0})}catch{return null}if(!N)return null;let S=!this.isRegex&&!_;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new m.SearchData(N,this.wordSeparators?(0,x.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}n.SearchParams=h;function l(E){if(!E||E.length===0)return!1;for(let _=0,N=E.length;_<N;_++){const S=E.charCodeAt(_);if(S===10)return!0;if(S===92){if(_++,_>=N)break;const C=E.charCodeAt(_);if(C===110||C===114||C===87)return!0}}return!1}function L(E,_,N){if(!N)return new m.FindMatch(E,null);const S=[];for(let C=0,i=_.length;C<i;C++)S[C]=_[C];return new m.FindMatch(E,S)}class e{constructor(_){const N=[];let S=0;for(let C=0,i=_.length;C<i;C++)_.charCodeAt(C)===10&&(N[S++]=C);this._lineFeedsOffsets=N}findLineFeedCountBeforeOffset(_){const N=this._lineFeedsOffsets;let S=0,C=N.length-1;if(C===-1||_<=N[0])return 0;for(;S<C;){const i=S+((C-S)/2>>0);N[i]>=_?C=i-1:N[i+1]>=_?(S=i,C=i):S=i+1}return S+1}}class s{static findMatches(_,N,S,C,i){const a=N.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(_,S,new f(a.wordSeparators,a.regex),C,i):this._doFindMatchesLineByLine(_,S,a,C,i):[]}static _getMultilineMatchRange(_,N,S,C,i,a){let d,p=0;C?(p=C.findLineFeedCountBeforeOffset(i),d=N+i+p):d=N+i;let b;if(C){const M=C.findLineFeedCountBeforeOffset(i+a.length)-p;b=d+a.length+M}else b=d+a.length;const w=_.getPositionAt(d),R=_.getPositionAt(b);return new c.Range(w.lineNumber,w.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(_,N,S,C,i){const a=_.getOffsetAt(N.getStartPosition()),d=_.getValueInRange(N,1),p=_.getEOL()===`\r
`?new e(d):null,b=[];let w=0,R;for(S.reset(0);R=S.next(d);)if(b[w++]=L(this._getMultilineMatchRange(_,a,d,p,R.index,R[0]),R,C),w>=i)return b;return b}static _doFindMatchesLineByLine(_,N,S,C,i){const a=[];let d=0;if(N.startLineNumber===N.endLineNumber){const b=_.getLineContent(N.startLineNumber).substring(N.startColumn-1,N.endColumn-1);return d=this._findMatchesInLine(S,b,N.startLineNumber,N.startColumn-1,d,a,C,i),a}const p=_.getLineContent(N.startLineNumber).substring(N.startColumn-1);d=this._findMatchesInLine(S,p,N.startLineNumber,N.startColumn-1,d,a,C,i);for(let b=N.startLineNumber+1;b<N.endLineNumber&&d<i;b++)d=this._findMatchesInLine(S,_.getLineContent(b),b,0,d,a,C,i);if(d<i){const b=_.getLineContent(N.endLineNumber).substring(0,N.endColumn-1);d=this._findMatchesInLine(S,b,N.endLineNumber,0,d,a,C,i)}return a}static _findMatchesInLine(_,N,S,C,i,a,d,p){const b=_.wordSeparators;if(!d&&_.simpleSearch){const y=_.simpleSearch,M=y.length,D=N.length;let T=-M;for(;(T=N.indexOf(y,T+M))!==-1;)if((!b||g(b,N,D,T,M))&&(a[i++]=new m.FindMatch(new c.Range(S,T+1+C,S,T+1+M+C),null),i>=p))return i;return i}const w=new f(_.wordSeparators,_.regex);let R;w.reset(0);do if(R=w.next(N),R&&(a[i++]=L(new c.Range(S,R.index+1+C,S,R.index+1+R[0].length+C),R,d),i>=p))return i;while(R);return i}static findNextMatch(_,N,S,C){const i=N.parseSearchRequest();if(!i)return null;const a=new f(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(_,S,a,C):this._doFindNextMatchLineByLine(_,S,a,C)}static _doFindNextMatchMultiline(_,N,S,C){const i=new A.Position(N.lineNumber,1),a=_.getOffsetAt(i),d=_.getLineCount(),p=_.getValueInRange(new c.Range(i.lineNumber,i.column,d,_.getLineMaxColumn(d)),1),b=_.getEOL()===`\r
`?new e(p):null;S.reset(N.column-1);const w=S.next(p);return w?L(this._getMultilineMatchRange(_,a,p,b,w.index,w[0]),w,C):N.lineNumber!==1||N.column!==1?this._doFindNextMatchMultiline(_,new A.Position(1,1),S,C):null}static _doFindNextMatchLineByLine(_,N,S,C){const i=_.getLineCount(),a=N.lineNumber,d=_.getLineContent(a),p=this._findFirstMatchInLine(S,d,a,N.column,C);if(p)return p;for(let b=1;b<=i;b++){const w=(a+b-1)%i,R=_.getLineContent(w+1),y=this._findFirstMatchInLine(S,R,w+1,1,C);if(y)return y}return null}static _findFirstMatchInLine(_,N,S,C,i){_.reset(C-1);const a=_.next(N);return a?L(new c.Range(S,a.index+1,S,a.index+1+a[0].length),a,i):null}static findPreviousMatch(_,N,S,C){const i=N.parseSearchRequest();if(!i)return null;const a=new f(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(_,S,a,C):this._doFindPreviousMatchLineByLine(_,S,a,C)}static _doFindPreviousMatchMultiline(_,N,S,C){const i=this._doFindMatchesMultiline(_,new c.Range(1,1,N.lineNumber,N.column),S,C,10*v);if(i.length>0)return i[i.length-1];const a=_.getLineCount();return N.lineNumber!==a||N.column!==_.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(_,new A.Position(a,_.getLineMaxColumn(a)),S,C):null}static _doFindPreviousMatchLineByLine(_,N,S,C){const i=_.getLineCount(),a=N.lineNumber,d=_.getLineContent(a).substring(0,N.column-1),p=this._findLastMatchInLine(S,d,a,C);if(p)return p;for(let b=1;b<=i;b++){const w=(i+a-b-1)%i,R=_.getLineContent(w+1),y=this._findLastMatchInLine(S,R,w+1,C);if(y)return y}return null}static _findLastMatchInLine(_,N,S,C){let i=null,a;for(_.reset(0);a=_.next(N);)i=L(new c.Range(S,a.index+1,S,a.index+1+a[0].length),a,C);return i}}n.TextModelSearch=s;function o(E,_,N,S,C){if(S===0)return!0;const i=_.charCodeAt(S-1);if(E.get(i)!==0||i===13||i===10)return!0;if(C>0){const a=_.charCodeAt(S);if(E.get(a)!==0)return!0}return!1}function u(E,_,N,S,C){if(S+C===N)return!0;const i=_.charCodeAt(S+C);if(E.get(i)!==0||i===13||i===10)return!0;if(C>0){const a=_.charCodeAt(S+C-1);if(E.get(a)!==0)return!0}return!1}function g(E,_,N,S,C){return o(E,_,N,S,C)&&u(E,_,N,S,C)}class f{constructor(_,N){this._wordSeparators=_,this._searchRegex=N,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(_){this._searchRegex.lastIndex=_,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(_){const N=_.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===N||(S=this._searchRegex.exec(_),!S))return null;const C=S.index,i=S[0].length;if(C===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){r.getNextCodePoint(_,N,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=C,this._prevMatchLength=i,!this._wordSeparators||g(this._wordSeparators,_,N,C,i))return S}while(S);return null}}n.Searcher=f}),Y(J[59],Z([0,1,2,58,6,12,29]),function(B,n,r,x,A,c,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class v{static computeUnicodeHighlights(s,o,u){const g=u?u.startLineNumber:1,f=u?u.endLineNumber:s.getLineCount(),E=new l(o),_=E.getCandidateCodePoints();let N;_==="allNonBasicAscii"?N=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):N=new RegExp(`${h(Array.from(_))}`,"g");const S=new x.Searcher(null,N),C=[];let i=!1,a,d=0,p=0,b=0;e:for(let w=g,R=f;w<=R;w++){const y=s.getLineContent(w),M=y.length;S.reset(0);do if(a=S.next(y),a){let D=a.index,T=a.index+a[0].length;if(D>0){const G=y.charCodeAt(D-1);A.isHighSurrogate(G)&&D--}if(T+1<M){const G=y.charCodeAt(T-1);A.isHighSurrogate(G)&&T++}const k=y.substring(D,T);let q=(0,m.getWordAtText)(D+1,m.DEFAULT_WORD_REGEXP,y,0);q&&q.endColumn<=D+1&&(q=null);const H=E.shouldHighlightNonBasicASCII(k,q?q.word:null);if(H!==0){if(H===3?d++:H===2?p++:H===1?b++:(0,c.assertNever)(H),C.length>=1e3){i=!0;break e}C.push(new r.Range(w,D+1,w,T+1))}}while(a)}return{ranges:C,hasMore:i,ambiguousCharacterCount:d,invisibleCharacterCount:p,nonBasicAsciiCharacterCount:b}}static computeUnicodeHighlightReason(s,o){const u=new l(o);switch(u.shouldHighlightNonBasicASCII(s,null)){case 0:return null;case 2:return{kind:1};case 3:{const f=s.codePointAt(0),E=u.ambiguousCharacters.getPrimaryConfusable(f),_=A.AmbiguousCharacters.getLocales().filter(N=>!A.AmbiguousCharacters.getInstance(new Set([...o.allowedLocales,N])).isAmbiguous(f));return{kind:0,confusableWith:String.fromCodePoint(E),notAmbiguousInLocales:_}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=v;function h(e,s){return`[${A.escapeRegExpCharacters(e.map(u=>String.fromCodePoint(u)).join(""))}]`}class l{constructor(s){this.options=s,this.allowedCodePoints=new Set(s.allowedCodePoints),this.ambiguousCharacters=A.AmbiguousCharacters.getInstance(new Set(s.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const s=new Set;if(this.options.invisibleCharacters)for(const o of A.InvisibleCharacters.codePoints)L(String.fromCodePoint(o))||s.add(o);if(this.options.ambiguousCharacters)for(const o of this.ambiguousCharacters.getConfusableCodePoints())s.add(o);for(const o of this.allowedCodePoints)s.delete(o);return s}shouldHighlightNonBasicASCII(s,o){const u=s.codePointAt(0);if(this.allowedCodePoints.has(u))return 0;if(this.options.nonBasicASCII)return 1;let g=!1,f=!1;if(o)for(const E of o){const _=E.codePointAt(0),N=A.isBasicASCII(E);g=g||N,!N&&!this.ambiguousCharacters.isAmbiguous(_)&&!A.InvisibleCharacters.isInvisibleCharacter(_)&&(f=!0)}return!g&&f?0:this.options.invisibleCharacters&&!L(s)&&A.InvisibleCharacters.isInvisibleCharacter(u)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(u)?3:0}}function L(e){return e===" "||e===`
`||e==="	"}}),Y(J[60],Z([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.ShowLightbulbIconMode=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.PartialAcceptTriggerKind=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.NewSymbolNameTag=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineEditTriggerKind=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var r;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(r||(n.AccessibilitySupport=r={}));var x;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(x||(n.CodeActionTriggerType=x={}));var A;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(A||(n.CompletionItemInsertTextRule=A={}));var c;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(c||(n.CompletionItemKind=c={}));var m;(function(t){t[t.Deprecated=1]="Deprecated"})(m||(n.CompletionItemTag=m={}));var v;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v||(n.CompletionTriggerKind=v={}));var h;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(h||(n.ContentWidgetPositionPreference=h={}));var l;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(l||(n.CursorChangeReason=l={}));var L;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(L||(n.DefaultEndOfLine=L={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var s;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(s||(n.EditorAutoIndentStrategy=s={}));var o;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.ariaRequired=5]="ariaRequired",t[t.autoClosingBrackets=6]="autoClosingBrackets",t[t.autoClosingComments=7]="autoClosingComments",t[t.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=9]="autoClosingDelete",t[t.autoClosingOvertype=10]="autoClosingOvertype",t[t.autoClosingQuotes=11]="autoClosingQuotes",t[t.autoIndent=12]="autoIndent",t[t.automaticLayout=13]="automaticLayout",t[t.autoSurround=14]="autoSurround",t[t.bracketPairColorization=15]="bracketPairColorization",t[t.guides=16]="guides",t[t.codeLens=17]="codeLens",t[t.codeLensFontFamily=18]="codeLensFontFamily",t[t.codeLensFontSize=19]="codeLensFontSize",t[t.colorDecorators=20]="colorDecorators",t[t.colorDecoratorsLimit=21]="colorDecoratorsLimit",t[t.columnSelection=22]="columnSelection",t[t.comments=23]="comments",t[t.contextmenu=24]="contextmenu",t[t.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",t[t.cursorBlinking=26]="cursorBlinking",t[t.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",t[t.cursorStyle=28]="cursorStyle",t[t.cursorSurroundingLines=29]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",t[t.cursorWidth=31]="cursorWidth",t[t.disableLayerHinting=32]="disableLayerHinting",t[t.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",t[t.domReadOnly=34]="domReadOnly",t[t.dragAndDrop=35]="dragAndDrop",t[t.dropIntoEditor=36]="dropIntoEditor",t[t.emptySelectionClipboard=37]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",t[t.extraEditorClassName=39]="extraEditorClassName",t[t.fastScrollSensitivity=40]="fastScrollSensitivity",t[t.find=41]="find",t[t.fixedOverflowWidgets=42]="fixedOverflowWidgets",t[t.folding=43]="folding",t[t.foldingStrategy=44]="foldingStrategy",t[t.foldingHighlight=45]="foldingHighlight",t[t.foldingImportsByDefault=46]="foldingImportsByDefault",t[t.foldingMaximumRegions=47]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=49]="fontFamily",t[t.fontInfo=50]="fontInfo",t[t.fontLigatures=51]="fontLigatures",t[t.fontSize=52]="fontSize",t[t.fontWeight=53]="fontWeight",t[t.fontVariations=54]="fontVariations",t[t.formatOnPaste=55]="formatOnPaste",t[t.formatOnType=56]="formatOnType",t[t.glyphMargin=57]="glyphMargin",t[t.gotoLocation=58]="gotoLocation",t[t.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",t[t.hover=60]="hover",t[t.inDiffEditor=61]="inDiffEditor",t[t.inlineSuggest=62]="inlineSuggest",t[t.inlineEdit=63]="inlineEdit",t[t.letterSpacing=64]="letterSpacing",t[t.lightbulb=65]="lightbulb",t[t.lineDecorationsWidth=66]="lineDecorationsWidth",t[t.lineHeight=67]="lineHeight",t[t.lineNumbers=68]="lineNumbers",t[t.lineNumbersMinChars=69]="lineNumbersMinChars",t[t.linkedEditing=70]="linkedEditing",t[t.links=71]="links",t[t.matchBrackets=72]="matchBrackets",t[t.minimap=73]="minimap",t[t.mouseStyle=74]="mouseStyle",t[t.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=76]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",t[t.multiCursorModifier=78]="multiCursorModifier",t[t.multiCursorPaste=79]="multiCursorPaste",t[t.multiCursorLimit=80]="multiCursorLimit",t[t.occurrencesHighlight=81]="occurrencesHighlight",t[t.overviewRulerBorder=82]="overviewRulerBorder",t[t.overviewRulerLanes=83]="overviewRulerLanes",t[t.padding=84]="padding",t[t.pasteAs=85]="pasteAs",t[t.parameterHints=86]="parameterHints",t[t.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",t[t.quickSuggestions=89]="quickSuggestions",t[t.quickSuggestionsDelay=90]="quickSuggestionsDelay",t[t.readOnly=91]="readOnly",t[t.readOnlyMessage=92]="readOnlyMessage",t[t.renameOnType=93]="renameOnType",t[t.renderControlCharacters=94]="renderControlCharacters",t[t.renderFinalNewline=95]="renderFinalNewline",t[t.renderLineHighlight=96]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=98]="renderValidationDecorations",t[t.renderWhitespace=99]="renderWhitespace",t[t.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",t[t.roundedSelection=101]="roundedSelection",t[t.rulers=102]="rulers",t[t.scrollbar=103]="scrollbar",t[t.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=105]="scrollBeyondLastLine",t[t.scrollPredominantAxis=106]="scrollPredominantAxis",t[t.selectionClipboard=107]="selectionClipboard",t[t.selectionHighlight=108]="selectionHighlight",t[t.selectOnLineNumbers=109]="selectOnLineNumbers",t[t.showFoldingControls=110]="showFoldingControls",t[t.showUnused=111]="showUnused",t[t.snippetSuggestions=112]="snippetSuggestions",t[t.smartSelect=113]="smartSelect",t[t.smoothScrolling=114]="smoothScrolling",t[t.stickyScroll=115]="stickyScroll",t[t.stickyTabStops=116]="stickyTabStops",t[t.stopRenderingLineAfter=117]="stopRenderingLineAfter",t[t.suggest=118]="suggest",t[t.suggestFontSize=119]="suggestFontSize",t[t.suggestLineHeight=120]="suggestLineHeight",t[t.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",t[t.suggestSelection=122]="suggestSelection",t[t.tabCompletion=123]="tabCompletion",t[t.tabIndex=124]="tabIndex",t[t.unicodeHighlighting=125]="unicodeHighlighting",t[t.unusualLineTerminators=126]="unusualLineTerminators",t[t.useShadowDOM=127]="useShadowDOM",t[t.useTabStops=128]="useTabStops",t[t.wordBreak=129]="wordBreak",t[t.wordSeparators=130]="wordSeparators",t[t.wordWrap=131]="wordWrap",t[t.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=134]="wordWrapColumn",t[t.wordWrapOverride1=135]="wordWrapOverride1",t[t.wordWrapOverride2=136]="wordWrapOverride2",t[t.wrappingIndent=137]="wrappingIndent",t[t.wrappingStrategy=138]="wrappingStrategy",t[t.showDeprecated=139]="showDeprecated",t[t.inlayHints=140]="inlayHints",t[t.editorClassName=141]="editorClassName",t[t.pixelRatio=142]="pixelRatio",t[t.tabFocusMode=143]="tabFocusMode",t[t.layoutInfo=144]="layoutInfo",t[t.wrappingInfo=145]="wrappingInfo",t[t.defaultColorDecorators=146]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",t[t.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(o||(n.EditorOption=o={}));var u;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(u||(n.EndOfLinePreference=u={}));var g;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(g||(n.EndOfLineSequence=g={}));var f;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(f||(n.GlyphMarginLane=f={}));var E;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(E||(n.IndentAction=E={}));var _;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(_||(n.InjectedTextCursorStops=_={}));var N;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(N||(n.InlayHintKind=N={}));var S;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(S||(n.InlineCompletionTriggerKind=S={}));var C;(function(t){t[t.Invoke=0]="Invoke",t[t.Automatic=1]="Automatic"})(C||(n.InlineEditTriggerKind=C={}));var i;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(i||(n.KeyCode=i={}));var a;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(a||(n.MarkerSeverity=a={}));var d;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(d||(n.MarkerTag=d={}));var p;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(p||(n.MinimapPosition=p={}));var b;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(b||(n.MouseTargetType=b={}));var w;(function(t){t[t.AIGenerated=1]="AIGenerated"})(w||(n.NewSymbolNameTag=w={}));var R;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(R||(n.OverlayWidgetPositionPreference=R={}));var y;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(y||(n.OverviewRulerLane=y={}));var M;(function(t){t[t.Word=0]="Word",t[t.Line=1]="Line",t[t.Suggest=2]="Suggest"})(M||(n.PartialAcceptTriggerKind=M={}));var D;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(D||(n.PositionAffinity=D={}));var T;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(T||(n.RenderLineNumbersType=T={}));var k;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(k||(n.RenderMinimap=k={}));var q;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(q||(n.ScrollType=q={}));var H;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(H||(n.ScrollbarVisibility=H={}));var G;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(G||(n.SelectionDirection=G={}));var F;(function(t){t.Off="off",t.OnCode="onCode",t.On="on"})(F||(n.ShowLightbulbIconMode=F={}));var I;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(I||(n.SignatureHelpTriggerKind=I={}));var W;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(W||(n.SymbolKind=W={}));var V;(function(t){t[t.Deprecated=1]="Deprecated"})(V||(n.SymbolTag=V={}));var z;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(z||(n.TextEditorCursorBlinkingStyle=z={}));var U;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(U||(n.TextEditorCursorStyle=U={}));var se;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(se||(n.TrackedRangeStickiness=se={}));var he;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(he||(n.WrappingIndent=he={}))}),Y(J[61],Z([0,1,9,13]),function(B,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class A{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new r.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(v){this._onDidChange.fire({changedLanguages:v,changedColorMap:!1})}register(v,h){return this._tokenizationSupports.set(v,h),this.handleChange([v]),(0,x.toDisposable)(()=>{this._tokenizationSupports.get(v)===h&&(this._tokenizationSupports.delete(v),this.handleChange([v]))})}get(v){return this._tokenizationSupports.get(v)||null}registerFactory(v,h){var l;(l=this._factories.get(v))===null||l===void 0||l.dispose();const L=new c(this,v,h);return this._factories.set(v,L),(0,x.toDisposable)(()=>{const e=this._factories.get(v);!e||e!==L||(this._factories.delete(v),e.dispose())})}async getOrCreate(v){const h=this.get(v);if(h)return h;const l=this._factories.get(v);return!l||l.isResolved?null:(await l.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const l=this._factories.get(v);return!!(!l||l.isResolved)}setColorMap(v){this._colorMap=v,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=A;class c extends x.Disposable{get isResolved(){return this._isResolved}constructor(v,h,l){super(),this._registry=v,this._languageId=h,this._factory=l,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const v=await this._factory.tokenizationSupport;this._isResolved=!0,v&&!this._isDisposed&&this._register(this._registry.register(this._languageId,v))}}}),Y(J[62],Z([19,63]),function(B,n){return B.create("vs/base/common/platform",n)}),Y(J[17],Z([0,1,62]),function(B,n,r){"use strict";var x;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.webWorkerOrigin=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.LANGUAGE_DEFAULT=void 0,n.isLittleEndian=b,n.LANGUAGE_DEFAULT="en";let A=!1,c=!1,m=!1,v=!1,h=!1,l=!1,L=!1,e=!1,s=!1,o=!1,u,g=n.LANGUAGE_DEFAULT,f=n.LANGUAGE_DEFAULT,E,_;const N=globalThis;let S;typeof N.vscode<"u"&&typeof N.vscode.process<"u"?S=N.vscode.process:typeof process<"u"&&(S=process);const C=typeof((x=S?.versions)===null||x===void 0?void 0:x.electron)=="string",i=C&&S?.type==="renderer";if(typeof S=="object"){A=S.platform==="win32",c=S.platform==="darwin",m=S.platform==="linux",v=m&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,L=C,s=!!S.env.CI||!!S.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=n.LANGUAGE_DEFAULT,g=n.LANGUAGE_DEFAULT;const w=S.env.VSCODE_NLS_CONFIG;if(w)try{const R=JSON.parse(w),y=R.availableLanguages["*"];u=R.locale,f=R.osLocale,g=y||n.LANGUAGE_DEFAULT,E=R._translationsConfigFile}catch{}h=!0}else typeof navigator=="object"&&!i?(_=navigator.userAgent,A=_.indexOf("Windows")>=0,c=_.indexOf("Macintosh")>=0,e=(_.indexOf("Macintosh")>=0||_.indexOf("iPad")>=0||_.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,m=_.indexOf("Linux")>=0,o=_?.indexOf("Mobi")>=0,l=!0,u=r.getConfiguredDefaultLocale(r.localize(0,null))||n.LANGUAGE_DEFAULT,g=u,f=navigator.language):console.error("Unable to resolve platform.");let a=0;c?a=1:A?a=3:m&&(a=2),n.isWindows=A,n.isMacintosh=c,n.isLinux=m,n.isNative=h,n.isWeb=l,n.isWebWorker=l&&typeof N.importScripts=="function",n.webWorkerOrigin=n.isWebWorker?N.origin:void 0,n.isIOS=e,n.isMobile=o,n.userAgent=_,n.language=g,n.setTimeout0IsFaster=typeof N.postMessage=="function"&&!N.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const w=[];N.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let M=0,D=w.length;M<D;M++){const T=w[M];if(T.id===y.data.vscodeScheduleAsyncWork){w.splice(M,1),T.callback();return}}});let R=0;return y=>{const M=++R;w.push({id:M,callback:y}),N.postMessage({vscodeScheduleAsyncWork:M},"*")}}return w=>setTimeout(w)})(),n.OS=c||e?2:A?1:3;let d=!0,p=!1;function b(){if(!p){p=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,d=new Uint16Array(w.buffer)[0]===513}return d}n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Y(J[64],Z([0,1,17]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let x;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const c=A.process;x={get platform(){return c.platform},get arch(){return c.arch},get env(){return c.env},cwd(){return c.cwd()}}}else typeof process<"u"?x={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:x={get platform(){return r.isWindows?"win32":r.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=x.cwd,n.env=x.env,n.platform=x.platform}),Y(J[65],Z([0,1,64]),function(B,n,r){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const x=65,A=97,c=90,m=122,v=46,h=47,l=92,L=58,e=63;class s extends Error{constructor(a,d,p){let b;typeof d=="string"&&d.indexOf("not ")===0?(b="must not be",d=d.replace(/^not /,"")):b="must be";const w=a.indexOf(".")!==-1?"property":"argument";let R=`The "${a}" ${w} ${b} of type ${d}`;R+=`. Received type ${typeof p}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function o(i,a){if(i===null||typeof i!="object")throw new s(a,"Object",i)}function u(i,a){if(typeof i!="string")throw new s(a,"string",i)}const g=r.platform==="win32";function f(i){return i===h||i===l}function E(i){return i===h}function _(i){return i>=x&&i<=c||i>=A&&i<=m}function N(i,a,d,p){let b="",w=0,R=-1,y=0,M=0;for(let D=0;D<=i.length;++D){if(D<i.length)M=i.charCodeAt(D);else{if(p(M))break;M=h}if(p(M)){if(!(R===D-1||y===1))if(y===2){if(b.length<2||w!==2||b.charCodeAt(b.length-1)!==v||b.charCodeAt(b.length-2)!==v){if(b.length>2){const T=b.lastIndexOf(d);T===-1?(b="",w=0):(b=b.slice(0,T),w=b.length-1-b.lastIndexOf(d)),R=D,y=0;continue}else if(b.length!==0){b="",w=0,R=D,y=0;continue}}a&&(b+=b.length>0?`${d}..`:"..",w=2)}else b.length>0?b+=`${d}${i.slice(R+1,D)}`:b=i.slice(R+1,D),w=D-R-1;R=D,y=0}else M===v&&y!==-1?++y:y=-1}return b}function S(i,a){o(a,"pathObject");const d=a.dir||a.root,p=a.base||`${a.name||""}${a.ext||""}`;return d?d===a.root?`${d}${p}`:`${d}${i}${p}`:p}n.win32={resolve(...i){let a="",d="",p=!1;for(let b=i.length-1;b>=-1;b--){let w;if(b>=0){if(w=i[b],u(w,"path"),w.length===0)continue}else a.length===0?w=r.cwd():(w=r.env[`=${a}`]||r.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==a.toLowerCase()&&w.charCodeAt(2)===l)&&(w=`${a}\\`));const R=w.length;let y=0,M="",D=!1;const T=w.charCodeAt(0);if(R===1)f(T)&&(y=1,D=!0);else if(f(T))if(D=!0,f(w.charCodeAt(1))){let k=2,q=k;for(;k<R&&!f(w.charCodeAt(k));)k++;if(k<R&&k!==q){const H=w.slice(q,k);for(q=k;k<R&&f(w.charCodeAt(k));)k++;if(k<R&&k!==q){for(q=k;k<R&&!f(w.charCodeAt(k));)k++;(k===R||k!==q)&&(M=`\\\\${H}\\${w.slice(q,k)}`,y=k)}}}else y=1;else _(T)&&w.charCodeAt(1)===L&&(M=w.slice(0,2),y=2,R>2&&f(w.charCodeAt(2))&&(D=!0,y=3));if(M.length>0)if(a.length>0){if(M.toLowerCase()!==a.toLowerCase())continue}else a=M;if(p){if(a.length>0)break}else if(d=`${w.slice(y)}\\${d}`,p=D,D&&a.length>0)break}return d=N(d,!p,"\\",f),p?`${a}\\${d}`:`${a}${d}`||"."},normalize(i){u(i,"path");const a=i.length;if(a===0)return".";let d=0,p,b=!1;const w=i.charCodeAt(0);if(a===1)return E(w)?"\\":i;if(f(w))if(b=!0,f(i.charCodeAt(1))){let y=2,M=y;for(;y<a&&!f(i.charCodeAt(y));)y++;if(y<a&&y!==M){const D=i.slice(M,y);for(M=y;y<a&&f(i.charCodeAt(y));)y++;if(y<a&&y!==M){for(M=y;y<a&&!f(i.charCodeAt(y));)y++;if(y===a)return`\\\\${D}\\${i.slice(M)}\\`;y!==M&&(p=`\\\\${D}\\${i.slice(M,y)}`,d=y)}}}else d=1;else _(w)&&i.charCodeAt(1)===L&&(p=i.slice(0,2),d=2,a>2&&f(i.charCodeAt(2))&&(b=!0,d=3));let R=d<a?N(i.slice(d),!b,"\\",f):"";return R.length===0&&!b&&(R="."),R.length>0&&f(i.charCodeAt(a-1))&&(R+="\\"),p===void 0?b?`\\${R}`:R:b?`${p}\\${R}`:`${p}${R}`},isAbsolute(i){u(i,"path");const a=i.length;if(a===0)return!1;const d=i.charCodeAt(0);return f(d)||a>2&&_(d)&&i.charCodeAt(1)===L&&f(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,d;for(let w=0;w<i.length;++w){const R=i[w];u(R,"path"),R.length>0&&(a===void 0?a=d=R:a+=`\\${R}`)}if(a===void 0)return".";let p=!0,b=0;if(typeof d=="string"&&f(d.charCodeAt(0))){++b;const w=d.length;w>1&&f(d.charCodeAt(1))&&(++b,w>2&&(f(d.charCodeAt(2))?++b:p=!1))}if(p){for(;b<a.length&&f(a.charCodeAt(b));)b++;b>=2&&(a=`\\${a.slice(b)}`)}return n.win32.normalize(a)},relative(i,a){if(u(i,"from"),u(a,"to"),i===a)return"";const d=n.win32.resolve(i),p=n.win32.resolve(a);if(d===p||(i=d.toLowerCase(),a=p.toLowerCase(),i===a))return"";let b=0;for(;b<i.length&&i.charCodeAt(b)===l;)b++;let w=i.length;for(;w-1>b&&i.charCodeAt(w-1)===l;)w--;const R=w-b;let y=0;for(;y<a.length&&a.charCodeAt(y)===l;)y++;let M=a.length;for(;M-1>y&&a.charCodeAt(M-1)===l;)M--;const D=M-y,T=R<D?R:D;let k=-1,q=0;for(;q<T;q++){const G=i.charCodeAt(b+q);if(G!==a.charCodeAt(y+q))break;G===l&&(k=q)}if(q!==T){if(k===-1)return p}else{if(D>T){if(a.charCodeAt(y+q)===l)return p.slice(y+q+1);if(q===2)return p.slice(y+q)}R>T&&(i.charCodeAt(b+q)===l?k=q:q===2&&(k=3)),k===-1&&(k=0)}let H="";for(q=b+k+1;q<=w;++q)(q===w||i.charCodeAt(q)===l)&&(H+=H.length===0?"..":"\\..");return y+=k,H.length>0?`${H}${p.slice(y,M)}`:(p.charCodeAt(y)===l&&++y,p.slice(y,M))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=n.win32.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===l){if(a.charCodeAt(1)===l){const d=a.charCodeAt(2);if(d!==e&&d!==v)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(_(a.charCodeAt(0))&&a.charCodeAt(1)===L&&a.charCodeAt(2)===l)return`\\\\?\\${a}`;return i},dirname(i){u(i,"path");const a=i.length;if(a===0)return".";let d=-1,p=0;const b=i.charCodeAt(0);if(a===1)return f(b)?i:".";if(f(b)){if(d=p=1,f(i.charCodeAt(1))){let y=2,M=y;for(;y<a&&!f(i.charCodeAt(y));)y++;if(y<a&&y!==M){for(M=y;y<a&&f(i.charCodeAt(y));)y++;if(y<a&&y!==M){for(M=y;y<a&&!f(i.charCodeAt(y));)y++;if(y===a)return i;y!==M&&(d=p=y+1)}}}}else _(b)&&i.charCodeAt(1)===L&&(d=a>2&&f(i.charCodeAt(2))?3:2,p=d);let w=-1,R=!0;for(let y=a-1;y>=p;--y)if(f(i.charCodeAt(y))){if(!R){w=y;break}}else R=!1;if(w===-1){if(d===-1)return".";w=d}return i.slice(0,w)},basename(i,a){a!==void 0&&u(a,"ext"),u(i,"path");let d=0,p=-1,b=!0,w;if(i.length>=2&&_(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(d=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let R=a.length-1,y=-1;for(w=i.length-1;w>=d;--w){const M=i.charCodeAt(w);if(f(M)){if(!b){d=w+1;break}}else y===-1&&(b=!1,y=w+1),R>=0&&(M===a.charCodeAt(R)?--R===-1&&(p=w):(R=-1,p=y))}return d===p?p=y:p===-1&&(p=i.length),i.slice(d,p)}for(w=i.length-1;w>=d;--w)if(f(i.charCodeAt(w))){if(!b){d=w+1;break}}else p===-1&&(b=!1,p=w+1);return p===-1?"":i.slice(d,p)},extname(i){u(i,"path");let a=0,d=-1,p=0,b=-1,w=!0,R=0;i.length>=2&&i.charCodeAt(1)===L&&_(i.charCodeAt(0))&&(a=p=2);for(let y=i.length-1;y>=a;--y){const M=i.charCodeAt(y);if(f(M)){if(!w){p=y+1;break}continue}b===-1&&(w=!1,b=y+1),M===v?d===-1?d=y:R!==1&&(R=1):d!==-1&&(R=-1)}return d===-1||b===-1||R===0||R===1&&d===b-1&&d===p+1?"":i.slice(d,b)},format:S.bind(null,"\\"),parse(i){u(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const d=i.length;let p=0,b=i.charCodeAt(0);if(d===1)return f(b)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(f(b)){if(p=1,f(i.charCodeAt(1))){let k=2,q=k;for(;k<d&&!f(i.charCodeAt(k));)k++;if(k<d&&k!==q){for(q=k;k<d&&f(i.charCodeAt(k));)k++;if(k<d&&k!==q){for(q=k;k<d&&!f(i.charCodeAt(k));)k++;k===d?p=k:k!==q&&(p=k+1)}}}}else if(_(b)&&i.charCodeAt(1)===L){if(d<=2)return a.root=a.dir=i,a;if(p=2,f(i.charCodeAt(2))){if(d===3)return a.root=a.dir=i,a;p=3}}p>0&&(a.root=i.slice(0,p));let w=-1,R=p,y=-1,M=!0,D=i.length-1,T=0;for(;D>=p;--D){if(b=i.charCodeAt(D),f(b)){if(!M){R=D+1;break}continue}y===-1&&(M=!1,y=D+1),b===v?w===-1?w=D:T!==1&&(T=1):w!==-1&&(T=-1)}return y!==-1&&(w===-1||T===0||T===1&&w===y-1&&w===R+1?a.base=a.name=i.slice(R,y):(a.name=i.slice(R,w),a.base=i.slice(R,y),a.ext=i.slice(w,y))),R>0&&R!==p?a.dir=i.slice(0,R-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(g){const i=/\\/g;return()=>{const a=r.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>r.cwd()})();n.posix={resolve(...i){let a="",d=!1;for(let p=i.length-1;p>=-1&&!d;p--){const b=p>=0?i[p]:C();u(b,"path"),b.length!==0&&(a=`${b}/${a}`,d=b.charCodeAt(0)===h)}return a=N(a,!d,"/",E),d?`/${a}`:a.length>0?a:"."},normalize(i){if(u(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===h,d=i.charCodeAt(i.length-1)===h;return i=N(i,!a,"/",E),i.length===0?a?"/":d?"./":".":(d&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return u(i,"path"),i.length>0&&i.charCodeAt(0)===h},join(...i){if(i.length===0)return".";let a;for(let d=0;d<i.length;++d){const p=i[d];u(p,"path"),p.length>0&&(a===void 0?a=p:a+=`/${p}`)}return a===void 0?".":n.posix.normalize(a)},relative(i,a){if(u(i,"from"),u(a,"to"),i===a||(i=n.posix.resolve(i),a=n.posix.resolve(a),i===a))return"";const d=1,p=i.length,b=p-d,w=1,R=a.length-w,y=b<R?b:R;let M=-1,D=0;for(;D<y;D++){const k=i.charCodeAt(d+D);if(k!==a.charCodeAt(w+D))break;k===h&&(M=D)}if(D===y)if(R>y){if(a.charCodeAt(w+D)===h)return a.slice(w+D+1);if(D===0)return a.slice(w+D)}else b>y&&(i.charCodeAt(d+D)===h?M=D:D===0&&(M=0));let T="";for(D=d+M+1;D<=p;++D)(D===p||i.charCodeAt(D)===h)&&(T+=T.length===0?"..":"/..");return`${T}${a.slice(w+M)}`},toNamespacedPath(i){return i},dirname(i){if(u(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===h;let d=-1,p=!0;for(let b=i.length-1;b>=1;--b)if(i.charCodeAt(b)===h){if(!p){d=b;break}}else p=!1;return d===-1?a?"/":".":a&&d===1?"//":i.slice(0,d)},basename(i,a){a!==void 0&&u(a,"ext"),u(i,"path");let d=0,p=-1,b=!0,w;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let R=a.length-1,y=-1;for(w=i.length-1;w>=0;--w){const M=i.charCodeAt(w);if(M===h){if(!b){d=w+1;break}}else y===-1&&(b=!1,y=w+1),R>=0&&(M===a.charCodeAt(R)?--R===-1&&(p=w):(R=-1,p=y))}return d===p?p=y:p===-1&&(p=i.length),i.slice(d,p)}for(w=i.length-1;w>=0;--w)if(i.charCodeAt(w)===h){if(!b){d=w+1;break}}else p===-1&&(b=!1,p=w+1);return p===-1?"":i.slice(d,p)},extname(i){u(i,"path");let a=-1,d=0,p=-1,b=!0,w=0;for(let R=i.length-1;R>=0;--R){const y=i.charCodeAt(R);if(y===h){if(!b){d=R+1;break}continue}p===-1&&(b=!1,p=R+1),y===v?a===-1?a=R:w!==1&&(w=1):a!==-1&&(w=-1)}return a===-1||p===-1||w===0||w===1&&a===p-1&&a===d+1?"":i.slice(a,p)},format:S.bind(null,"/"),parse(i){u(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const d=i.charCodeAt(0)===h;let p;d?(a.root="/",p=1):p=0;let b=-1,w=0,R=-1,y=!0,M=i.length-1,D=0;for(;M>=p;--M){const T=i.charCodeAt(M);if(T===h){if(!y){w=M+1;break}continue}R===-1&&(y=!1,R=M+1),T===v?b===-1?b=M:D!==1&&(D=1):b!==-1&&(D=-1)}if(R!==-1){const T=w===0&&d?1:w;b===-1||D===0||D===1&&b===R-1&&b===w+1?a.base=a.name=i.slice(T,R):(a.name=i.slice(T,b),a.base=i.slice(T,R),a.ext=i.slice(b,R))}return w>0?a.dir=i.slice(0,w-1):d&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=g?n.win32.normalize:n.posix.normalize,n.resolve=g?n.win32.resolve:n.posix.resolve,n.relative=g?n.win32.relative:n.posix.relative,n.dirname=g?n.win32.dirname:n.posix.dirname,n.basename=g?n.win32.basename:n.posix.basename,n.extname=g?n.win32.extname:n.posix.extname,n.sep=g?n.win32.sep:n.posix.sep}),Y(J[18],Z([0,1,65,17]),function(B,n,r,x){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.URI=void 0,n.uriToFsPath=N;const A=/^\w[\w\d+.-]*$/,c=/^\//,m=/^\/\//;function v(d,p){if(!d.scheme&&p)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!A.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!c.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(m.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(d,p){return!d&&!p?"file":d}function l(d,p){switch(d){case"https":case"http":case"file":p?p[0]!==e&&(p=e+p):p=e;break}return p}const L="",e="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class o{static isUri(p){return p instanceof o?!0:p?typeof p.authority=="string"&&typeof p.fragment=="string"&&typeof p.path=="string"&&typeof p.query=="string"&&typeof p.scheme=="string"&&typeof p.fsPath=="string"&&typeof p.with=="function"&&typeof p.toString=="function":!1}constructor(p,b,w,R,y,M=!1){typeof p=="object"?(this.scheme=p.scheme||L,this.authority=p.authority||L,this.path=p.path||L,this.query=p.query||L,this.fragment=p.fragment||L):(this.scheme=h(p,M),this.authority=b||L,this.path=l(this.scheme,w||L),this.query=R||L,this.fragment=y||L,v(this,M))}get fsPath(){return N(this,!1)}with(p){if(!p)return this;let{scheme:b,authority:w,path:R,query:y,fragment:M}=p;return b===void 0?b=this.scheme:b===null&&(b=L),w===void 0?w=this.authority:w===null&&(w=L),R===void 0?R=this.path:R===null&&(R=L),y===void 0?y=this.query:y===null&&(y=L),M===void 0?M=this.fragment:M===null&&(M=L),b===this.scheme&&w===this.authority&&R===this.path&&y===this.query&&M===this.fragment?this:new g(b,w,R,y,M)}static parse(p,b=!1){const w=s.exec(p);return w?new g(w[2]||L,a(w[4]||L),a(w[5]||L),a(w[7]||L),a(w[9]||L),b):new g(L,L,L,L,L)}static file(p){let b=L;if(x.isWindows&&(p=p.replace(/\\/g,e)),p[0]===e&&p[1]===e){const w=p.indexOf(e,2);w===-1?(b=p.substring(2),p=e):(b=p.substring(2,w),p=p.substring(w)||e)}return new g("file",b,p,L,L)}static from(p,b){return new g(p.scheme,p.authority,p.path,p.query,p.fragment,b)}static joinPath(p,...b){if(!p.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return x.isWindows&&p.scheme==="file"?w=o.file(r.win32.join(N(p,!0),...b)).path:w=r.posix.join(p.path,...b),p.with({path:w})}toString(p=!1){return S(this,p)}toJSON(){return this}static revive(p){var b,w;if(p){if(p instanceof o)return p;{const R=new g(p);return R._formatted=(b=p.external)!==null&&b!==void 0?b:null,R._fsPath=p._sep===u&&(w=p.fsPath)!==null&&w!==void 0?w:null,R}}else return p}}n.URI=o;const u=x.isWindows?1:void 0;class g extends o{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=N(this,!1)),this._fsPath}toString(p=!1){return p?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const p={$mid:1};return this._fsPath&&(p.fsPath=this._fsPath,p._sep=u),this._formatted&&(p.external=this._formatted),this.path&&(p.path=this.path),this.scheme&&(p.scheme=this.scheme),this.authority&&(p.authority=this.authority),this.query&&(p.query=this.query),this.fragment&&(p.fragment=this.fragment),p}}const f={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function E(d,p,b){let w,R=-1;for(let y=0;y<d.length;y++){const M=d.charCodeAt(y);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||p&&M===47||b&&M===91||b&&M===93||b&&M===58)R!==-1&&(w+=encodeURIComponent(d.substring(R,y)),R=-1),w!==void 0&&(w+=d.charAt(y));else{w===void 0&&(w=d.substr(0,y));const D=f[M];D!==void 0?(R!==-1&&(w+=encodeURIComponent(d.substring(R,y)),R=-1),w+=D):R===-1&&(R=y)}}return R!==-1&&(w+=encodeURIComponent(d.substring(R))),w!==void 0?w:d}function _(d){let p;for(let b=0;b<d.length;b++){const w=d.charCodeAt(b);w===35||w===63?(p===void 0&&(p=d.substr(0,b)),p+=f[w]):p!==void 0&&(p+=d[b])}return p!==void 0?p:d}function N(d,p){let b;return d.authority&&d.path.length>1&&d.scheme==="file"?b=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?p?b=d.path.substr(1):b=d.path[1].toLowerCase()+d.path.substr(2):b=d.path,x.isWindows&&(b=b.replace(/\//g,"\\")),b}function S(d,p){const b=p?_:E;let w="",{scheme:R,authority:y,path:M,query:D,fragment:T}=d;if(R&&(w+=R,w+=":"),(y||R==="file")&&(w+=e,w+=e),y){let k=y.indexOf("@");if(k!==-1){const q=y.substr(0,k);y=y.substr(k+1),k=q.lastIndexOf(":"),k===-1?w+=b(q,!1,!1):(w+=b(q.substr(0,k),!1,!1),w+=":",w+=b(q.substr(k+1),!1,!0)),w+="@"}y=y.toLowerCase(),k=y.lastIndexOf(":"),k===-1?w+=b(y,!1,!0):(w+=b(y.substr(0,k),!1,!0),w+=y.substr(k))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const k=M.charCodeAt(1);k>=65&&k<=90&&(M=`/${String.fromCharCode(k+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const k=M.charCodeAt(0);k>=65&&k<=90&&(M=`${String.fromCharCode(k+32)}:${M.substr(2)}`)}w+=b(M,!0,!1)}return D&&(w+="?",w+=b(D,!1,!1)),T&&(w+="#",w+=p?T:E(T,!1,!1)),w}function C(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+C(d.substr(3)):d}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(d){return d.match(i)?d.replace(i,p=>C(p)):d}}),Y(J[69],Z([0,1,5,9,13,14,17,6]),function(B,n,r,x,A,c,m,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SimpleWorkerServer=n.SimpleWorkerClient=void 0,n.logOnceWebWorkerWarning=L,n.create=i;const h="$initialize";let l=!1;function L(a){m.isWeb&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(a.message))}class e{constructor(d,p,b,w){this.vsWorker=d,this.req=p,this.method=b,this.args=w,this.type=0}}class s{constructor(d,p,b,w){this.vsWorker=d,this.seq=p,this.res=b,this.err=w,this.type=1}}class o{constructor(d,p,b,w){this.vsWorker=d,this.req=p,this.eventName=b,this.arg=w,this.type=2}}class u{constructor(d,p,b){this.vsWorker=d,this.req=p,this.event=b,this.type=3}}class g{constructor(d,p){this.vsWorker=d,this.req=p,this.type=4}}class f{constructor(d){this._workerId=-1,this._handler=d,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(d){this._workerId=d}sendMessage(d,p){const b=String(++this._lastSentReq);return new Promise((w,R)=>{this._pendingReplies[b]={resolve:w,reject:R},this._send(new e(this._workerId,b,d,p))})}listen(d,p){let b=null;const w=new x.Emitter({onWillAddFirstListener:()=>{b=String(++this._lastSentReq),this._pendingEmitters.set(b,w),this._send(new o(this._workerId,b,d,p))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(b),this._send(new g(this._workerId,b)),b=null}});return w.event}handleMessage(d){!d||!d.vsWorker||this._workerId!==-1&&d.vsWorker!==this._workerId||this._handleMessage(d)}_handleMessage(d){switch(d.type){case 1:return this._handleReplyMessage(d);case 0:return this._handleRequestMessage(d);case 2:return this._handleSubscribeEventMessage(d);case 3:return this._handleEventMessage(d);case 4:return this._handleUnsubscribeEventMessage(d)}}_handleReplyMessage(d){if(!this._pendingReplies[d.seq]){console.warn("Got reply to unknown seq");return}const p=this._pendingReplies[d.seq];if(delete this._pendingReplies[d.seq],d.err){let b=d.err;d.err.$isError&&(b=new Error,b.name=d.err.name,b.message=d.err.message,b.stack=d.err.stack),p.reject(b);return}p.resolve(d.res)}_handleRequestMessage(d){const p=d.req;this._handler.handleMessage(d.method,d.args).then(w=>{this._send(new s(this._workerId,p,w,void 0))},w=>{w.detail instanceof Error&&(w.detail=(0,r.transformErrorForSerialization)(w.detail)),this._send(new s(this._workerId,p,void 0,(0,r.transformErrorForSerialization)(w)))})}_handleSubscribeEventMessage(d){const p=d.req,b=this._handler.handleEvent(d.eventName,d.arg)(w=>{this._send(new u(this._workerId,p,w))});this._pendingEvents.set(p,b)}_handleEventMessage(d){if(!this._pendingEmitters.has(d.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(d.req).fire(d.event)}_handleUnsubscribeEventMessage(d){if(!this._pendingEvents.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(d.req).dispose(),this._pendingEvents.delete(d.req)}_send(d){const p=[];if(d.type===0)for(let b=0;b<d.args.length;b++)d.args[b]instanceof ArrayBuffer&&p.push(d.args[b]);else d.type===1&&d.res instanceof ArrayBuffer&&p.push(d.res);this._handler.sendMessage(d,p)}}class E extends A.Disposable{constructor(d,p,b){super();let w=null;this._worker=this._register(d.create("vs/base/common/worker/simpleWorker",k=>{this._protocol.handleMessage(k)},k=>{w?.(k)})),this._protocol=new f({sendMessage:(k,q)=>{this._worker.postMessage(k,q)},handleMessage:(k,q)=>{if(typeof b[k]!="function")return Promise.reject(new Error("Missing method "+k+" on main thread host."));try{return Promise.resolve(b[k].apply(b,q))}catch(H){return Promise.reject(H)}},handleEvent:(k,q)=>{if(N(k)){const H=b[k].call(b,q);if(typeof H!="function")throw new Error(`Missing dynamic event ${k} on main thread host.`);return H}if(_(k)){const H=b[k];if(typeof H!="function")throw new Error(`Missing event ${k} on main thread host.`);return H}throw new Error(`Malformed event name ${k}`)}}),this._protocol.setWorkerId(this._worker.getId());let R=null;const y=globalThis.require;typeof y<"u"&&typeof y.getConfig=="function"?R=y.getConfig():typeof globalThis.requirejs<"u"&&(R=globalThis.requirejs.s.contexts._.config);const M=(0,c.getAllMethodNames)(b);this._onModuleLoaded=this._protocol.sendMessage(h,[this._worker.getId(),JSON.parse(JSON.stringify(R)),p,M]);const D=(k,q)=>this._request(k,q),T=(k,q)=>this._protocol.listen(k,q);this._lazyProxy=new Promise((k,q)=>{w=q,this._onModuleLoaded.then(H=>{k(S(H,D,T))},H=>{q(H),this._onError("Worker failed to load "+p,H)})})}getProxyObject(){return this._lazyProxy}_request(d,p){return new Promise((b,w)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(d,p).then(b,w)},w)})}_onError(d,p){console.error(d),console.info(p)}}n.SimpleWorkerClient=E;function _(a){return a[0]==="o"&&a[1]==="n"&&v.isUpperAsciiLetter(a.charCodeAt(2))}function N(a){return/^onDynamic/.test(a)&&v.isUpperAsciiLetter(a.charCodeAt(9))}function S(a,d,p){const b=y=>function(){const M=Array.prototype.slice.call(arguments,0);return d(y,M)},w=y=>function(M){return p(y,M)},R={};for(const y of a){if(N(y)){R[y]=w(y);continue}if(_(y)){R[y]=p(y,void 0);continue}R[y]=b(y)}return R}class C{constructor(d,p){this._requestHandlerFactory=p,this._requestHandler=null,this._protocol=new f({sendMessage:(b,w)=>{d(b,w)},handleMessage:(b,w)=>this._handleMessage(b,w),handleEvent:(b,w)=>this._handleEvent(b,w)})}onmessage(d){this._protocol.handleMessage(d)}_handleMessage(d,p){if(d===h)return this.initialize(p[0],p[1],p[2],p[3]);if(!this._requestHandler||typeof this._requestHandler[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this._requestHandler[d].apply(this._requestHandler,p))}catch(b){return Promise.reject(b)}}_handleEvent(d,p){if(!this._requestHandler)throw new Error("Missing requestHandler");if(N(d)){const b=this._requestHandler[d].call(this._requestHandler,p);if(typeof b!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return b}if(_(d)){const b=this._requestHandler[d];if(typeof b!="function")throw new Error(`Missing event ${d} on request handler.`);return b}throw new Error(`Malformed event name ${d}`)}initialize(d,p,b,w){this._protocol.setWorkerId(d);const M=S(w,(D,T)=>this._protocol.sendMessage(D,T),(D,T)=>this._protocol.listen(D,T));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(M),Promise.resolve((0,c.getAllMethodNames)(this._requestHandler))):(p&&(typeof p.baseUrl<"u"&&delete p.baseUrl,typeof p.paths<"u"&&typeof p.paths.vs<"u"&&delete p.paths.vs,typeof p.trustedTypesPolicy<"u"&&delete p.trustedTypesPolicy,p.catchError=!0,globalThis.require.config(p)),new Promise((D,T)=>{(globalThis.require||B)([b],q=>{if(this._requestHandler=q.create(M),!this._requestHandler){T(new Error("No RequestHandler!"));return}D((0,c.getAllMethodNames)(this._requestHandler))},T)}))}}n.SimpleWorkerServer=C;function i(a){return new C(a,null)}}),Y(J[66],Z([19,63]),function(B,n){return B.create("vs/editor/common/languages",n)}),Y(J[67],Z([0,1,42,18,2,61,66]),function(B,n,r,x,A,c,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.InlineEditTriggerKind=n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.NewSymbolNameTag=n.FoldingRangeKind=n.TextEdit=n.SymbolKinds=n.symbolKindNames=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.DocumentPasteTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0,n.isLocationLink=f,n.getAriaLabelForSymbol=E;class v{constructor(w,R,y){this.offset=w,this.type=R,this.language=y,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=v;class h{constructor(w,R){this.tokens=w,this.endState=R,this._tokenizationResultBrand=void 0}}n.TokenizationResult=h;class l{constructor(w,R){this.tokens=w,this.endState=R,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=l;var L;(function(b){const w=new Map;w.set(0,r.Codicon.symbolMethod),w.set(1,r.Codicon.symbolFunction),w.set(2,r.Codicon.symbolConstructor),w.set(3,r.Codicon.symbolField),w.set(4,r.Codicon.symbolVariable),w.set(5,r.Codicon.symbolClass),w.set(6,r.Codicon.symbolStruct),w.set(7,r.Codicon.symbolInterface),w.set(8,r.Codicon.symbolModule),w.set(9,r.Codicon.symbolProperty),w.set(10,r.Codicon.symbolEvent),w.set(11,r.Codicon.symbolOperator),w.set(12,r.Codicon.symbolUnit),w.set(13,r.Codicon.symbolValue),w.set(15,r.Codicon.symbolEnum),w.set(14,r.Codicon.symbolConstant),w.set(15,r.Codicon.symbolEnum),w.set(16,r.Codicon.symbolEnumMember),w.set(17,r.Codicon.symbolKeyword),w.set(27,r.Codicon.symbolSnippet),w.set(18,r.Codicon.symbolText),w.set(19,r.Codicon.symbolColor),w.set(20,r.Codicon.symbolFile),w.set(21,r.Codicon.symbolReference),w.set(22,r.Codicon.symbolCustomColor),w.set(23,r.Codicon.symbolFolder),w.set(24,r.Codicon.symbolTypeParameter),w.set(25,r.Codicon.account),w.set(26,r.Codicon.issues);function R(D){let T=w.get(D);return T||(console.info("No codicon found for CompletionItemKind "+D),T=r.Codicon.symbolProperty),T}b.toIcon=R;const y=new Map;y.set("method",0),y.set("function",1),y.set("constructor",2),y.set("field",3),y.set("variable",4),y.set("class",5),y.set("struct",6),y.set("interface",7),y.set("module",8),y.set("property",9),y.set("event",10),y.set("operator",11),y.set("unit",12),y.set("value",13),y.set("constant",14),y.set("enum",15),y.set("enum-member",16),y.set("enumMember",16),y.set("keyword",17),y.set("snippet",27),y.set("text",18),y.set("color",19),y.set("file",20),y.set("reference",21),y.set("customcolor",22),y.set("folder",23),y.set("type-parameter",24),y.set("typeParameter",24),y.set("account",25),y.set("issue",26);function M(D,T){let k=y.get(D);return typeof k>"u"&&!T&&(k=9),k}b.fromString=M})(L||(n.CompletionItemKinds=L={}));var e;(function(b){b[b.Automatic=0]="Automatic",b[b.Explicit=1]="Explicit"})(e||(n.InlineCompletionTriggerKind=e={}));class s{constructor(w,R,y,M){this.range=w,this.text=R,this.completionKind=y,this.isSnippetText=M}equals(w){return A.Range.lift(this.range).equalsRange(w.range)&&this.text===w.text&&this.completionKind===w.completionKind&&this.isSnippetText===w.isSnippetText}}n.SelectedSuggestionInfo=s;var o;(function(b){b[b.Automatic=0]="Automatic",b[b.PasteAs=1]="PasteAs"})(o||(n.DocumentPasteTriggerKind=o={}));var u;(function(b){b[b.Invoke=1]="Invoke",b[b.TriggerCharacter=2]="TriggerCharacter",b[b.ContentChange=3]="ContentChange"})(u||(n.SignatureHelpTriggerKind=u={}));var g;(function(b){b[b.Text=0]="Text",b[b.Read=1]="Read",b[b.Write=2]="Write"})(g||(n.DocumentHighlightKind=g={}));function f(b){return b&&x.URI.isUri(b.uri)&&A.Range.isIRange(b.range)&&(A.Range.isIRange(b.originSelectionRange)||A.Range.isIRange(b.targetSelectionRange))}n.symbolKindNames={17:(0,m.localize)(0,null),16:(0,m.localize)(1,null),4:(0,m.localize)(2,null),13:(0,m.localize)(3,null),8:(0,m.localize)(4,null),9:(0,m.localize)(5,null),21:(0,m.localize)(6,null),23:(0,m.localize)(7,null),7:(0,m.localize)(8,null),0:(0,m.localize)(9,null),11:(0,m.localize)(10,null),10:(0,m.localize)(11,null),19:(0,m.localize)(12,null),5:(0,m.localize)(13,null),1:(0,m.localize)(14,null),2:(0,m.localize)(15,null),20:(0,m.localize)(16,null),15:(0,m.localize)(17,null),18:(0,m.localize)(18,null),24:(0,m.localize)(19,null),3:(0,m.localize)(20,null),6:(0,m.localize)(21,null),14:(0,m.localize)(22,null),22:(0,m.localize)(23,null),25:(0,m.localize)(24,null),12:(0,m.localize)(25,null)};function E(b,w){return(0,m.localize)(26,null,b,n.symbolKindNames[w])}var _;(function(b){const w=new Map;w.set(0,r.Codicon.symbolFile),w.set(1,r.Codicon.symbolModule),w.set(2,r.Codicon.symbolNamespace),w.set(3,r.Codicon.symbolPackage),w.set(4,r.Codicon.symbolClass),w.set(5,r.Codicon.symbolMethod),w.set(6,r.Codicon.symbolProperty),w.set(7,r.Codicon.symbolField),w.set(8,r.Codicon.symbolConstructor),w.set(9,r.Codicon.symbolEnum),w.set(10,r.Codicon.symbolInterface),w.set(11,r.Codicon.symbolFunction),w.set(12,r.Codicon.symbolVariable),w.set(13,r.Codicon.symbolConstant),w.set(14,r.Codicon.symbolString),w.set(15,r.Codicon.symbolNumber),w.set(16,r.Codicon.symbolBoolean),w.set(17,r.Codicon.symbolArray),w.set(18,r.Codicon.symbolObject),w.set(19,r.Codicon.symbolKey),w.set(20,r.Codicon.symbolNull),w.set(21,r.Codicon.symbolEnumMember),w.set(22,r.Codicon.symbolStruct),w.set(23,r.Codicon.symbolEvent),w.set(24,r.Codicon.symbolOperator),w.set(25,r.Codicon.symbolTypeParameter);function R(y){let M=w.get(y);return M||(console.info("No codicon found for SymbolKind "+y),M=r.Codicon.symbolProperty),M}b.toIcon=R})(_||(n.SymbolKinds=_={}));class N{}n.TextEdit=N;class S{static fromValue(w){switch(w){case"comment":return S.Comment;case"imports":return S.Imports;case"region":return S.Region}return new S(w)}constructor(w){this.value=w}}n.FoldingRangeKind=S,S.Comment=new S("comment"),S.Imports=new S("imports"),S.Region=new S("region");var C;(function(b){b[b.AIGenerated=1]="AIGenerated"})(C||(n.NewSymbolNameTag=C={}));var i;(function(b){function w(R){return!R||typeof R!="object"?!1:typeof R.id=="string"&&typeof R.title=="string"}b.is=w})(i||(n.Command=i={}));var a;(function(b){b[b.Type=1]="Type",b[b.Parameter=2]="Parameter"})(a||(n.InlayHintKind=a={}));class d{constructor(w){this.createSupport=w,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(w=>{w&&w.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=d,n.TokenizationRegistry=new c.TokenizationRegistry;var p;(function(b){b[b.Invoke=0]="Invoke",b[b.Automatic=1]="Automatic"})(p||(n.InlineEditTriggerKind=p={}))}),Y(J[68],Z([0,1,39,9,36,18,4,2,43,67,60]),function(B,n,r,x,A,c,m,v,h,l,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyMod=void 0,n.createMonacoBaseAPI=s;class e{static chord(u,g){return(0,A.KeyChord)(u,g)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function s(){return{editor:void 0,languages:void 0,CancellationTokenSource:r.CancellationTokenSource,Emitter:x.Emitter,KeyCode:L.KeyCode,KeyMod:e,Position:m.Position,Range:v.Range,Selection:h.Selection,SelectionDirection:L.SelectionDirection,MarkerSeverity:L.MarkerSeverity,MarkerTag:L.MarkerTag,Uri:c.URI,Token:l.Token}}}),Y(J[70],Z([0,1,24,18,4,2,57,29,53,54,68,23,59,51,14,52]),function(B,n,r,x,A,c,m,v,h,l,L,e,s,o,u,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.EditorSimpleWorker=void 0,n.create=_;class f extends m.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(S){const C=[];for(let i=0;i<this._lines.length;i++){const a=this._lines[i],d=this.offsetAt(new A.Position(i+1,1)),p=a.matchAll(S);for(const b of p)(b.index||b.index===0)&&(b.index=b.index+d),C.push(b)}return C}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(S){return this._lines[S-1]}getWordAtPosition(S,C){const i=(0,v.getWordAtText)(S.column,(0,v.ensureValidWordDefinition)(C),this._lines[S.lineNumber-1],0);return i?new c.Range(S.lineNumber,i.startColumn,S.lineNumber,i.endColumn):null}words(S){const C=this._lines,i=this._wordenize.bind(this);let a=0,d="",p=0,b=[];return{*[Symbol.iterator](){for(;;)if(p<b.length){const w=d.substring(b[p].start,b[p].end);p+=1,yield w}else if(a<C.length)d=C[a],b=i(d,S),p=0,a+=1;else break}}}getLineWords(S,C){const i=this._lines[S-1],a=this._wordenize(i,C),d=[];for(const p of a)d.push({word:i.substring(p.start,p.end),startColumn:p.start+1,endColumn:p.end+1});return d}_wordenize(S,C){const i=[];let a;for(C.lastIndex=0;(a=C.exec(S))&&a[0].length!==0;)i.push({start:a.index,end:a.index+a[0].length});return i}getValueInRange(S){if(S=this._validateRange(S),S.startLineNumber===S.endLineNumber)return this._lines[S.startLineNumber-1].substring(S.startColumn-1,S.endColumn-1);const C=this._eol,i=S.startLineNumber-1,a=S.endLineNumber-1,d=[];d.push(this._lines[i].substring(S.startColumn-1));for(let p=i+1;p<a;p++)d.push(this._lines[p]);return d.push(this._lines[a].substring(0,S.endColumn-1)),d.join(C)}offsetAt(S){return S=this._validatePosition(S),this._ensureLineStarts(),this._lineStarts.getPrefixSum(S.lineNumber-2)+(S.column-1)}positionAt(S){S=Math.floor(S),S=Math.max(0,S),this._ensureLineStarts();const C=this._lineStarts.getIndexOf(S),i=this._lines[C.index].length;return{lineNumber:1+C.index,column:1+Math.min(C.remainder,i)}}_validateRange(S){const C=this._validatePosition({lineNumber:S.startLineNumber,column:S.startColumn}),i=this._validatePosition({lineNumber:S.endLineNumber,column:S.endColumn});return C.lineNumber!==S.startLineNumber||C.column!==S.startColumn||i.lineNumber!==S.endLineNumber||i.column!==S.endColumn?{startLineNumber:C.lineNumber,startColumn:C.column,endLineNumber:i.lineNumber,endColumn:i.column}:S}_validatePosition(S){if(!A.Position.isIPosition(S))throw new Error("bad position");let{lineNumber:C,column:i}=S,a=!1;if(C<1)C=1,i=1,a=!0;else if(C>this._lines.length)C=this._lines.length,i=this._lines[C-1].length+1,a=!0;else{const d=this._lines[C-1].length+1;i<1?(i=1,a=!0):i>d&&(i=d,a=!0)}return a?{lineNumber:C,column:i}:S}}class E{constructor(S,C){this._host=S,this._models=Object.create(null),this._foreignModuleFactory=C,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(S){return this._models[S]}_getModels(){const S=[];return Object.keys(this._models).forEach(C=>S.push(this._models[C])),S}acceptNewModel(S){this._models[S.url]=new f(x.URI.parse(S.url),S.lines,S.EOL,S.versionId)}acceptModelChanged(S,C){if(!this._models[S])return;this._models[S].onEvents(C)}acceptRemovedModel(S){this._models[S]&&delete this._models[S]}async computeUnicodeHighlights(S,C,i){const a=this._getModel(S);return a?s.UnicodeTextModelHighlighter.computeUnicodeHighlights(a,C,i):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(S,C,i,a){const d=this._getModel(S),p=this._getModel(C);return!d||!p?null:E.computeDiff(d,p,i,a)}static computeDiff(S,C,i,a){const d=a==="advanced"?o.linesDiffComputers.getDefault():o.linesDiffComputers.getLegacy(),p=S.getLinesContent(),b=C.getLinesContent(),w=d.computeDiff(p,b,i),R=w.changes.length>0?!1:this._modelsAreIdentical(S,C);function y(M){return M.map(D=>{var T;return[D.original.startLineNumber,D.original.endLineNumberExclusive,D.modified.startLineNumber,D.modified.endLineNumberExclusive,(T=D.innerChanges)===null||T===void 0?void 0:T.map(k=>[k.originalRange.startLineNumber,k.originalRange.startColumn,k.originalRange.endLineNumber,k.originalRange.endColumn,k.modifiedRange.startLineNumber,k.modifiedRange.startColumn,k.modifiedRange.endLineNumber,k.modifiedRange.endColumn])]})}return{identical:R,quitEarly:w.hitTimeout,changes:y(w.changes),moves:w.moves.map(M=>[M.lineRangeMapping.original.startLineNumber,M.lineRangeMapping.original.endLineNumberExclusive,M.lineRangeMapping.modified.startLineNumber,M.lineRangeMapping.modified.endLineNumberExclusive,y(M.changes)])}}static _modelsAreIdentical(S,C){const i=S.getLineCount(),a=C.getLineCount();if(i!==a)return!1;for(let d=1;d<=i;d++){const p=S.getLineContent(d),b=C.getLineContent(d);if(p!==b)return!1}return!0}async computeMoreMinimalEdits(S,C,i){const a=this._getModel(S);if(!a)return C;const d=[];let p;C=C.slice(0).sort((w,R)=>{if(w.range&&R.range)return c.Range.compareRangesUsingStarts(w.range,R.range);const y=w.range?0:1,M=R.range?0:1;return y-M});let b=0;for(let w=1;w<C.length;w++)c.Range.getEndPosition(C[b].range).equals(c.Range.getStartPosition(C[w].range))?(C[b].range=c.Range.fromPositions(c.Range.getStartPosition(C[b].range),c.Range.getEndPosition(C[w].range)),C[b].text+=C[w].text):(b++,C[b]=C[w]);C.length=b+1;for(let{range:w,text:R,eol:y}of C){if(typeof y=="number"&&(p=y),c.Range.isEmpty(w)&&!R)continue;const M=a.getValueInRange(w);if(R=R.replace(/\r\n|\n|\r/g,a.eol),M===R)continue;if(Math.max(R.length,M.length)>E._diffLimit){d.push({range:w,text:R});continue}const D=(0,r.stringDiff)(M,R,i),T=a.offsetAt(c.Range.lift(w).getStartPosition());for(const k of D){const q=a.positionAt(T+k.originalStart),H=a.positionAt(T+k.originalStart+k.originalLength),G={text:R.substr(k.modifiedStart,k.modifiedLength),range:{startLineNumber:q.lineNumber,startColumn:q.column,endLineNumber:H.lineNumber,endColumn:H.column}};a.getValueInRange(G.range)!==G.text&&d.push(G)}}return typeof p=="number"&&d.push({eol:p,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),d}async computeLinks(S){const C=this._getModel(S);return C?(0,h.computeLinks)(C):null}async computeDefaultDocumentColors(S){const C=this._getModel(S);return C?(0,g.computeDefaultDocumentColors)(C):null}async textualSuggest(S,C,i,a){const d=new e.StopWatch,p=new RegExp(i,a),b=new Set;e:for(const w of S){const R=this._getModel(w);if(R){for(const y of R.words(p))if(!(y===C||!isNaN(Number(y)))&&(b.add(y),b.size>E._suggestionsLimit))break e}}return{words:Array.from(b),duration:d.elapsed()}}async computeWordRanges(S,C,i,a){const d=this._getModel(S);if(!d)return Object.create(null);const p=new RegExp(i,a),b=Object.create(null);for(let w=C.startLineNumber;w<C.endLineNumber;w++){const R=d.getLineWords(w,p);for(const y of R){if(!isNaN(Number(y.word)))continue;let M=b[y.word];M||(M=[],b[y.word]=M),M.push({startLineNumber:w,startColumn:y.startColumn,endLineNumber:w,endColumn:y.endColumn})}}return b}async navigateValueSet(S,C,i,a,d){const p=this._getModel(S);if(!p)return null;const b=new RegExp(a,d);C.startColumn===C.endColumn&&(C={startLineNumber:C.startLineNumber,startColumn:C.startColumn,endLineNumber:C.endLineNumber,endColumn:C.endColumn+1});const w=p.getValueInRange(C),R=p.getWordAtPosition({lineNumber:C.startLineNumber,column:C.startColumn},b);if(!R)return null;const y=p.getValueInRange(R);return l.BasicInplaceReplace.INSTANCE.navigateValueSet(C,w,R,y,i)}loadForeignModule(S,C,i){const a=(b,w)=>this._host.fhr(b,w),p={host:(0,u.createProxyObject)(i,a),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(p,C),Promise.resolve((0,u.getAllMethodNames)(this._foreignModule))):new Promise((b,w)=>{B([S],R=>{this._foreignModule=R.create(p,C),b((0,u.getAllMethodNames)(this._foreignModule))},w)})}fmr(S,C){if(!this._foreignModule||typeof this._foreignModule[S]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+S));try{return Promise.resolve(this._foreignModule[S].apply(this._foreignModule,C))}catch(i){return Promise.reject(i)}}}n.EditorSimpleWorker=E,E._diffLimit=1e5,E._suggestionsLimit=1e4;function _(N){return new E(N,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,L.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map